//
//PRIN 2000 : SISTEMI OFDM CON APPLICAZIONI ALLE RETI W-LAN
//PROGETTO M U R S T
//
//
//**********SIMULATORE MAC UL_DL_FDD VERSIONE 1.0 *************** 
//*********UPLINK(ACCESSO MULTIPLO "TDMA"),DOWNLINK**************
//********(ACCESSO MULTIPLO "CDMA"),MULTIPLAZIONE "OFDM"*********
//
//-------------------------------------------
//PROGRAMMATORE:
//
//ANDREA VITALI anvit@libero.it
//
//
//COLLABORATORI:
//
//ING.GUERINO GIANCOLA kubika@libero.it
//ANTONELLA DE LUCA antonellad@infinito.it
//FRANCESCO PASSI f.passi@libero.it
//-------------------------------------------
//
//
#include<iostream.h>
#include<stddef.h>                              
#include<stdio.h>                               
#include<stdlib.h>                               
#include<time.h>
#include<math.h>
#include<float.h>
#include<malloc.h>
//#include"parameter.h"

//ABBIAMO 3 CLASSI DI SERVIZI PER CIASCUNA DEI 3 TIPI DI SORGENTE
#define CLASSI_SERVIZI 9

//NUMERO DI RADIO TERMINAL CHE COLLOQUIANO CON IL RADIO NODE
#define NRT 10

//NUMERO DI CODICI UTILIZZATI
#define K 52 

//NUMERO DI TIME-SLOT DI UNA TRAMA
#define NTS_UL 312               //IPOTESI DI LAVORO:IL RAPPORTO TRA IL NUMERO DI TS IN UL E QUELLO DEI TS IN DL
#define NTS_DL 6                 //DEVE ESSERE UN INTERO E PARI AL RAPPORTO TRA LA DURATA DEL TS IN DL E QUELLA
                                 //DEL TS IN UL.LA TRAMA HA LA STESSA DURATA NEI DUE VERSI.
//DURATA DEL TS
#define DURATA_TS_UL 0.0000288 // secondi
#define DURATA_TS_DL 0.0015 // secondi
 
// scarto in TS tra l'emissione di una richiesta e la ricezione dell'allocazione
#define RIALLOCAZIONE_UL 2
#define RIALLOCAZIONE_DL 3

//IL  MASSIMO NUMERO DI TRAME E' STATO SCELTO PER AVERE UNA DURATA DI
//SIMULAZIONE PARI AD 1 ora
#define MAX_NUM_TRAME 400000

//CARATTERIZZAZIONE DEI PARAMETRI DELLE SORGENTI
#define NCLASSI 3   //numero di sottoclassi che si decide di implementare
                    // Se si cambia aquesto numero, va cambiato anche nel
                    // programma che genera i files
                    
// PAYLOAD DELLA MAC PDU
#define PAYLOAD 78

// OVERHEAD DELLA MAC PDU     // 96 BYTES TOTALI PER UNA MAC-PDU
#define OVERHEAD 12

// PAYLOAD DELLA AL PDU
#define PAYLOAD_AL 72

// OVERHEAD DELLA AL PDU e' comprensivo di HEADER e di FEC(3 bytes)
#define OVERHEAD_AL 6

//MAC PDU UTILIZZATE PER LA SEGNALAZIONE IN UL
#define SEGNALAZIONE_UL 1
#define SEGNALAZIONE_DL 2

//POSIZIONE DEL PAGING CHANNEL NELLA MATRICE DEI CODICI
#define POSIZIONE_PAG_CH 4

// MAX RITARDO IN TS CHE IMMAGINIAMO POSSIBILE NEL SISTEMA
// IL VALORE ANDRA' TARATO IN BASE AI RISULTATI DELLE SIMULAZIONI
#define MAX_RITARDO_TS_UL 1000
#define MAX_RITARDO_TS_DL 500

#define CAPIENZA_BUFFER 1000
#define percentuale 0.9

//*************************************************************************************
//*************************************************************************************
//            SEZIONE RISERVATA ALLE DICHIARAZIONI E ALLE STRUTTURE
//*************************************************************************************
//*************************************************************************************

int RAPP=(NTS_UL/NTS_DL);
int L_MACPDU=PAYLOAD+OVERHEAD;
int L_ALPDU=PAYLOAD_AL+OVERHEAD_AL;

int macpdu_trasm_GB_UL=0,macpdu_trasm_BE_UL=0;
int macpdu_trasm_GB_DL=0,macpdu_trasm_BE_DL=0;

//conta le trame simulate
int cont_trame=0;

int INIZIO_ROUND_ROBIN_GB_UL=1,INIZIO_ROUND_ROBIN_BE_UL=1;
int INIZIO_ROUND_ROBIN_GB_DL=1,INIZIO_ROUND_ROBIN_BE_DL=1;


// DEFINIZIONE DELLE MATRICI DELLE SORGENTI
// In queste matrici vengono inseriti i parametri
// delle sorgenti tipo che verranno utilizzate nella simulazione
// I PARAMETRI VERRANNO LETTI DAI FILE:
// sorgentitipo1.dat
// sorgentitipo2.dat
// sorgentitipo3.dat
int MATRICE_TIPO_1 [NCLASSI][5];
int MATRICE_TIPO_2 [NCLASSI][5];
int MATRICE_TIPO_3 [NCLASSI][2];
double VETTORE_RITARDI_TIPO_1_UL[NCLASSI];
double VETTORE_RITARDI_TIPO_2_UL[NCLASSI];
double VETTORE_RITARDI_TIPO_1_DL[NCLASSI];
double VETTORE_RITARDI_TIPO_2_DL[NCLASSI];


// STRUTTURA DELLA MAC-PDU
struct MAC_PDU
{
    double T_GEN;
    double NS_IP;
    double NS_MACPDU;
    int SORGENTE;
    int TIPO_TRAFFICO;
    struct MAC_PDU *NEXT_MACPDU;
};
typedef struct MAC_PDU *BUFFER;
BUFFER CODE_GB_RT[NRT];
BUFFER CODE_BE_RT[NRT];
BUFFER CODE_GB_RN[NRT];
BUFFER CODE_BE_RN[NRT];


//DEFINIAMO LA STRUTTURA DEL MINI-SLOT DEL REQUEST CHANNEL CHE VIENE MESSO
//A DISPOSIZIONE DI OGNI RADIO TERMINAL

struct RECORD_REQUEST_CHANNEL
{
	double LUNG1;
	double LUNG2;
	double BUFFER_VUOTI;
} ;

//
// DEFINIZIONE DEI CANALI DI SEGNALAZIONE
//
//DEFINIAMO LA SINGOLA MAC-PDU CHE VIENE UTILIZZATA COME PARTE DEL REQUEST CHANNEL
//QUESTA MAC-PDU CONTIENE UN CERTO NUMERO DEI MINI-SLOT DEFINITI PRIMA
//DEFINIAMO, IN SOSTANZA, UN VETTORE DI MINI-SLOT
struct RECORD_REQUEST_CHANNEL REQUEST_CHANNEL[NRT];
struct RECORD_REQUEST_CHANNEL STATO_CODE_AL_RN[NRT];


int BANDA_TOTALE_UL=0;
int BANDA_TOTALE_DL=0;
//Capacit netta rappresenta il numero massimo  di MAC-PDU assegnabili per trama
int CAPACITA_NETTA_DL=K*NTS_DL-SEGNALAZIONE_DL;
int CAPACITA_NETTA_UL=NTS_UL-SEGNALAZIONE_UL;

//Capacita' 
int CAPACITA_ALLOCABILE_GB_DL=(int)(ceil)(CAPACITA_NETTA_DL*percentuale);
int CAPACITA_ALLOCABILE_GB_UL=(int)(ceil)(CAPACITA_NETTA_UL*percentuale);
//Capacit totale trame rappresenta il numero massimo di MAC-PDU assegnabili per tutte le trame considerate 
//int CAPACITA_TOT_TRAME=CAPACITA_NETTA_DL*MAX_NUM_TRAME;

//I SEGUENTI VETTORI SERVONO PER TENER CONTO DELLA BANDA ALLOCATA PER OGNI RT SIA QUANDO NASCE UNA 
//SORGENTE LATO RT,SIA QUANDO IN ESSI NASCE UNA SORGENTE SIMMETRICA.
int BANDA_RT_UL[NRT];
int BANDA_RT_DL[NRT];
 

double  INIZIO_ANALISI_DL=1; //al minimo vale 1
double  FINE_ANALISI_DL=MAX_NUM_TRAME;
double  INIZIO_ANALISI_UL=1; //al minimo vale 1
double  FINE_ANALISI_UL=MAX_NUM_TRAME;


//RITARDO MASSIMO DI ACCESSO AL MEZZO
double D_MAX_ACCESSO_DL=2*NTS_DL*DURATA_TS_DL+RIALLOCAZIONE_DL*DURATA_TS_DL;//e' pari a 0.0225
double D_MAX_ACCESSO_UL= 2*NTS_UL*DURATA_TS_UL+RIALLOCAZIONE_UL*DURATA_TS_UL;//e' pari a 0.0225


//Contiene il numero di MACPDU nella coda BE per ogni RT di destinazione
int LUNGHEZZA_CODE_BE_UL[NRT];
int OVERFLOW_BE_HAPPENED_UL[NRT];
int LUNGHEZZA_CODE_BE_DL[NRT];
int OVERFLOW_BE_HAPPENED_DL[NRT];


// DEFINIAMO ADESSO I DUE CANALI CHE UTILIZZA IL RADIO NODE
// NEL DOWNLINK: L'ALLOCATIONAL_CHANNEL E IL PAGING_CHANNEL
// entrambi questi due canali sono individuati da una matrice bidimensionale
// che ha per righe i RADIO TERMINALs e per colonne i TIME SLOTs
// ogni elemento della matrice e' un puntatore alla CODA DEI CODICI
// LA CODA DEI CODICI RAPPRESENTA L'INSIEME DEI CODICI ASSEGNATI O DA ASCOLTARE
// PER UN RADIO TERMINAL E PER UN TIME SLOT

struct CODE
{
 int COD;
 struct CODE *NEXT_COD;
};
typedef struct CODE *pCODE;
pCODE PAGING_CHANNEL[NRT][NTS_DL];



// DEFINIZIONE DELLE STRUTTURE PER LA GENERAZIONE DELL'OUTPUT
// QUESTE STRUTTURE PERMETTONO DI VALUTARE LE PRESTAZIONI DEL MAC
//
// Contatori delle MACPDU che partono dai RADIO TERMINAL verso il RADIO NODE
int CONT_MACPDU_GB_RT[NRT];
int CONT_MACPDU_BE_RT[NRT];
// Contatori delle MACPDU che partono dal RADIO NODE verso i RADIO TERMINAL
int CONT_MACPDU_GB_RN[NRT];
int CONT_MACPDU_BE_RN[NRT];
// Contatori dei pacchetti IPche partono dai RADIO TERMINAL verso il RADIO NODE
int CONT_IP_GB_RT[NRT];
int CONT_IP_BE_RT[NRT];
// Contatori dei pacchetti IP che partono dal RADIO NODE verso i RADIO TERMINAL
int CONT_IP_GB_RN[NRT];
int CONT_IP_BE_RN[NRT];

//DEFINIAMO IL VETTORE NEL QUALE CI SONO LE PERCENTUALI DELLE SORGENTI SIMMETRICHE 
int VECT_PERCENT[CLASSI_SERVIZI];


// DEFINIAMO ADESSO LE STRUTTURE CHE UTILIZZIAMO PER DESCRIVERE LE SORGENTI
// DI TRAFFICO (CHE POSSONO ESSERE DI 3 TIPI)
// TIPO 1: SORGENTI ON-OFF (CLASSE GB)
// TIPO 2: SORGENTI CBR (CLASSE GB)
// TIPO 3: SORGENTI POISSONIANE (CLASSE BE)

// STRUTTURA PER SORGENTI DI TIPO 1 (ON-OFF CLASSE GB)
// queste sorgenti vengono caratterizzate dai seguenti parametri:
// T_ON : durata fissa dell'attivita' della sorgente
// T_OFF : durata fissa del silenzio della sorgente
// RATE_PICCO : ritmo di picco (byte/sec)
// RATE_MEDIO : ritmo medio sostenibile o token rate (byte/sec)
// TBD : token buffer dimension - tolleranza di burst (byte)
// L_IP : lunghezza pacchetto IP (byte)
// BYTE : contatore BYTE emessi
// IDENTIFICATIVO : numero che caratterizza la sorgente nel radio terminal
// BANDA_MAC : numero di MAC-PDU che dobbiamo garantire per trama
// D_MAX : ritardo massimo in secondi ammesso per un pacchetto IP
// TNEXT : tempo di generazione prossimo pacchetto
// PRIMO_MOMENTO : accumula i ritardi subiti dalle MAC_PDU
// SECONDO MOMENTO : accumula i quadrati dei ritardi subiti dalle MAC_PDU
struct SORGENTE_TIPO1
{
       double T_ON;
       double T_OFF;
       int RATE_PICCO;
       int RATE_MEDIO;
       int TBD;
       int L_IP;
       int BYTE;
       int IDENTIFICATIVO;
       int BANDA_MAC;
       double D_MAX;
       double TNEXT;
       double PRIMO_MOMENTO;
       double SECONDO_MOMENTO;
       struct SORGENTE_TIPO1 *NEXT_SORG;
};

// STRUTTURA PER SORGENTI DI TIPO 2 (CBR CLASSE GB)
// queste sorgenti vengono caratterizzate dai seguenti parametri:
// RATE_PICCO : ritmo di picco (byte/sec)
// RATE_MEDIO : ritmo medio sostenibile o token rate (byte/sec)
// TBD : token buffer dimension - tolleranza di burst (byte)
// L_IP : lunghezza pacchetto IP (byte)
// IDENTIFICATIVO : numero che caratterizza la sorgente nel radio terminal
// BANDA_MAC : numero di MAC-PDU che dobbiamo garantire per trama
// D_MAX : ritardo massimo in secondi ammesso per un pacchetto IP
// BYTE : contatore BYTE emessi
// TNEXT : tempo di generazione prossimo pacchetto
// PRIMO_MOMENTO : accumula i ritardi subiti dalle MAC_PDU
// SECONDO MOMENTO : accumula i quadrati dei ritardi subiti dalle MAC_PDU
struct SORGENTE_TIPO2
{
       int RATE_PICCO;
       int RATE_MEDIO;
       int TBD;
       int L_IP;
       int IDENTIFICATIVO;
       int BANDA_MAC;
       double D_MAX;
       double TNEXT;
       double PRIMO_MOMENTO;
       double SECONDO_MOMENTO;
       struct SORGENTE_TIPO2 *NEXT_SORG;
};


// STRUTTURA PER SORGENTI DI TIPO 3 (VBR CLASSE BE)
// queste sorgenti vengono caratterizzate dai seguenti parametri:
// FREQUENZA_MEDIA : frequenza media di interarrivo dei pacchetti IP
// L_IP : lunghezza pacchetto IP (byte)
// BYTE : contatore BYTE emessi
// TNEXT : tempo di generazione prossimo pacchetto
// PRIMO_MOMENTO : accumula i ritardi subiti dalle MAC_PDU
// SECONDO MOMENTO : accumula i quadrati dei ritardi subiti dalle MAC_PDU 
struct SORGENTE_TIPO3
{
    int FREQUENZA_MEDIA;
    int L_IP;
    int IDENTIFICATIVO;
    double TNEXT;
    double PRIMO_MOMENTO;
    double SECONDO_MOMENTO;
    struct SORGENTE_TIPO3 *NEXT_SORG;
};

// VETTORI DI INTERI CHE RACCOLGONO PER OGNI RADIO TERMINAL LA BANDA GARANTITA
// DELLE SUE SORGENTI GB
int BANDE_TOTALI_MAC_UL[NRT];  
int BANDE_TOTALI_MAC_DL[NRT];


// DEFINIAMO I PUNTATORI ALLE STRUTTURE DI SORGENTI
typedef struct SORGENTE_TIPO1 *pTIPO_1;
typedef struct SORGENTE_TIPO2 *pTIPO_2;
typedef struct SORGENTE_TIPO3 *pTIPO_3;

struct SORG_123
{
        pTIPO_1  T1;
        pTIPO_2  T2;
        pTIPO_3  T3;
        int S_ID;
};

// VETTORI CHE RACCOLGONO LE SORGENTI
// OGNI ELEMENTO DEI VETTORE CORRISPONDE AD UN RADIO TERMINAL
struct SORG_123 VETTORE_SORGENTI_RT_UL[NRT];
struct SORG_123 VETTORE_SORGENTI_RT_DL[NRT];


// PER QUANTO RIGUARDA IL CANALE DI ALLOCAZIONE "ALLOCATIONAL CHANNEL"
// PER L'UPLINK DEFINIAMO UN VETTORE DI PUNTATORI,TANTI QUANTI SONO I RT,
// CHE PUNTANO A RECORD COSTITUITI DA UN CAMPO "INTERO",CHE CONTIENE IL TS 
// IN CUI SI DOVRA' TRASMETTERE,E DA UN CAMPO "PUNTATORE"
// DEFINIAMO IL RECORD PUNTATO DAGLI ELEMENTI DELLA LISTA

struct RECORD_TS
{ 
       int TS;
       struct RECORD_TS *NEXT_TS;
       
};          	


// DEFINIAMO IL PUNTATORE CHE UTLIZZIAMO PER CREARE LA LISTA E PUNTARE I RECORD
typedef struct RECORD_TS *pTS;



// DEFINIAMO LA LISTA CHE PER OGNI RT CONTIENE I TS NEI QUALI SI DEVE TRASMETTERE
pTS LISTA_ALL_CH_UL[NRT];


//DEFINISCO UN VETTORE,DI DIMENSIONE PARI AL NUMERO DI TS,DI RECORD CHE DEVO POI INIZIALIZZARE
//SINGOLO ELEMENTO DEL VETTORE

struct COPPIA_TIPO_RT
{
 char TIPO;   //"G" per la BANDA GARANTITA,"E" per la BEST EFFORT
 int RT;
};

//DEFINISCO IL VETTORE
struct COPPIA_TIPO_RT VETTORE_TS[NTS_UL];
//MATRICE DEI CODICI
struct COPPIA_TIPO_RT MATRICE_CODICI[K][NTS_DL];
 

// STRUTTURE NECESSARIE PER COSTRUIRE IL VETTORE TRASMISSIONE IN UPLINK
// E LA MATRICE IN DOWNLINK 
struct TX
{
 int GB;
 int BE;
};

struct TX TRASMISSIONE_UL[NRT][NTS_UL]; 
struct TX ASSEGNAZIONE_UL[NRT];
struct TX TRASMISSIONE_DL[NRT][NTS_DL];
struct TX ASSEGNAZIONE_DL[NRT];
struct TX ASSEGNAZIONE_DL_PORTATA[NRT];


//PER OGNI TS DICE QUANTI CODICI SONO IMPEGNATI
int SITUAZIONE_TS_DL[NTS_DL];



// ************************DICHIARAZIONI PER FARE GLI ISTOGRAMMI************************
//
// ISTOGRAMMA DEI RITARDI DELLE MAC PDU PER TUTTO IL TRAFFICO IP* AL RT
// *DIFFERENZA NS TRAFFICO BE RISPETTO A DELLUOMO
//Hyst delay rappresenta quante volte si  verificato un certo numero di TS di ritardo
int hyst_delay_BE_DL[NRT][MAX_RITARDO_TS_DL+1];
int hyst_delay_BE_UL[NRT][MAX_RITARDO_TS_UL+1];

//Normalizza delay BE  numero totale di MAC-PDU BE che sono state trasmesse verso quel RT 
int normalizza_delay_BE_DL[NRT]; 
int normalizza_delay_ON_OFF_DL[NRT];
int normalizza_delay_CBR_DL[NRT];
int normalizza_delay_BE_UL[NRT]; 
int normalizza_delay_ON_OFF_UL[NRT];
int normalizza_delay_CBR_UL[NRT];


//ISTOGRAMMA DEL RIEMPIMENTO DEL BUFFER GB PER CIASCUN RT
//Hyst riempimento rappresenta quante volte c' stato quel numero di MAC-PDU in quel TIME-SLOT
int hyst_riempimento_GB_DL[NRT][CAPIENZA_BUFFER+2];
int hyst_riempimento_GB_UL[NRT][CAPIENZA_BUFFER+2];

//ISTOGRAMMA DEL RIEMPIMENTO DEL BUFFER BE PER CIASCUN RT
int hyst_riempimento_BE_DL[NRT][CAPIENZA_BUFFER+2];
int hyst_riempimento_BE_UL[NRT][CAPIENZA_BUFFER+2];


//Gli istogrammi sono  su base trama, dove la trama  quella che inizia dal PAGING CHANNEL,mentre nel file matrice dei
//codici  rappresentata la matrice dei codici.Quindi nel conteggio della portata bisogna considerare i TS 0,1,2,3 
//della matrice dei codici corrente e i TS 4,5 della matrice dei codici precedente a quella corrente.
//Hyst portata rappresenta quante MAC-PDU sono state assegnate in quella trama

int hyst_portata_ON_OFF_DL[NRT][NTS_DL*K-SEGNALAZIONE_DL+1];
int hyst_portata_CBR_DL[NRT][NTS_DL*K-SEGNALAZIONE_DL+1]; //Dovrebbe venire un DIRAC
int hyst_portata_GB_DL[NRT][NTS_DL*K-SEGNALAZIONE_DL+1];
int hyst_portata_BE_DL[NRT][NTS_DL*K-SEGNALAZIONE_DL+1];
int hyst_portata_ON_OFF_UL[NRT][NTS_UL-SEGNALAZIONE_UL+1];
int hyst_portata_CBR_UL[NRT][NTS_UL-SEGNALAZIONE_UL+1];
int hyst_portata_GB_UL[NRT][NTS_UL-SEGNALAZIONE_UL+1];
int hyst_portata_BE_UL[NRT][NTS_UL-SEGNALAZIONE_UL+1];


//Hyst codice probabile rappresenta quante volte un certo codice  assegnato al particolare RT	
int hyst_CODICE_PROBABILE_GB[NRT][K];
// Normalizza Cod_Probabile conta quanti codici in totale sono stati assegnati per ogni RT, per la classe GB 
int normalizza_COD_PROBABILE_GB[NRT];
int hyst_CODICE_PROBABILE_BE[NRT][K];
// Normalizza Cod_Probabile conta quanti codici in totale sono stati assegnati per ogni RT, per la classe BE 
int normalizza_COD_PROBABILE_BE[NRT];


//ISTOGRAMMA DEI TS ASSEGNATI AD OGNI RT
int hyst_RT_TS[NRT][NTS_UL];


 struct DELAY_MM
 {
    double MIN;
    double MAX;
 };


struct  DELAY_MM DELAY_ON_OFF_DL[NRT];
struct  DELAY_MM DELAY_CBR_DL[NRT];
struct  DELAY_MM DELAY_BE_DL[NRT];
struct  DELAY_MM DELAY_ON_OFF_UL[NRT];
struct  DELAY_MM DELAY_CBR_UL[NRT];
struct  DELAY_MM DELAY_BE_UL[NRT];



  struct appoggio{

	  int ON_OFF;
	  int CBR;
          int GB;
          int BE;
  };

struct appoggio APPOGGIO_PORTATA_UL[NRT];
struct appoggio APPOGGIO_PORTATA_DL[NRT];




//*************************************************************************************
//*************************************************************************************
//            SEZIONE RISERVATA ALLE PROCEDURE DI INIZIALIZZAZIONE
//*************************************************************************************
//*************************************************************************************


//INIZIALIZZIAMO IL VETTORE DELLE PERCENTUALI
void inizializza_percentuali()
{
  VECT_PERCENT[0]=10;
  VECT_PERCENT[1]=10;
  VECT_PERCENT[2]=10;
  VECT_PERCENT[3]=100;
  VECT_PERCENT[4]=6;
  VECT_PERCENT[5]=6;
  VECT_PERCENT[6]=2;
  VECT_PERCENT[7]=2;
  VECT_PERCENT[8]=2;
return;
}


//PROCEDURA DI INIZIALIZZAZIONE DEL REQUEST CHANNEL
void inizializza_REQUEST_CHANNEL_UL()
{
	int i;
	for(i=0;i<NRT;i++)
	{

		REQUEST_CHANNEL[i].LUNG1=0;
		REQUEST_CHANNEL[i].LUNG2=0;
		REQUEST_CHANNEL[i].BUFFER_VUOTI=0;
  //IL REQUEST CHANNEL E' POSTO TUTTO A ZERO
  //NON C'E' NESSUNA RICHIESTA DA PARTE DI NESSUN RADIO TERMINAL

	}
	//printf("\nStruttura del REQUEST CHANNEL inizializzata \n");
	return;
}


void inizializzazione_STATO_CODE_AL_RN()
//funzione di inizializzazione dell'analogo del ReqCh
//in DL
{
	int i;
     for(i=0;i<NRT;i++)
	{
        STATO_CODE_AL_RN[i].LUNG1=0;
        STATO_CODE_AL_RN[i].LUNG2=0;
        STATO_CODE_AL_RN[i].BUFFER_VUOTI=0;
	}	
     //ho inizializzato tutto il stato_code_al_RN a 0
     //printf("\nStruttura del 'stato_code_al_RN' inizializzata \n");
	return;
 }


//PROCEDURA DI INIZIALIZZAZIONE DELl' ALLOCATIONAL CHANNEL
void inizializza_ALLOCATIONAL_CHANNEL()
{
     int i;
     for (i=0;i<NRT;i++)
             LISTA_ALL_CH_UL[i]=NULL;
     //printf("\nStruttura dell'ALLOCATIONAL CHANNEL inizializzata \n");
     return;
}

//PROCEDURA DI INIZIALIZZAZIONE DEL PAGING CHANNEL
void inizializzazione_PAGING_CHANNEL()
{
     int i,j;
     for (i=0;i<NRT;i++)
     {
      for (j=0;j<NTS_DL;j++)
        {
         PAGING_CHANNEL[i][j]=NULL;
        }
      }
//printf("\nStruttura del PAGING CHANNEL inizializzata\n");
     return;
}


//INIZIALIZZIAMO IL VETTORE_TS
void inizializza_VETTORE_TS()
{
        int i;
        for (i=0;i<NTS_UL;i++)
        {
         VETTORE_TS[i].TIPO='A';  //"A" E "-1" VOGLIONO DIRE CHE IL RECORD E' LIBERO,
                                  //CMQ IL CONTROLLO LO FARO' SEMPRE  SU ".RT"
         VETTORE_TS[i].RT=-1;
        }
//IN QUESTO CASO PARTICOLARE INIZIALIZZO A -2 SOLAMENTE IL PRIMO ELEMENTO DEL VETTORE!
// E' QUELLO CHE,DIVISO IN NRT MINI TS,UTILIZZO PER IL REQUEST CHANNEL

        for (i=NTS_UL-RIALLOCAZIONE_UL;i<NTS_UL-RIALLOCAZIONE_UL+SEGNALAZIONE_UL;i++)
        { VETTORE_TS[i].TIPO='Z';    //"Z" E "-2" VOGLIONO DIRE CHE IL RECORD E'
                                     // INTOCCABILE
          VETTORE_TS[i].RT=-2;
        }
        //printf("\nStruttura del Vettore dei TS inizializzata\n");
        
return;
}


// INIZIALIZZAZIONE BUFFER

void inizializza_BUFFER()
{
int temp;
for (temp=0;temp<NRT;temp++)
         {
         CODE_GB_RT[temp]=NULL;
         CODE_BE_RT[temp]=NULL;
         CODE_GB_RN[temp]=NULL;
         CODE_BE_RN[temp]=NULL;
         
         LUNGHEZZA_CODE_BE_DL[temp]=0;
         OVERFLOW_BE_HAPPENED_DL[temp]=0;
         LUNGHEZZA_CODE_BE_UL[temp]=0;
         OVERFLOW_BE_HAPPENED_UL[temp]=0;
         }
//printf("\nBuffer inizializzati \n");
return;
}

//INIZIALIZZAZIONE CONTATORI
void inizializza_CONTATORI()
{
int temp;
for (temp=0;temp<NRT;temp++)
        {
        CONT_MACPDU_GB_RT[temp]=0;
        CONT_MACPDU_BE_RT[temp]=0;
        CONT_MACPDU_GB_RN[temp]=0;
        CONT_MACPDU_BE_RN[temp]=0;
        CONT_IP_GB_RT[temp]=0;
        CONT_IP_BE_RT[temp]=0;
        CONT_IP_GB_RN[temp]=0;
        CONT_IP_BE_RN[temp]=0;
        }
//printf("\nContatori inizializzati \n");
return;
}

// METTE A ZERO I VETTORI CHE CONTENGONO LA BANDA GARANTITA TOTALE PER RT
void inizializza_BANDE_TOTALI_MAC()
{
int i;
for (i=0;i<NRT;i++)
  {
    BANDE_TOTALI_MAC_UL[i]=0;
    BANDE_TOTALI_MAC_DL[i]=0;
  }  
//printf("\nBande totali MAC inizializzate correttamente\n");
return;
}


//PROCEDURA DI INIZIALIZZAZIONE DELLA MATRICE DEI CODICI
void inizializzazione_MATRICE_CODICI()
{
	int i,j;
	//i e j contano rispettivamente i CODICI ed i TIME-SLOT
    for (i=0;i<K;i++)
	{
		for (j=0;j<NTS_DL;j++)
		{
			MATRICE_CODICI[i][j].RT=-1;
			MATRICE_CODICI[i][j].TIPO=-1;

		}
	}
	// Inizializzo entrambe i campi della matrice dei codici a -1
    j=POSIZIONE_PAG_CH;
	for (i=0;i<SEGNALAZIONE_DL;i++)
	{
	   MATRICE_CODICI[i][j].RT=-2;
       MATRICE_CODICI[i][j].TIPO=-2;

	}
	// Riinizializzo la parte della matrice dei codici relativa
	//alla segnalazione a -2
 //printf("\nStruttura della matrice dei codici inizializzata\n");
return;
}



// PROCEDURE DI INIZIALIZZAZIONE DEI VETTORI CHE RACCOLGONO LE SORGENTI

void inizializza_SORGENTI_DL()
{
     int i;
     for (i=0;i<NRT;i++)
     {
            VETTORE_SORGENTI_RT_DL[i].T1=NULL;
            VETTORE_SORGENTI_RT_DL[i].T2=NULL;
            VETTORE_SORGENTI_RT_DL[i].T3=NULL;
            VETTORE_SORGENTI_RT_DL[i].S_ID=0;
     }
     //printf("\nSorgenti DL inizializzate\n");
     return;
}

void inizializza_SORGENTI_UL()
{
     int i;
     for (i=0;i<NRT;i++)
     {
            VETTORE_SORGENTI_RT_UL[i].T1=NULL;
            VETTORE_SORGENTI_RT_UL[i].T2=NULL;
            VETTORE_SORGENTI_RT_UL[i].T3=NULL;
            VETTORE_SORGENTI_RT_UL[i].S_ID=0;
     }
     //printf("\nSorgenti UL inizializzate\n");
     return;
}


void inizializza_ASSEGNAZIONE_UL()
 {
 int i;
  for (i=0;i<NRT;i++)
  {
   ASSEGNAZIONE_UL[i].GB=0;
   ASSEGNAZIONE_UL[i].BE=0;
  }
  return;
 }

void inizializza_ASSEGNAZIONE_DL()
 {
 int i;
  for (i=0;i<NRT;i++)
  {
   ASSEGNAZIONE_DL[i].GB=0;
   ASSEGNAZIONE_DL[i].BE=0;
  }
  //printf("\nAssegnazione DL inizializzata\n");
  return;
 }

void inizializza_SITUAZIONE_TS_DL()
{
int i;
//NEL TS DOVE STA L'ALLOCATIONAL CHANNEL(E NON SOLO LUI, AD ES
//ANCHE L'ACK CHANNEL) CI SONO SEMPRE "SEGNALAZIONE_DL" TC_PAIR OCCUPATE
 
 for(i=0;i<NTS_DL;i++) SITUAZIONE_TS_DL[i]=0;
 SITUAZIONE_TS_DL[POSIZIONE_PAG_CH]=SEGNALAZIONE_DL;
 //printf("\nSituazione TS DL inizializzata\n");
 //printf("\n\n");
 //for(i=0;i<NTS_DL;i++) printf("%d ",SITUAZIONE_TS_DL[i]);
 //printf("\n\n");
 
 return;

}


void inizializza_TRASMISSIONE_DL()
{
int i,j;
for (i=0;i<NRT;i++)
  {
   for (j=0;j<NTS_DL;j++)
    {
TRASMISSIONE_DL[i][j].GB=0;
TRASMISSIONE_DL[i][j].BE=0;
    }
  }
//printf("\nTrasmissione DL inizializzata\n");
return;
}


void inizializza_TRASMISSIONE_UL()
{
int i,j;
for (i=0;i<NRT;i++)
  {
   for (j=0;j<NTS_UL;j++)
   {
  TRASMISSIONE_UL[i][j].GB=0;
  TRASMISSIONE_UL[i][j].BE=0;
   }
  }
//printf("\nTrasmissione UL inizializzata\n");
return;
}


void inizializza_VETTORI_BANDE()
{
int i;
for(i=0;i<NRT;i++)
 {
  BANDA_RT_UL[i]=0;
  BANDA_RT_DL[i]=0;
 }
return;
}   




//*****************************************************************************************************
//                                INIZIALIZZAZIONI STATISTICHE
//*****************************************************************************************************




  void inizializza_STATISTICHE_DL()
  {
   int i,j;

	//INIZIALIZZO GLI ISTOGRAMMI DELLA PORTATA GB e BE PER OGNI RT
   for (i=0;i<NRT;i++)
	   for (j=0;j<NTS_DL*K-SEGNALAZIONE_DL+1;j++)
	   {
		hyst_portata_ON_OFF_DL[i][j]=0;
		hyst_portata_CBR_DL[i][j]=0;
		hyst_portata_GB_DL[i][j]=0;
		hyst_portata_BE_DL[i][j]=0;
	   }
   
   //INIZIALIZZO GLI ISTOGRAMMI DEL RIEMPIMENTO DEI BUFFER GB e BE
   for (i=0;i<NRT;i++)
   {
    	for (j=0;j<CAPIENZA_BUFFER+2;j++)
        {
         hyst_riempimento_GB_DL[i][j]=0;
         hyst_riempimento_BE_DL[i][j]=0;
        }
   }

   //INIZIALIZZO GLI ISTOGRAMMI DEI RITARDI DELLE MAC PDU BE
   for (i=0;i<NRT;i++)
   {
    	for (j=0;j<MAX_RITARDO_TS_DL+1;j++)
        {
         hyst_delay_BE_DL[i][j]=0;
        }
        normalizza_delay_BE_DL[i]=0;
   }
   
   
   //INIZIALIZZO LE NORMALIZZA DELAY ON_OFF E CBR
   
   for (i=0;i<NRT;i++)
    {
    normalizza_delay_ON_OFF_DL[i]=0;
    normalizza_delay_CBR_DL[i]=0;
    }

   // INIZIALIZZO I VETTORI DEI RITARDI MIN E MAX
   for (i=0;i<NRT;i++)
   {
     DELAY_ON_OFF_DL[i].MIN=MAX_RITARDO_TS_DL*DURATA_TS_DL;
     DELAY_CBR_DL[i].MIN=MAX_RITARDO_TS_DL*DURATA_TS_DL;
     DELAY_BE_DL[i].MIN=MAX_RITARDO_TS_DL*DURATA_TS_DL;

     DELAY_ON_OFF_DL[i].MAX=0;
     DELAY_CBR_DL[i].MAX=0;
     DELAY_BE_DL[i].MAX=0;
   }

   //INIZIALIZZO GLI ISTOGRAMMI DELLA PROBABILITA' CHE UN CERTO CODICE SIA ASSEGNATO AL DETERMINATO RT

   for (i=0;i<NRT;i++)
   {
	   for (j=0;j<K;j++) hyst_CODICE_PROBABILE_GB[i][j]=0;
           normalizza_COD_PROBABILE_GB[i]=0;
   }

   for (i=0;i<NRT;i++)
   {
	   for (j=0;j<K;j++) hyst_CODICE_PROBABILE_BE[i][j]=0;
           normalizza_COD_PROBABILE_BE[i]=0;
   }

	for (i=0;i<NRT;i++) 
		
	{
		APPOGGIO_PORTATA_DL[i].ON_OFF=0; 
		APPOGGIO_PORTATA_DL[i].CBR=0; 
        APPOGGIO_PORTATA_DL[i].GB=0;
        APPOGGIO_PORTATA_DL[i].BE=0;	
	}

  //printf("\nStatistiche inizializzate\n");
  return;

  }


void inizializza_STATISTICHE_UL()
  {
   int i,j;
   
   
	//INIZIALIZZO GLI ISTOGRAMMI DELLA PORTATA GB e BE PER OGNI RT
   for (i=0;i<NRT;i++)
	   for (j=0;j<NTS_UL-SEGNALAZIONE_UL+1;j++)
	   {
		hyst_portata_ON_OFF_UL[i][j]=0;
		hyst_portata_CBR_UL[i][j]=0;
		hyst_portata_GB_UL[i][j]=0;
		hyst_portata_BE_UL[i][j]=0;
	   }
   

//INIZIALIZZO GLI ISTOGRAMMI DEL RIEMPIMENTO DEI BUFFER GB e BE
   for (i=0;i<NRT;i++)
   {
    	for (j=0;j<CAPIENZA_BUFFER+2;j++)
        {
         hyst_riempimento_GB_UL[i][j]=0;
         hyst_riempimento_BE_UL[i][j]=0;
        }
   }

//INIZIALIZZO GLI ISTOGRAMMI DEI RITARDI DELLE MAC PDU BE
   for (i=0;i<NRT;i++)
   {
    	for (j=0;j<MAX_RITARDO_TS_UL+1;j++)          hyst_delay_BE_UL[i][j]=0;
            
        normalizza_delay_BE_UL[i]=0;
        
   }

//INIZIALIZZO LE NORMALIZZA DELAY ON_OFF E CBR
   
   for (i=0;i<NRT;i++)
    {
    normalizza_delay_ON_OFF_UL[i]=0;
    normalizza_delay_CBR_UL[i]=0;
    }


// INIZIALIZZO I VETTORI DEI RITARDI MIN E MAX
   for (i=0;i<NRT;i++)
   {
     DELAY_ON_OFF_UL[i].MIN=MAX_RITARDO_TS_UL*DURATA_TS_UL;
     DELAY_CBR_UL[i].MIN=MAX_RITARDO_TS_UL*DURATA_TS_UL;
     DELAY_BE_UL[i].MIN=MAX_RITARDO_TS_UL*DURATA_TS_UL;

     DELAY_ON_OFF_UL[i].MAX=0;
     DELAY_CBR_UL[i].MAX=0;
     DELAY_BE_UL[i].MAX=0;
   }

  
  

//INIZIALIZZO L'ISTOGRAMMA RT-TS
  for(i=0;i<NRT;i++)
  {
    for(j=0;j<NTS_UL;j++)
       
       hyst_RT_TS[i][j]=0;
  }
  

//INIZIALIZZIAMO GLI ISTOGRAMMI DELLE PORTATE       
for (i=0;i<NRT;i++) 
		
	{
		APPOGGIO_PORTATA_UL[i].ON_OFF=0; 
		APPOGGIO_PORTATA_UL[i].CBR=0; 
                APPOGGIO_PORTATA_UL[i].GB=0;
                APPOGGIO_PORTATA_UL[i].BE=0;	
	}

  //printf("\nStatistiche inizializzate\n");
 return;

}


//*******************************************************************************************
//*******************************************************************************************
//                     SEZIONE RISERVATA ALLE PROCEDURE VARIE
//*******************************************************************************************
//*******************************************************************************************


/// PROCEDURE AUSILIARIE

//USANDO "min" INVECE DI "mini" E "max" INVECE DI "maxi",UN COMPILATORE C DA' ERRORE IN QUANTO GIA' ESISTE 
//TALE FUNZIONE IN LIBRERIA
 
double maxi (double a,double b)
{
 if (a>=b) return(a);
 else    return(b);
}


int massimo (int a,int b)
{
 if (a>=b) return(a);
 else    return(b);
}


double mini (double a,double b)
{
 if (a<=b) return(a);
 else    return(b);
}


int minimo (int a,int b)
{
 if (a<=b) return(a);
 else    return(b);
}



//RESTITUISCE UN INTERO UNIFORMEMENTE DISTRIBUITO FRA "0" e "a-1" 
int random_int(int a)
{
int casual;
casual=(abs)((int)ceil((rand()/(double)(RAND_MAX+1))*a));
if (casual==0) casual=1;
//if (casual<0) casual=casual*(-1);
return (casual-1);
}





//RESTITUISCE UN REALE UNIFORMEMENTE DISTRIBUITO FRA "0" e "a"

double random_real(double a)
{
	double casual;
	casual=(rand()/((double) (RAND_MAX+1)))*a;
        if (casual==0) casual=1;
        if (casual<0) casual=casual*(-1);
  return(casual);
}


// calcola la determinazione del tempo di interarrivo secondo
// la distribuzione di POISSON

double POISSON(int f)
// f = frequenza media di interarrivo in HERTZ
{
double x;
x=(rand()/(double)(RAND_MAX+1));
//Abbiamo lasciato RAND_MAX+1 anche se ci sono stati problemi sul Visual C++ compilando il programma con compilatore //"C" 
if (x<0) x*=-1;
x=0-log(x);
x=x/f;
//printf("\nIl valore del tempo di interarrivo  e' pari a %lf\n",x);
return x;
}


//PROCEDURE PER LA VERIFICA DELLA DISPONIBILITA' DELLE RISORSE 
int TS_OCCUPATO(int TS)
{
  if (VETTORE_TS[TS].RT!=-1) return(1);
 else return(0);
}


int TS_PIENO(int TS)
{
// IL TS E' PIENO SE TUTTI I "K" CODICI SONO OCCUPATI
 if (SITUAZIONE_TS_DL[TS]==K) return(1);
 else return(0);

}

int CODICE_PIENO(int TS,int CODICE)
{
//IL CAMPO "RT" VALE "-1" SE E SOLO SE QUELLA TC_PAIR E' LIBERA
//VALE "-2" SE E' DI SEGNALAZIONE. E' >0 SE E' ASSEGNATA AD ALTRO UTENTE
 if (MATRICE_CODICI[CODICE][TS].RT==-1) return(0);
 else return(1);
}





// PROCEDURA DI RIEMPIMENTO DELLE MATRICI DELLE SORGENTI
void CREA_MATRICI_SORGENTI_DL()
{
FILE *fp1,*fp2,*fp3;
int j,c,temp;
double dtemp;
fp1=fopen("sorgentitipo1.dat","r");
fp2=fopen("sorgentitipo2.dat","r");
fp3=fopen("sorgentitipo3.dat","r");
// matrice sorgenti di tipo 1
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<4;c++)
        {
        fscanf(fp1,"%d",&temp);
        MATRICE_TIPO_1[j][c]=temp;
        }
    fscanf(fp1,"%lf",&dtemp);
    VETTORE_RITARDI_TIPO_1_DL[j]=dtemp;
    }
fclose(fp1);
// matrice sorgenti di tipo 2
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<4;c++)
        {
        fscanf(fp2,"%d",&temp);
        MATRICE_TIPO_2[j][c]=temp;
        }
    fscanf(fp2,"%lf",&dtemp);
    VETTORE_RITARDI_TIPO_2_DL[j]=dtemp;
    }
fclose(fp2);
// matrice sorgenti di tipo 3
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<2;c++)
        {
        fscanf(fp3,"%d",&temp);
        MATRICE_TIPO_3[j][c]=temp;
        }
    }
fclose(fp3);
return;
}



// PROCEDURA DI RIEMPIMENTO DELLE MATRICI DELLE SORGENTI
void CREA_MATRICI_SORGENTI_UL()
{
FILE *fp1,*fp2,*fp3;
int j,c,temp;
double dtemp;
fp1=fopen("sorgentitipo1.dat","r");
fp2=fopen("sorgentitipo2.dat","r");
fp3=fopen("sorgentitipo3.dat","r");
// matrice sorgenti di tipo 1
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<4;c++)
        {
        fscanf(fp1,"%d",&temp);
        MATRICE_TIPO_1[j][c]=temp;
        }
    fscanf(fp1,"%lf",&dtemp);
    VETTORE_RITARDI_TIPO_1_UL[j]=dtemp;
    }
fclose(fp1);
// matrice sorgenti di tipo 2
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<4;c++)
        {
        fscanf(fp2,"%d",&temp);
        MATRICE_TIPO_2[j][c]=temp;
        }
    fscanf(fp2,"%lf",&dtemp);
    VETTORE_RITARDI_TIPO_2_UL[j]=dtemp;
    }
fclose(fp2);
// matrice sorgenti di tipo 3
for (j=0;j<NCLASSI;j++)
    {
    for (c=0;c<2;c++)
        {
        fscanf(fp3,"%d",&temp);
        MATRICE_TIPO_3[j][c]=temp;
        }
    }
fclose(fp3);
return;
}


// PROCEDURE DI GESTIONE DELL'ALLOCATIONAL E DEL PAGING CHANNEL
// tutte queste procedure ricevono come ingresso, necessariamente,
// la matrice su cui devono essere applicate

void AGGIUNGI_RISORSA_DL(pCODE MATRIX[NRT][NTS_DL],int k,int RT,int TS)  
{
pCODE support;
if (MATRIX[RT][TS]==NULL)
   {
   MATRIX[RT][TS]=(pCODE)malloc(sizeof(CODE));
   support=MATRIX[RT][TS];
   }
   else
   {
   support=MATRIX[RT][TS];
   while (support->NEXT_COD!=NULL) support=support->NEXT_COD;
   support->NEXT_COD=(pCODE)malloc(sizeof(CODE));
   support=support->NEXT_COD;
   }
support->COD=k;
support->NEXT_COD=NULL;
return;
}



void DEALLOCA_RISORSE(pCODE MATRIX[][NTS_DL])
{
pCODE support1,support2;
int a,b;
for (a=0;a<NRT;a++)
    {
    for (b=0;b<NTS_DL;b++)
        {
        support1=MATRIX[a][b];
        while (support1!=NULL)
              {
              support2=support1->NEXT_COD;
              free(support1);
              support1=support2;
              }
        MATRIX[a][b]=NULL;
        }
    }
return;
}



int CONTA_e_DEALLOCA_DL(pCODE MATRIX[][NTS_DL],int RT,int TS)
// questa procedura conta le risorse (codici) allocati per un dato
// radio terminal e per un dato Time Slot. La procedura restituisce come
// risultato il numero di risorse allocate e resetta a zero quell'elemento
// dell'array preso in considerazione
{
int contarisorse=0;
pCODE support1,support2;
support1=MATRIX[RT-1][TS-1];
if (support1!=NULL)
    while (support1!=NULL)
    {
    contarisorse++;
    support2=support1->NEXT_COD;
    free(support1);
    support1=support2;
    }
return contarisorse;
}



int CONTA_DL(pCODE MATRIX[][NTS_DL],int RT,int TS)
// come prima ma senza deallocazione della memoria
{
int contarisorse=0;
pCODE support1;
support1=MATRIX[RT-1][TS-1];
if (support1!=NULL)
    while (support1!=NULL)
    {
    contarisorse++;
    support1=support1->NEXT_COD;
    }
return contarisorse;
}

//QUESTA PROCEDURA AGGIUNGE IL RECORD IN CODA ALLE LISTE CHE PARTONO
// DAL VETTORE DI PUNTATORI "LISTA_ALL_CH_UL"
void AGGIUNGI_TS (pTS VECTOR[],int RT,int TIME)
{
 pTS support;
 if (VECTOR[RT]==NULL)
 {
  VECTOR[RT]=(pTS)malloc(sizeof(struct RECORD_TS));
  support=VECTOR[RT];
 }
 else
 {
   support=VECTOR[RT];
   while(support->NEXT_TS!=NULL)
   support=support->NEXT_TS;
   support->NEXT_TS=(pTS)malloc(sizeof(struct RECORD_TS));
   support=support->NEXT_TS;
 }
 support->TS=TIME;
 support->NEXT_TS=NULL;
return;
}


//QUESTA PROCEDURA DEALLOCA LE RISORSE DAL VETTORE DI PUNTATORI

void DEALLOCA_TS(pTS VECTOR[])
{
 pTS support1,support2;
 int i;
 for (i=0;i<NRT;i++)
   {  support1=VECTOR[i];
     while (support1!=NULL)
          {
           support2=support1->NEXT_TS;
           free(support1);
           support1=support2;
          }
      VECTOR[i]=NULL;
    }             
return;
}

//QUESTA PROCEDURA CONTA E DEALLOCA LE RISORSE

int CONTA_e_DEALLOCA_UL(pTS VECTOR[],int RT)
{
 int contarisorse=0;
 pTS support1,support2;
 support1=VECTOR[RT-1];
 if (support1!=NULL)
    while(support1!=NULL)
        {
         contarisorse++;
         support2=support1->NEXT_TS;
         free(support1);
         support1=support2;
        }
 return contarisorse;
}

//QUESTA PROCEDURA CONTA SENZA DEALLOCARE

        
int CONTA_UL(pTS VECTOR[],int RT)
{
int contarisorse=0;
pTS support1;
support1=VECTOR[RT-1];
if (support1!=NULL)
    while (support1!=NULL)
    {
    contarisorse++;
    support1=support1->NEXT_TS;
    }
return contarisorse;
}



//Conta il numero di elementi in coda in un buffer
int NUMERO_ELEMENTI_CODA(BUFFER q)
{
 int conta=0;
 BUFFER p=q;
 while (p!=NULL)
 {
  p=p->NEXT_MACPDU;
  conta++;
 }
 return (conta);
}



void LIBERA_LISTA(BUFFER punt)
{

 BUFFER temp;
 if (punt==NULL) //non ci sono elementi da togliere
 return;

else
{
  if (punt->NEXT_MACPDU==NULL)// c' un solo elemento da togliere
  {
  free (punt);
  punt=NULL;
  }
  else
  {
   while (punt->NEXT_MACPDU!=NULL) //ci sono pi elementi da togliere
      {
	   temp=punt;
	   punt=punt->NEXT_MACPDU;
	   free (temp);
       }
   free (punt);
   punt=NULL;
  }
 }

return;
}



// RESTITUISCO IL PUNTATORE ALLE MAC PDU CHE HO TOLTO.
// INOLTRE MODIFICA IL BUFFER CHE GLI E' STATO PASSATO LEVANDO "Tx" MAC PDU
// AD INIZIARE DALLA PRIMA CHE E' STATA INSERITA (FIFO)
BUFFER ACCORCIA_LISTA(BUFFER *p,int Tx,int *num) 
{
 BUFFER temp=*p;
 BUFFER q;
 BUFFER t;
 q=*p;
 int i;
 *num=NUMERO_ELEMENTI_CODA(temp);

 if (*num>0)
 {
  	if (Tx<= *num)
   	{

      	for (i=0;i<Tx-1;i++)  q=q->NEXT_MACPDU;
         if (Tx!=0)
         	{
            
			t=q->NEXT_MACPDU;
                        q->NEXT_MACPDU=NULL;
                        q=t;
			*p=t;
            return (temp);
            }
          else return (NULL);
      }

      else //Tx > (*num)
           {
            p=NULL;
            return (temp);
           }
 }

 else //(*num<=0)
 return(NULL);
}


//QUESTA PROCEDURA RIEMPIE MAN MANO I RECORD DEL VETTORE CHE PER OGNI TS 
//SEGNALA A QUALE RT E' STATO ASSENATO E CHE TIPO DI MACPDU SI TRASMETTE.

void AGGIUNGI_RISORSA_UL (struct COPPIA_TIPO_RT VETTORE[],char CAR,int TS,int rt)
{
 VETTORE[TS].TIPO=CAR;
 VETTORE[TS].RT=rt;
 
return;
}  


// PROCEDURE PER L'ASSEGNAZIONE DELLE BANDE

int  assegnazione_banda_DL_TIPO1(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP,NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC

         //ASSEGNO LE BANDE ALLE SORGENTI ON-OFF
         
NUM_BW=(double)((MATRICE_TIPO_1[temp-1][0])*(MATRICE_TIPO_1[temp-1][2])); //NUMERATORE PER IL CALCOLO DELLA BANDA
BW=NUM_BW/(double)(((MATRICE_TIPO_1[temp-1][0]-MATRICE_TIPO_1[temp-1][1])*(VETTORE_RITARDI_TIPO_1_DL[temp-1]-D_MAX_ACCESSO_DL))+(MATRICE_TIPO_1[temp-1][2]));

B_RSVP=maxi(BW,(double)MATRICE_TIPO_1[temp-1][1]);
// Calcolo della banda RSVP secondo l'articolo di WHITE

B_MAC=B_RSVP*(ceil(MATRICE_TIPO_1[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_1[temp-1][3]);
// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL


return (int)ceil(B_MAC*(NTS_DL*DURATA_TS_DL)/(double)L_MACPDU);
 
}               
         
               
int  assegnazione_banda_DL_TIPO2(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC               
               
               
//ASSEGNO LE BANDE ALLE SORGENTI CBR

B_RSVP=(double)(MATRICE_TIPO_2[temp-1][0]);
// Calcolo della banda RSVP secondo l'articolo di WHITE
B_MAC=B_RSVP*(ceil(MATRICE_TIPO_2[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_2[temp-1][3]);
// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil((B_MAC*NTS_DL*DURATA_TS_DL)/(double)L_MACPDU);

}


int  assegnazione_banda_UL_TIPO1(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP,NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC

         //ASSEGNO LE BANDE ALLE SORGENTI ON-OFF
         
NUM_BW=(double)((MATRICE_TIPO_1[temp-1][0])*(MATRICE_TIPO_1[temp-1][2])); //NUMERATORE PER IL CALCOLO DELLA BANDA
BW=NUM_BW/(double)(((MATRICE_TIPO_1[temp-1][0]-MATRICE_TIPO_1[temp-1][1])*(VETTORE_RITARDI_TIPO_1_UL[temp-1]-D_MAX_ACCESSO_UL))+(MATRICE_TIPO_1[temp-1][2]));

B_RSVP=maxi(BW,(double)MATRICE_TIPO_1[temp-1][1]);
// Calcolo della banda RSVP secondo l'articolo di WHITE

B_MAC=B_RSVP*(ceil(MATRICE_TIPO_1[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_1[temp-1][3]);
// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil(B_MAC*(NTS_UL*DURATA_TS_UL)/(double)L_MACPDU);
 
}               
         
               
int  assegnazione_banda_UL_TIPO2(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP;
//double NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC               
               
               
//ASSEGNO LE BANDE ALLE SORGENTI CBR

B_RSVP=(double)(MATRICE_TIPO_2[temp-1][0]);
// Calcolo della banda RSVP secondo l'articolo di WHITE
B_MAC=B_RSVP*(ceil(MATRICE_TIPO_2[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_2[temp-1][3]);
// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil((B_MAC*NTS_UL*DURATA_TS_UL)/(double)L_MACPDU);

}




int  assegnazione_banda_simm_RN_TIPO1(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP,NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC

         //ASSEGNO LE BANDE ALLE SORGENTI ON-OFF
         
NUM_BW=(double)((MATRICE_TIPO_1[temp-1][0])*(MATRICE_TIPO_1[temp-1][2])); //NUMERATORE PER IL CALCOLO DELLA BANDA
BW=NUM_BW/(double)(((MATRICE_TIPO_1[temp-1][0]-MATRICE_TIPO_1[temp-1][1])*(VETTORE_RITARDI_TIPO_1_DL[temp-1]-D_MAX_ACCESSO_DL))+(MATRICE_TIPO_1[temp-1][2]));

B_RSVP=maxi(BW,(double)MATRICE_TIPO_1[temp-1][1]);
// Calcolo della banda RSVP secondo l'articolo di WHITE

B_MAC=B_RSVP*(ceil(MATRICE_TIPO_1[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_1[temp-1][3])*(VECT_PERCENT[temp-1])/(double)100;

// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil(B_MAC*(NTS_DL*DURATA_TS_DL)/(double)L_MACPDU);
 
}               

               
int  assegnazione_banda_simm_RN_TIPO2(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC               
               
               
//ASSEGNO LE BANDE ALLE SORGENTI CBR

B_RSVP=(double)(MATRICE_TIPO_2[temp-1][0]);
// Calcolo della banda RSVP secondo l'articolo di WHITE
B_MAC=B_RSVP*(ceil(MATRICE_TIPO_2[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_2[temp-1][3])*(VECT_PERCENT[temp+2])/(double)100;
// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil((B_MAC*NTS_DL*DURATA_TS_DL)/(double)L_MACPDU);

}


int  assegnazione_banda_simm_RT_TIPO1(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP,NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC

         //ASSEGNO LE BANDE ALLE SORGENTI ON-OFF
         
NUM_BW=(double)((MATRICE_TIPO_1[temp-1][0])*(MATRICE_TIPO_1[temp-1][2])); //NUMERATORE PER IL CALCOLO DELLA BANDA
BW=NUM_BW/(double)(((MATRICE_TIPO_1[temp-1][0]-MATRICE_TIPO_1[temp-1][1])*(VETTORE_RITARDI_TIPO_1_UL[temp-1]-D_MAX_ACCESSO_UL))+(MATRICE_TIPO_1[temp-1][2]));

B_RSVP=maxi(BW,(double)MATRICE_TIPO_1[temp-1][1]);
// Calcolo della banda RSVP secondo l'articolo di WHITE

B_MAC=B_RSVP*(ceil(MATRICE_TIPO_1[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_1[temp-1][3])*(VECT_PERCENT[temp-1])/(double)100;

// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil(B_MAC*(NTS_UL*DURATA_TS_UL)/(double)L_MACPDU);
 
}               
           
int  assegnazione_banda_simm_RT_TIPO2(int i,int temp)  //"i" indica il RT  
{
double B_MAC,B_RSVP;
//double NUM_BW,BW;         // [bytes/sec]
// la banda RSVP non rimane memorizzata nella sorgente ma serve solamente
// per arrivare a calcolare la banda MAC               
               
               
//ASSEGNO LE BANDE ALLE SORGENTI CBR

B_RSVP=(double)(MATRICE_TIPO_2[temp-1][0]);
// Calcolo della banda RSVP secondo l'articolo di WHITE
B_MAC=B_RSVP*(ceil(MATRICE_TIPO_2[temp-1][3]/(double)PAYLOAD_AL))*(L_MACPDU/(double)MATRICE_TIPO_2[temp-1][3])*(VECT_PERCENT[temp+2])/(double)100;

// Calcolo la banda allo strato MAC al netto dell'overhead di strato MAC e AL

return (int)ceil((B_MAC*NTS_UL*DURATA_TS_UL)/(double)L_MACPDU);

}



// PROCEDURE DI INSERIMENTO DI UNA NUOVA SORGENTE AL RADIO NODE

int inserisci_sorgente_TIPO1_RN(int T,int temp)
{
pTIPO_1 support;
int BW_MAC=0;
BW_MAC=assegnazione_banda_DL_TIPO1(T-1,temp);

if ((BANDA_TOTALE_DL+BW_MAC)<= CAPACITA_ALLOCABILE_GB_DL)
{

VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_DL[T-1].T1;

if (support==NULL)
   {              // E' la prima sorgente di quel tipo per quel radio-terminal
   VETTORE_SORGENTI_RT_DL[T-1].T1=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
   support=VETTORE_SORGENTI_RT_DL[T-1].T1;
   
   support->T_ON=(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1]));
   support->T_OFF=(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);
   support->RATE_PICCO=MATRICE_TIPO_1[temp-1][0];
   support->RATE_MEDIO=MATRICE_TIPO_1[temp-1][1];
   support->TBD=MATRICE_TIPO_1[temp-1][2];
   support->L_IP=MATRICE_TIPO_1[temp-1][3];
   support->BYTE=0;
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_1_DL[temp-1];
   support->BANDA_MAC=BW_MAC;
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
   BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
  // printf("\nB_MAC tipo 1 riferita al RT %d e' %d%\n",T,support->BANDA_MAC);

   // support punta al record della nuova sorgente
   }
else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
    support=support->NEXT_SORG;
    
    support->T_ON=(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1]));
    support->T_OFF=(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);
    support->RATE_PICCO=MATRICE_TIPO_1[temp-1][0];
    support->RATE_MEDIO=MATRICE_TIPO_1[temp-1][1];
    support->TBD=MATRICE_TIPO_1[temp-1][2];
    support->L_IP=MATRICE_TIPO_1[temp-1][3];
    support->BYTE=0;
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_1_DL[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    
    BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 1 riferita al RT %d e' %d%\n",T,support->BANDA_MAC);
    // support punta al record della nuova sorgente
    }
return (support->BANDA_MAC);
}
else return 0;

}


int inserisci_sorgente_TIPO2_RN(int T,int temp)
{
pTIPO_2 support;

int BW_MAC=0;
BW_MAC=assegnazione_banda_DL_TIPO2(T-1,temp);

if ((BANDA_TOTALE_DL+BW_MAC)<=CAPACITA_ALLOCABILE_GB_DL)
   {

   VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
   support=VETTORE_SORGENTI_RT_DL[T-1].T2;
   if (support==NULL)
       {              // E' la prima sorgente di quel tipo per quel radio-terminal
        VETTORE_SORGENTI_RT_DL[T-1].T2=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
        support=VETTORE_SORGENTI_RT_DL[T-1].T2;
        support->RATE_PICCO=MATRICE_TIPO_2[temp-1][0];
        support->RATE_MEDIO=MATRICE_TIPO_2[temp-1][1];
        support->TBD=MATRICE_TIPO_2[temp-1][2];
        support->L_IP=MATRICE_TIPO_2[temp-1][3];
        support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
        support->D_MAX=VETTORE_RITARDI_TIPO_2_DL[temp-1];
        support->BANDA_MAC=BW_MAC;
        support->TNEXT=0;
        support->PRIMO_MOMENTO=0;
        support->SECONDO_MOMENTO=0;
        support->NEXT_SORG=NULL;
        BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
        //printf("\nB_MAC tipo 2 riferita al RT %d e' %d%\n",T,support->BANDA_MAC);
        
        // support punta al record della nuova sorgente
       }
   else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
       {
      	while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
        support->NEXT_SORG=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
        support=support->NEXT_SORG;
        support->RATE_PICCO=MATRICE_TIPO_2[temp-1][0];
        support->RATE_MEDIO=MATRICE_TIPO_2[temp-1][1];
        support->TBD=MATRICE_TIPO_2[temp-1][2];
        support->L_IP=MATRICE_TIPO_2[temp-1][3];
        support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
        support->D_MAX=VETTORE_RITARDI_TIPO_2_DL[temp-1];
        support->BANDA_MAC=BW_MAC;
        support->TNEXT=0;
        support->PRIMO_MOMENTO=0;
        support->SECONDO_MOMENTO=0;
        support->NEXT_SORG=NULL;
        BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
        //printf("\nB_MAC tipo 2 riferita al RT %d e' %d%\n",T,support->BANDA_MAC);
        // support punta al record della nuova sorgente
        }
   return (support->BANDA_MAC);
   
   }
else return 0;
}

void inserisci_sorgente_TIPO3_RN(int T,int temp)
{
pTIPO_3 support;
VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_DL[T-1].T3;
if (support==NULL)
   {              // E' la prima sorgente di quel tipo per quel radio-terminal
   VETTORE_SORGENTI_RT_DL[T-1].T3=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
   support=VETTORE_SORGENTI_RT_DL[T-1].T3;
   
   support->FREQUENZA_MEDIA=MATRICE_TIPO_3[temp-1][0];
   support->L_IP=MATRICE_TIPO_3[temp-1][1];
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   // support punta al record della nuova sorgente
   }
else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
   
    support->NEXT_SORG=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
    support=support->NEXT_SORG;
    support->FREQUENZA_MEDIA=MATRICE_TIPO_3[temp-1][0];
    support->L_IP=MATRICE_TIPO_3[temp-1][1];
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    // support punta al record della nuova sorgente
    }
return;
}



//LE SEGUENTI QUATTRO PROCEDURE SERVONO PER CALCOLARE LA BANDA SENZA ALLOCARE LE SORGENTI.
//SONO NECESSARIE NEL MAIN PER GESTIRE LA NASCITA DELLE SORGENTI AI RT.
int calcola_banda_TIPO1_RT(int T,int temp)
{
 int banda=0;
 banda=assegnazione_banda_UL_TIPO1(T-1,temp);

 return(banda);
} 


int calcola_banda_TIPO2_RT(int T,int temp)
{
 int banda=0;
 banda=assegnazione_banda_UL_TIPO2(T-1,temp);

 return(banda);
} 


int calcola_banda_simm_TIPO1_RT(int T,int temp)
{
 int banda=0;
 banda=assegnazione_banda_simm_RN_TIPO1(T-1,temp);

 return(banda);
} 


int calcola_banda_simm_TIPO2_RT(int T,int temp)
{
 int banda=0;
 banda=assegnazione_banda_simm_RN_TIPO2(T-1,temp);

 return(banda);
} 





// PROCEDURE DI INSERIMENTO DI UNA NUOVA SORGENTE AL RADIO TERMINAL
int inserisci_sorgente_TIPO1_RT(int T,int temp)
{
pTIPO_1 support;
int BW_MAC=0;
BW_MAC=assegnazione_banda_UL_TIPO1(T-1,temp);

if ((BANDA_TOTALE_UL+BW_MAC)<= CAPACITA_ALLOCABILE_GB_UL)
{
VETTORE_SORGENTI_RT_UL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_UL[T-1].T1;

if (support==NULL)
   {              // E' la prima sorgente di quel tipo per quel radio-terminal
   VETTORE_SORGENTI_RT_UL[T-1].T1=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
   support=VETTORE_SORGENTI_RT_UL[T-1].T1;
      
   support->T_ON=(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1])); 
   support->T_OFF=(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);   
   support->RATE_PICCO=MATRICE_TIPO_1[temp-1][0];
   support->RATE_MEDIO=MATRICE_TIPO_1[temp-1][1];  
   support->TBD=MATRICE_TIPO_1[temp-1][2];  
   support->L_IP=MATRICE_TIPO_1[temp-1][3];  
   support->BYTE=0;
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_1_UL[temp-1];
   support->BANDA_MAC=BW_MAC;
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
   BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
   //printf("\nB_MAC tipo 1 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);

   // support punta al record della nuova sorgente
   }
else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
    support=support->NEXT_SORG;
    
    support->T_ON=(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1]));
    support->T_OFF=(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);
    support->RATE_PICCO=MATRICE_TIPO_1[temp-1][0];
    support->RATE_MEDIO=MATRICE_TIPO_1[temp-1][1];
    support->TBD=MATRICE_TIPO_1[temp-1][2];
    support->L_IP=MATRICE_TIPO_1[temp-1][3];
    support->BYTE=0;
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_1_UL[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
        
    BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 1 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);
    // support punta al record della nuova sorgente
    }
return (support->BANDA_MAC);
}
else return 0;

}


int inserisci_sorgente_TIPO2_RT(int T,int temp)
{
pTIPO_2 support;

int BW_MAC=0;
BW_MAC=assegnazione_banda_UL_TIPO2(T-1,temp);

if ((BANDA_TOTALE_UL+BW_MAC)<=CAPACITA_ALLOCABILE_GB_UL)
 {

VETTORE_SORGENTI_RT_UL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_UL[T-1].T2;
if (support==NULL)
   {              // E' la prima sorgente di quel tipo per quel radio-terminal
   VETTORE_SORGENTI_RT_UL[T-1].T2=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
   support=VETTORE_SORGENTI_RT_UL[T-1].T2;
  
   support->RATE_PICCO=MATRICE_TIPO_2[temp-1][0];
   support->RATE_MEDIO=MATRICE_TIPO_2[temp-1][1];
   support->TBD=MATRICE_TIPO_2[temp-1][2];
   support->L_IP=MATRICE_TIPO_2[temp-1][3];
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_2_UL[temp-1];
   support->BANDA_MAC=BW_MAC;
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
    BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 2 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);

   // support punta al record della nuova sorgente
   }
else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
    support=support->NEXT_SORG;    
    support->RATE_PICCO=MATRICE_TIPO_2[temp-1][0];
    support->RATE_MEDIO=MATRICE_TIPO_2[temp-1][1];
    support->TBD=MATRICE_TIPO_2[temp-1][2];
    support->L_IP=MATRICE_TIPO_2[temp-1][3];
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_2_UL[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    
    BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 2 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);
    // support punta al record della nuova sorgente
    }
   return (support->BANDA_MAC);
   
   }
else return 0;
}

void inserisci_sorgente_TIPO3_RT(int T,int temp)
{
pTIPO_3 support;
VETTORE_SORGENTI_RT_UL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_UL[T-1].T3;
if (support==NULL)
   {              // E' la prima sorgente di quel tipo per quel radio-terminal
   VETTORE_SORGENTI_RT_UL[T-1].T3=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
  
   support=VETTORE_SORGENTI_RT_UL[T-1].T3;
   support->FREQUENZA_MEDIA=MATRICE_TIPO_3[temp-1][0];  
   support->L_IP=MATRICE_TIPO_3[temp-1][1];  
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   // support punta al record della nuova sorgente
   }
else              // Non e' la prima sorgente di quel tipo per quel radio-terminal
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    
    support->NEXT_SORG=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
    support=support->NEXT_SORG;
    support->FREQUENZA_MEDIA=MATRICE_TIPO_3[temp-1][0];
    support->L_IP=MATRICE_TIPO_3[temp-1][1];
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    // support punta al record della nuova sorgente
    }
return;
}

// PROCEDURE PER INSERIRE LE SORGENTI SIMMETRICHE NEL MOMENTO
// IN CUI AVVIENE UNA NASCITA

int inserisci_simmetrica_TIPO1_UL(int T,int temp)
{
 pTIPO_1 support;
int BW_MAC=0;
BW_MAC=assegnazione_banda_simm_RN_TIPO1(T-1,temp);  //BW_MAC=assegnazione_banda_DL_TIPO1(T-1,temp);

if ((BANDA_TOTALE_DL+BW_MAC)<= CAPACITA_ALLOCABILE_GB_DL)
{
VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_DL[T-1].T1;

if (support==NULL)
   {              
   VETTORE_SORGENTI_RT_DL[T-1].T1=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
   support=VETTORE_SORGENTI_RT_DL[T-1].T1;
   
   
   support->T_ON=(VECT_PERCENT[temp-1]/(double)100)*(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1])); 
   support->T_OFF=(1-(VECT_PERCENT[temp-1]/(double)100))*(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]); 
   support->RATE_PICCO=(int)ceil(MATRICE_TIPO_1[temp-1][0]);
   support->RATE_MEDIO=(int)ceil(MATRICE_TIPO_1[temp-1][1]);   
   support->TBD=MATRICE_TIPO_1[temp-1][2];   
   support->L_IP=MATRICE_TIPO_1[temp-1][3];   
   support->BYTE=0;   
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_1_DL[temp-1];
   support->BANDA_MAC=BW_MAC;
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
   BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 1 riferita al RT %d e' %d%\n",T,support->BANDA_MAC);
     }
else           
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
    support=support->NEXT_SORG;
    
    support->T_ON=(VECT_PERCENT[temp-1]/(double)100)*(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1]));
    support->T_OFF=(1-(VECT_PERCENT[temp-1])/(double)100)*(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);
    support->RATE_PICCO=(int)ceil(MATRICE_TIPO_1[temp-1][0]);
    support->RATE_MEDIO=(int)ceil(MATRICE_TIPO_1[temp-1][1]);   
    support->TBD=MATRICE_TIPO_1[temp-1][2];
    support->L_IP=MATRICE_TIPO_1[temp-1][3];
    support->BYTE=0;
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_1_DL[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
        
    BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
    // printf("\nB_MAC tipo 1 riferita al RT %d e' %d%\n",T,support->BANDA_MAC);
    }
return (support->BANDA_MAC);
}
else return 0;

}


int inserisci_simmetrica_TIPO1_DL(int T,int temp)
{
 pTIPO_1 support;
int BW_MAC=0;
BW_MAC=assegnazione_banda_simm_RT_TIPO1(T-1,temp);   //BW_MAC=assegnazione_banda_UL_TIPO1(T-1,temp);

if ((BANDA_TOTALE_UL+BW_MAC)<= CAPACITA_ALLOCABILE_GB_UL)
{
VETTORE_SORGENTI_RT_UL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_UL[T-1].T1;

if (support==NULL)
   {              
   VETTORE_SORGENTI_RT_UL[T-1].T1=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
   support=VETTORE_SORGENTI_RT_UL[T-1].T1;
   
   support->T_ON=(VECT_PERCENT[temp-1]/(double)100)*(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1])); 
   support->T_OFF=(1-(VECT_PERCENT[temp-1])/(double)100)*(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]); 
   support->RATE_PICCO=(int)ceil(MATRICE_TIPO_1[temp-1][0]);
   support->RATE_MEDIO=(int)ceil(MATRICE_TIPO_1[temp-1][1]);   
   support->TBD=MATRICE_TIPO_1[temp-1][2];   
   support->L_IP=MATRICE_TIPO_1[temp-1][3];   
   support->BYTE=0;
   
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_1_UL[temp-1];
   support->BANDA_MAC=BW_MAC;
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
   BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
   //printf("\nB_MAC tipo 1 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);
     }
else           
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_1)malloc(sizeof(struct SORGENTE_TIPO1));
    support=support->NEXT_SORG;
    
    support->T_ON=(VECT_PERCENT[temp-1]/(double)100)*(MATRICE_TIPO_1[temp-1][2])/(double)((MATRICE_TIPO_1[temp-1][0])-(MATRICE_TIPO_1[temp-1][1]));
    support->T_OFF=(1-(VECT_PERCENT[temp-1]/(double)100))*(MATRICE_TIPO_1[temp-1][2])/(double)(MATRICE_TIPO_1[temp-1][1]);
    support->RATE_PICCO=(int)ceil(MATRICE_TIPO_1[temp-1][0]);
    support->RATE_MEDIO=(int)ceil(MATRICE_TIPO_1[temp-1][1]);   
    support->TBD=MATRICE_TIPO_1[temp-1][2];
    support->L_IP=MATRICE_TIPO_1[temp-1][3];
    support->BYTE=0;
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_1_UL[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
        
    BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 1 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);
    }
return (support->BANDA_MAC);
}
else return 0;

}



int inserisci_simmetrica_TIPO2_UL(int T,int temp)
{
 pTIPO_2 support;

int BW_MAC=0;
BW_MAC=assegnazione_banda_simm_RN_TIPO2(T-1,temp);  //BW_MAC=assegnazione_banda_DL_TIPO2(T-1,temp);

if ((BANDA_TOTALE_DL+BW_MAC)<=CAPACITA_ALLOCABILE_GB_DL)
 {

VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_DL[T-1].T2;
if (support==NULL)
{              
   VETTORE_SORGENTI_RT_DL[T-1].T2=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
   support=VETTORE_SORGENTI_RT_DL[T-1].T2;
   
   support->RATE_PICCO=(int)ceil((MATRICE_TIPO_2[temp-1][0])*(VECT_PERCENT[temp+2])/(double)100);
   support->RATE_MEDIO=(int)ceil((MATRICE_TIPO_2[temp-1][1])*(VECT_PERCENT[temp+2])/(double)100);   
   support->TBD=MATRICE_TIPO_2[temp-1][2];
   support->L_IP=MATRICE_TIPO_2[temp-1][3];
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_2_DL[temp-1];
   support->BANDA_MAC=BW_MAC;
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
        
   BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 2 riferita al RT %d e' %d%\n",T,support->BANDA_MAC); 
   }
else             
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
    support=support->NEXT_SORG;
    
    support->RATE_PICCO=(int)ceil((MATRICE_TIPO_2[temp-1][0])*(VECT_PERCENT[temp+2])/(double)100);
    support->RATE_MEDIO=(int)ceil((MATRICE_TIPO_2[temp-1][1])*(VECT_PERCENT[temp+2])/(double)100);     
    support->TBD=MATRICE_TIPO_2[temp-1][2];
    support->L_IP=MATRICE_TIPO_2[temp-1][3];
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_2_DL[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    
    BANDE_TOTALI_MAC_DL[T-1]+=support->BANDA_MAC;
     //printf("\nB_MAC tipo 2 riferita al RT %d e' %d%\n",T,support->BANDA_MAC);
    }
   return (support->BANDA_MAC);
   
   }
else return 0;

}

int inserisci_simmetrica_TIPO2_DL(int T,int temp)
{
 pTIPO_2 support;

int BW_MAC=0;
BW_MAC=assegnazione_banda_simm_RT_TIPO2(T-1,temp);  //BW_MAC=assegnazione_banda_UL_TIPO2(T-1,temp);

if ((BANDA_TOTALE_UL+BW_MAC)<=CAPACITA_ALLOCABILE_GB_UL)
 {

VETTORE_SORGENTI_RT_UL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_UL[T-1].T2;
if (support==NULL)
{              
   VETTORE_SORGENTI_RT_UL[T-1].T2=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
   support=VETTORE_SORGENTI_RT_UL[T-1].T2;
   
   support->RATE_PICCO=(int)ceil((MATRICE_TIPO_2[temp-1][0])*(VECT_PERCENT[temp+2])/(double)100);
   support->RATE_MEDIO=(int)ceil((MATRICE_TIPO_2[temp-1][1])*(VECT_PERCENT[temp+2])/(double)100);   
   support->TBD=MATRICE_TIPO_2[temp-1][2];
   support->L_IP=MATRICE_TIPO_2[temp-1][3];
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
   support->D_MAX=VETTORE_RITARDI_TIPO_2_UL[temp-1];
   support->BANDA_MAC=BW_MAC;
   support->TNEXT=0;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
         
    BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 2 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);
   }
else             
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
    support->NEXT_SORG=(pTIPO_2)malloc(sizeof(struct SORGENTE_TIPO2));
    support=support->NEXT_SORG;
    
    support->RATE_PICCO=(int)ceil((MATRICE_TIPO_2[temp-1][0])*(VECT_PERCENT[temp+2])/(double)100);
    support->RATE_MEDIO=(int)ceil((MATRICE_TIPO_2[temp-1][1])*(VECT_PERCENT[temp+2])/(double)100);     
    support->TBD=MATRICE_TIPO_2[temp-1][2];
    support->L_IP=MATRICE_TIPO_2[temp-1][3];
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
    support->D_MAX=VETTORE_RITARDI_TIPO_2_UL[temp-1];
    support->BANDA_MAC=BW_MAC;
    support->TNEXT=0;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    
    BANDE_TOTALI_MAC_UL[T-1]+=support->BANDA_MAC;
    //printf("\nB_MAC tipo 2 assegnata al RT %d e' %d%\n",T,support->BANDA_MAC);
    }
   return (support->BANDA_MAC);
   
   }
else return 0;

}


void inserisci_simmetrica_TIPO3_UL(int T,int temp)
{
pTIPO_3 support;
VETTORE_SORGENTI_RT_DL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_DL[T-1].T3;
if (support==NULL)
   { 
   VETTORE_SORGENTI_RT_DL[T-1].T3=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
  
   support=VETTORE_SORGENTI_RT_DL[T-1].T3;
   
   support->FREQUENZA_MEDIA=(int)ceil((MATRICE_TIPO_3[temp-1][0])*(VECT_PERCENT[temp+5])/(double)100);  
   support->L_IP=MATRICE_TIPO_3[temp-1][1];  
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
   }
else            
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
  
    support->NEXT_SORG=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
    
    support=support->NEXT_SORG;    
    support->FREQUENZA_MEDIA=(int)ceil((MATRICE_TIPO_3[temp-1][0])*(VECT_PERCENT[temp+5])/(double)100);  
    support->L_IP=MATRICE_TIPO_3[temp-1][1];    
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_DL[T-1].S_ID;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    
    }
return;
}


void inserisci_simmetrica_TIPO3_DL(int T,int temp)
{
pTIPO_3 support;
VETTORE_SORGENTI_RT_UL[T-1].S_ID+=1;
support=VETTORE_SORGENTI_RT_UL[T-1].T3;
if (support==NULL)
   { 
   VETTORE_SORGENTI_RT_UL[T-1].T3=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
  
   support=VETTORE_SORGENTI_RT_UL[T-1].T3;
   
   support->FREQUENZA_MEDIA=(int)ceil((MATRICE_TIPO_3[temp-1][0])*(VECT_PERCENT[temp+5])/(double)100);  
   support->L_IP=MATRICE_TIPO_3[temp-1][1];
   support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
   support->PRIMO_MOMENTO=0;
   support->SECONDO_MOMENTO=0;
   support->NEXT_SORG=NULL;
   
   }
else            
    {
    while (support->NEXT_SORG!=NULL) support=support->NEXT_SORG;
  
    support->NEXT_SORG=(pTIPO_3)malloc(sizeof(struct SORGENTE_TIPO3));
    support=support->NEXT_SORG;
        
    support->FREQUENZA_MEDIA=(int)ceil((MATRICE_TIPO_3[temp-1][0])*(VECT_PERCENT[temp+5])/(double)100);  
    support->L_IP=MATRICE_TIPO_3[temp-1][1];    
    support->IDENTIFICATIVO=VETTORE_SORGENTI_RT_UL[T-1].S_ID;
    support->PRIMO_MOMENTO=0;
    support->SECONDO_MOMENTO=0;
    support->NEXT_SORG=NULL;
    
    }
return;
}




// PROCEDURA CHE CONTA LE SORGENTI INSERITE AL RADIO NODE
void CONTA_SORGENTI_RN()
{
int contaRT,contasorgenti1=0,contasorgenti2=0,contasorgenti3=0,VERIFICA=0;
pTIPO_1 support1;
pTIPO_2 support2;
pTIPO_3 support3;
for (contaRT=0;contaRT<NRT;contaRT++)
    {
    VERIFICA+=VETTORE_SORGENTI_RT_DL[contaRT].S_ID;
    support1=VETTORE_SORGENTI_RT_DL[contaRT].T1;
    while (support1!=NULL)
          {
          contasorgenti1++;
          support1=support1->NEXT_SORG;
          }
    support2=VETTORE_SORGENTI_RT_DL[contaRT].T2;
    while (support2!=NULL)
          {
          contasorgenti2++;
          support2=support2->NEXT_SORG;
          }
    support3=VETTORE_SORGENTI_RT_DL[contaRT].T3;
    while (support3!=NULL)
          {
          contasorgenti3++;
          support3=support3->NEXT_SORG;
          }
    }
    printf("\n\n----------------------------------------------------");
    printf("\nAL RADIO NODE SONO PRESENTI COMPLESSIVAMENTE:\n");
    printf("\n%d SORGENTI ON-OFF (TIPO 1)",contasorgenti1);
    printf("\n%d SORGENTI CBR (TIPO 2)",contasorgenti2);
    printf("\n%d SORGENTI BEST EFFORT (TIPO 3)",contasorgenti3);
    printf("\n%d SORGENTI TOTALI",VERIFICA);
    printf("\n----------------------------------------------------\n");
return;
}


// PROCEDURA CHE CONTA LE SORGENTI INSERITE AI RADIO TERMINALS
void CONTA_SORGENTI_RT()
{
int contaRT,contasorgenti1=0,contasorgenti2=0,contasorgenti3=0,VERIFICA=0;
pTIPO_1 support1;
pTIPO_2 support2;
pTIPO_3 support3;
for (contaRT=0;contaRT<NRT;contaRT++)
    {
    VERIFICA+=VETTORE_SORGENTI_RT_UL[contaRT].S_ID;
    support1=VETTORE_SORGENTI_RT_UL[contaRT].T1;
    while (support1!=NULL)
          {
          contasorgenti1++;
          support1=support1->NEXT_SORG;
          }
    support2=VETTORE_SORGENTI_RT_UL[contaRT].T2;
    while (support2!=NULL)
          {
          contasorgenti2++;
          support2=support2->NEXT_SORG;
          }
    support3=VETTORE_SORGENTI_RT_UL[contaRT].T3;
    while (support3!=NULL)
          {
          contasorgenti3++;
          support3=support3->NEXT_SORG;
          }
    }
    printf("\n\n----------------------------------------------------");
    printf("\nAI RADIO TERMINAL SONO PRESENTI COMPLESSIVAMENTE:\n");
    printf("\n%d SORGENTI ON-OFF (TIPO 1)",contasorgenti1);
    printf("\n%d SORGENTI CBR (TIPO 2)",contasorgenti2);
    printf("\n%d SORGENTI BEST EFFORT (TIPO 3)",contasorgenti3);
    printf("\n%d SORGENTI TOTALI",VERIFICA);
    printf("\n----------------------------------------------------\n");
return;
}






// INIZIALIZZAZIONE DELLE SORGENTI ON-OFF
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO1_DL(int RT)
{
pTIPO_1 p=VETTORE_SORGENTI_RT_DL[RT].T1;
double casuale;
int temp;
 while (p!=NULL)
      {
         // generazione numero random tra 0 compreso e 1 escluso
         casuale=random_real(1);//(double)rand()/(RAND_MAX+1);
         // normalizzazione tra T_ON e T_OFF
         casuale=casuale*((p->T_ON)+(p->T_OFF));
         // adesso 'casuale' simula se ci troviamo in un periodo di ON o di OFF
         if (casuale<p->T_ON)       // periodo di ON
            {
            temp=(int)ceil((p->RATE_PICCO)*casuale);
            p->BYTE=temp;
            p->TNEXT=0;
            }
         else                       // periodo di OFF
            {
            p->BYTE=0;
            p->TNEXT=(p->T_ON)+(p->T_OFF)-casuale;
            }
		 if (RT==1)
		 {
                  p->TNEXT=(p->T_ON+p->T_OFF)/2;
                 }
         p=p->NEXT_SORG;
    }
return;

}

// INIZIALIZZAZIONE DELLE SORGENTI CBR
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO2_DL(int RT)
{
pTIPO_2 p=VETTORE_SORGENTI_RT_DL[RT].T2;
double casuale;
while (p!=NULL)
      {
      casuale=random_real((p->L_IP)/(double)(p->RATE_PICCO));
      // variabile casuale inizializzata tra 0 e la durata in tempo del
      // pacchetto IP assegnato a quella sorgente
       p->TNEXT=casuale+((p->L_IP)/(double)(p->RATE_PICCO));
      //TNEXT in questo caso puo' essere visto come l'instante in cui
      //la sorgente ha finito di presentarci il primo pacchetto utile per la trasmissione.
      //Non si considerano i byte emessi dalla sorgente prima di questo pacchetto
      p=p->NEXT_SORG;
      }

return;

}


// INIZIALIZZAZIONE DELLE SORGENTI BEST EFFORT
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO3_DL(int RT)
{
pTIPO_3 p=VETTORE_SORGENTI_RT_DL[RT].T3;
while (p!=NULL)
      {
      p->TNEXT=POISSON(p->FREQUENZA_MEDIA);
      p=p->NEXT_SORG;
      }
     
return;
}



void inizializza_sorgenti_TIPO1_UL(int RT)
{
pTIPO_1 p=VETTORE_SORGENTI_RT_UL[RT].T1;
double casuale;
int temp;
	while (p!=NULL)
      {
         // generazione numero random tra 0 compreso e 1 escluso
         casuale=random_real(1);//(double)rand()/(RAND_MAX+1);
         // normalizzazione tra T_ON e T_OFF
         casuale=casuale*((p->T_ON)+(p->T_OFF));
         // adesso 'casuale' simula se ci troviamo in un periodo di ON o di OFF
         if (casuale<p->T_ON)       // periodo di ON
            {
            temp=(int)ceil((p->RATE_PICCO)*casuale);
            p->BYTE=temp;
            p->TNEXT=0;
            }
         else                       // periodo di OFF
            {
            p->BYTE=0;
            p->TNEXT=(p->T_ON)+(p->T_OFF)-casuale;
            }
		 if (RT==1)
		 {
			 p->TNEXT=(p->T_ON+p->T_OFF)/2;
		  }
         p=p->NEXT_SORG;
    }
return;

}

// INIZIALIZZAZIONE DELLE SORGENTI CBR
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO2_UL(int RT)
{
pTIPO_2 p=VETTORE_SORGENTI_RT_UL[RT].T2;
double casuale;
while (p!=NULL)
      {
      casuale=random_real((p->L_IP)/(double)(p->RATE_PICCO));
      // variabile casuale inizializzata tra 0 e la durata in tempo del
      // pacchetto IP assegnato a quella sorgente
       p->TNEXT=casuale+((p->L_IP)/(double)(p->RATE_PICCO));
      //TNEXT in questo caso puo' essere visto come l'instante in cui
      //la sorgente ha finito di presentarci il primo pacchetto utile per la trasmissione.
      //Non si considerano i byte emessi dalla sorgente prima di questo pacchetto
      p=p->NEXT_SORG;
      }

return;

}


// INIZIALIZZAZIONE DELLE SORGENTI BEST EFFORT
// viene passato il vettore di sorgenti interessato e l'indicatore del RT
void inizializza_sorgenti_TIPO3_UL(int RT)
{
pTIPO_3 p=VETTORE_SORGENTI_RT_UL[RT].T3;
while (p!=NULL)
      {
      p->TNEXT=POISSON(p->FREQUENZA_MEDIA);
      p=p->NEXT_SORG;
      }
     
return;
}


//PROCEDURE PER LA CREAZIONE DELLE MACPDU
void CREA_MACPDU_GB_DL(int DIMENSIONE,double MARCHIO,int RT,int ID,int OFFSET,int tipo_traffico)
{

BUFFER p;
int numero_MACPDU,conta;
numero_MACPDU=(int)ceil(DIMENSIONE/(double)PAYLOAD_AL);

   p=CODE_GB_RN[RT];
   CONT_IP_GB_RN[RT]+=1;
   CONT_MACPDU_GB_RN[RT]+=numero_MACPDU;
   
if (p==NULL)          // LISTA VUOTA
   {
   
      CODE_GB_RN[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_GB_RN[RT];
      
   }
else                  // LISTA NON VUOTA
   {
   while (p->NEXT_MACPDU!=NULL)   p=p->NEXT_MACPDU;
 
   p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
   p=p->NEXT_MACPDU;
   }
conta=1;
p->SORGENTE=ID;
p->T_GEN=MARCHIO;
p->TIPO_TRAFFICO=tipo_traffico;
p->NS_IP=CONT_IP_GB_RN[RT];
p->NS_MACPDU=conta+OFFSET;

while (conta<numero_MACPDU)
      {
      p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=p->NEXT_MACPDU;
      p->SORGENTE=ID;
      p->T_GEN=MARCHIO;
      p->TIPO_TRAFFICO=tipo_traffico;
      p->NS_IP=CONT_IP_GB_RN[RT];
      p->NS_MACPDU=conta+OFFSET;
      conta++;
      }
p->NEXT_MACPDU=NULL;

return;
}


void CREA_MACPDU_BE_DL(int DIMENSIONE,double MARCHIO,int RT,int ID,int tipo_traffico)

{

BUFFER p;
int numero_MACPDU,conta;
int lunghezza;

lunghezza=LUNGHEZZA_CODE_BE_DL[RT];  

if (lunghezza<CAPIENZA_BUFFER) 
{

numero_MACPDU=(int)ceil((double)DIMENSIONE/PAYLOAD_AL);

   p=CODE_BE_RN[RT];
   CONT_IP_BE_RN[RT]+=1;
   CONT_MACPDU_BE_RN[RT]+=numero_MACPDU;
   
   
if (p==NULL)          // LISTA VUOTA
   {
  
      CODE_BE_RN[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_BE_RN[RT];
      
   }
else                  // LISTA NON VUOTA
   {
   while (p->NEXT_MACPDU!=NULL) p=p->NEXT_MACPDU;
   p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
   p=p->NEXT_MACPDU;
   }

conta=1;
p->SORGENTE=ID;
p->T_GEN=MARCHIO;
p->TIPO_TRAFFICO=tipo_traffico;
p->NS_IP=CONT_IP_BE_RN[RT];
p->NS_MACPDU=conta;
lunghezza++;


while ((conta<numero_MACPDU)&&(lunghezza<(CAPIENZA_BUFFER)))
      {
      p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=p->NEXT_MACPDU;
      p->SORGENTE=ID;
      p->T_GEN=MARCHIO;
      p->TIPO_TRAFFICO=tipo_traffico;
      p->NS_IP=CONT_IP_BE_RN[RT]; //ORRORE!!
      p->NS_MACPDU=conta;
      conta++;
      lunghezza++;
      }
LUNGHEZZA_CODE_BE_DL[RT]=lunghezza;      
if ((lunghezza==(CAPIENZA_BUFFER))&&(conta<numero_MACPDU)) OVERFLOW_BE_HAPPENED_DL[RT]=1;
else OVERFLOW_BE_HAPPENED_DL[RT]=0;
//Abbiamo supposto che l'indicatore di overflow valga o 1 o 0 a seconda che sia avvenuto o meno OVERFLOW      
p->NEXT_MACPDU=NULL;

}

return;
}


void CREA_MACPDU_GB_UL(int DIMENSIONE,double MARCHIO,int RT,int ID,int OFFSET,int tipo_traffico)
{

BUFFER p;
int numero_MACPDU=0,conta;
numero_MACPDU=(int)ceil(DIMENSIONE/(double)PAYLOAD_AL);
 //printf("\nDIMENSIONE e' %d\n",DIMENSIONE);
 //printf("\nLe MAC PDU GB di tipo %d generate al tempo %lf dal RT %d sono %d\n",tipo_traffico,MARCHIO,RT+1,        numero_MACPDU);
 p=CODE_GB_RT[RT];
 CONT_IP_GB_RT[RT]+=1;
 CONT_MACPDU_GB_RT[RT]+=numero_MACPDU;
  
if (p==NULL)          // LISTA VUOTA
   {
   
      CODE_GB_RT[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_GB_RT[RT];
     
   
   }
else                  // LISTA NON VUOTA
   {
   while (p->NEXT_MACPDU!=NULL) p=p->NEXT_MACPDU;
   p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
   p=p->NEXT_MACPDU;
   }
conta=1;
p->SORGENTE=ID;
p->T_GEN=MARCHIO;
p->TIPO_TRAFFICO=tipo_traffico;
p->NS_IP=CONT_IP_GB_RT[RT];
p->NS_MACPDU=conta+OFFSET;
while (conta<numero_MACPDU)
      {
      p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=p->NEXT_MACPDU;
      p->SORGENTE=ID;
      p->T_GEN=MARCHIO;
      p->TIPO_TRAFFICO=tipo_traffico;
      p->NS_IP=CONT_IP_GB_RT[RT];
      p->NS_MACPDU=conta+OFFSET;
      conta++;
     
      }
p->NEXT_MACPDU=NULL;
//printf("\nIl numero delle MAC PDU GB per l'uplink  %d\n",numero_MACPDU);
return;
}

void CREA_MACPDU_BE_UL(int DIMENSIONE,double MARCHIO,int RT,int ID,int tipo_traffico)

{

BUFFER p;
int numero_MACPDU,conta,lunghezza;

lunghezza=LUNGHEZZA_CODE_BE_UL[RT];  

if (lunghezza<CAPIENZA_BUFFER) 
{

numero_MACPDU=(int)ceil((double)DIMENSIONE/PAYLOAD_AL);
   //printf("\nDIMENSIONE e' %d\n",DIMENSIONE);
   //printf("\nLe MAC PDU BE di tipo %d generate al tempo %lf dal RT %d sono %d\n",tipo_traffico,MARCHIO,RT+1,         numero_MACPDU);
   p=CODE_BE_RT[RT];
   CONT_IP_BE_RT[RT]+=1;
   CONT_MACPDU_BE_RT[RT]+=numero_MACPDU;
  
if (p==NULL)          // LISTA VUOTA
   {
   
      CODE_BE_RT[RT]=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=CODE_BE_RT[RT];
     
   }
else                  // LISTA NON VUOTA
   {
   while (p->NEXT_MACPDU!=NULL) p=p->NEXT_MACPDU;
   p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
   p=p->NEXT_MACPDU;
   }
conta=1;
p->SORGENTE=ID;
p->T_GEN=MARCHIO;
p->TIPO_TRAFFICO=tipo_traffico;
p->NS_IP=CONT_IP_BE_RT[RT];
p->NS_MACPDU=conta;

lunghezza++;

while ((conta<numero_MACPDU)&&(lunghezza<(CAPIENZA_BUFFER)))
      {
      p->NEXT_MACPDU=(BUFFER)malloc(sizeof(struct MAC_PDU));
      p=p->NEXT_MACPDU;
      p->SORGENTE=ID;
      p->T_GEN=MARCHIO;
      p->TIPO_TRAFFICO=tipo_traffico;
      p->NS_IP=CONT_IP_BE_RT[RT];
      p->NS_MACPDU=conta;
      conta++;
      lunghezza++;
      }

LUNGHEZZA_CODE_BE_UL[RT]=lunghezza;      
if ((lunghezza==(CAPIENZA_BUFFER))&&(conta<numero_MACPDU)) OVERFLOW_BE_HAPPENED_UL[RT]=1;
else OVERFLOW_BE_HAPPENED_UL[RT]=0;
//Abbiamo supposto che l'indicatore di overflow valga o 1 o 0 a seconda che sia avvenuto o meno OVERFLOW      
p->NEXT_MACPDU=NULL;
}
//printf("\nIl numero delle MAC PDU BE per l'uplink  %d\n",numero_MACPDU);
return;
}


// PROCEDURE DI GENERAZIONE TRAFFICO IN DOWNLINK
// TRAFFICO ON-OFF
void GENERA_TRAFFICO_TIPO1_DL(int RT, double tempo)
{
pTIPO_1 p;
int appoggio;
int conta_TOFF=0;
int tipo_traffico=1;
double T_AUX=0;
int centra;
p=VETTORE_SORGENTI_RT_DL[RT].T1;

while (p!=NULL)
      {
      while ((p->TNEXT)<tempo)
            {
            if ((double)(p->BYTE)<((p->RATE_PICCO)*(p->T_ON)))
               {
               if ((double)((p->BYTE)+(p->L_IP))>((p->RATE_PICCO)*(p->T_ON)))
                  {
                  // Abbiamo sforato, forse anche parecchio
                  centra=(int)ceil((p->RATE_PICCO)*(p->T_ON))-(p->BYTE);
                  appoggio=p->L_IP-centra;
                  conta_TOFF=(int)(floor)(appoggio/((p->T_ON)*(p->RATE_PICCO)));
                  appoggio=(int)(appoggio-((conta_TOFF)*(ceil)((p->T_ON)*(p->RATE_PICCO))));
                   //Ora in appoggio c' l'ultimo gruppo di bytes  del pacchetto
                  p->TNEXT=p->TNEXT+(centra/p->RATE_PICCO)+p->T_OFF+(conta_TOFF*(p->T_OFF+p->T_ON))+(appoggio/p->RATE_PICCO);		
                  p->BYTE=p->BYTE+p->L_IP;                 
                  }
               else
                  {
                  // Non abbiamo sforato
                  T_AUX=(p->TNEXT)+(p->L_IP)/(double)(p->RATE_PICCO);
                  CREA_MACPDU_GB_DL(p->L_IP,T_AUX,RT,p->IDENTIFICATIVO,0,tipo_traffico);
                  p->BYTE+=p->L_IP;
                  p->TNEXT=T_AUX;
                 
                  }
               }
            else
               {
               conta_TOFF=(int)(floor)(p->BYTE/((p->T_ON)*(p->RATE_PICCO)));
               p->BYTE=(int)(p->BYTE-(conta_TOFF)*((ceil)((p->T_ON)*(p->RATE_PICCO))));
               CREA_MACPDU_GB_DL(p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,0,tipo_traffico);            
               }
            }
      p=p->NEXT_SORG;
      }
//printf("\nFine generazione traffico ON/OFF al RT %d con tempo fine TS %lf\n",RT+1,tempo); 
return;
}


// TRAFFICO CBR
void GENERA_TRAFFICO_TIPO2_DL(int RT, double tempo)
{
int tipo_traffico=2;
pTIPO_2 p;
p=VETTORE_SORGENTI_RT_DL[RT].T2;
while (p!=NULL)
      {
      while (p->TNEXT<=tempo)
      {
          CREA_MACPDU_GB_DL(p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,0,tipo_traffico);
          p->TNEXT+=((p->L_IP)/(double)(p->RATE_PICCO));
          
      }
      p=p->NEXT_SORG;
      }
//printf("\nFine generazione traffico CBR al RT %d con tempo fine TS %lf\n",RT+1,tempo);
return;
}

// TRAFFICO BEST EFFORT
void  GENERA_TRAFFICO_TIPO3_DL(int RT, double tempo)
{
pTIPO_3 p;
int tipo_traffico=3;
p=VETTORE_SORGENTI_RT_DL[RT].T3;
    
while (p!=NULL)
      {
      while (p->TNEXT<=tempo)
            {
            CREA_MACPDU_BE_DL(p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,tipo_traffico);
            p->TNEXT+=POISSON(p->FREQUENZA_MEDIA);
            }
      p=p->NEXT_SORG;
      }
//printf("\nFine generazione traffico BE al RT %d con tempo fine TS %lf\n",RT+1,tempo);
return;
}



// PROCEDURE DI GENERAZIONE TRAFFICO IN UPLINK
// TRAFFICO ON-OFF
void GENERA_TRAFFICO_TIPO1_UL(int RT, double tempo)
{
pTIPO_1 p;
int appoggio;
int conta_TOFF=0;
int tipo_traffico=1;
double T_AUX=0;
int centra;
p=VETTORE_SORGENTI_RT_UL[RT].T1;


while (p!=NULL)
      {
      while ((p->TNEXT)<tempo)
            {
            if ((double)(p->BYTE)<((p->RATE_PICCO)*(p->T_ON)))
               {
               if ((double)((p->BYTE)+(p->L_IP))>((p->RATE_PICCO)*(p->T_ON)))
                  {
                  // Abbiamo sforato, forse anche parecchio
                  centra=(int)ceil((p->RATE_PICCO)*(p->T_ON))-(p->BYTE);
                  appoggio=p->L_IP-centra;
                  conta_TOFF=(int)(floor)(appoggio/((p->T_ON)*(p->RATE_PICCO)));
                  appoggio=(int)(appoggio-((conta_TOFF)*(ceil)((p->T_ON)*(p->RATE_PICCO))));
                   //Ora in appoggio c' l'ultimo gruppo di bytes  del pacchetto
                  p->TNEXT=p->TNEXT+(centra/p->RATE_PICCO)+p->T_OFF+(conta_TOFF*(p->T_OFF+p->T_ON))+(appoggio/p->RATE_PICCO);		
                  p->BYTE=p->BYTE+p->L_IP;                 
                  }
               else
                  {
                  // Non abbiamo sforato
                  T_AUX=(p->TNEXT)+(p->L_IP)/(double)(p->RATE_PICCO);
                  CREA_MACPDU_GB_UL(p->L_IP,T_AUX,RT,p->IDENTIFICATIVO,0,tipo_traffico);
                  p->BYTE+=p->L_IP;
                  p->TNEXT=T_AUX;
                 
                  }
               }
            else
               {
               conta_TOFF=(int)(floor)(p->BYTE/((p->T_ON)*(p->RATE_PICCO)));
               p->BYTE=(int)(p->BYTE-(conta_TOFF)*((ceil)((p->T_ON)*(p->RATE_PICCO))));
               CREA_MACPDU_GB_UL(p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,0,tipo_traffico);            
               }
            }
      p=p->NEXT_SORG;
      }
//printf("\nFine generazione traffico ON/OFF al RT %d con tempo fine TS %lf\n",RT+1,tempo); 
return;
}



// TRAFFICO CBR
void GENERA_TRAFFICO_TIPO2_UL(int RT, double tempo)
{
int tipo_traffico=2;
pTIPO_2 p;
p=VETTORE_SORGENTI_RT_UL[RT].T2;
while (p!=NULL)
      {
      while (p->TNEXT<=tempo)
      {
          CREA_MACPDU_GB_UL(p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,0,tipo_traffico);
          p->TNEXT+=((p->L_IP)/(double)(p->RATE_PICCO));
	  }
      p=p->NEXT_SORG;
      }
//printf("\nTraffico CBR generato in uplink\n");
return;
}

// TRAFFICO BEST EFFORT
void  GENERA_TRAFFICO_TIPO3_UL(int RT, double tempo)
{
pTIPO_3 p;
int tipo_traffico=3;
p=VETTORE_SORGENTI_RT_UL[RT].T3;
while (p!=NULL)
      {
      while (p->TNEXT<=tempo)
            {
            CREA_MACPDU_BE_UL(p->L_IP,p->TNEXT,RT,p->IDENTIFICATIVO,tipo_traffico);
            p->TNEXT+=POISSON(p->FREQUENZA_MEDIA);
            }
      p=p->NEXT_SORG;
      }
//printf("\nTraffico BE generato in uplink\n");
return;
}



// PROCEDURA PER LA COSTRUZIONE DELLA MATRICE DI TRASMISSIONE CHE SERVE PER LA MEMORIZZAZIONE DELLE PDU DI CLASSE
// GB E BE CHE DEVONO ESSERE TRASMESSE NEL DOWNLINK.LE MAC-PDU DI CLASSE GB E DI CLASSE BE CHE DEVONO ESSERE TRASMESSE
// SARANNO INVIDUABILI UNIVOCAMENTE ALL'INTERNO DELLA MATRICE TRAMITE L'IDENTIFICATIVO DEL RT E DEL TS.


void costruisci_TRASMISSIONE_DL()
{
int i,j;
for (i=0;i<K;i++)
 {
 for (j=0;j<NTS_DL;j++)
   {
    if (MATRICE_CODICI[i][j].TIPO==1) TRASMISSIONE_DL[(MATRICE_CODICI[i][j].RT)-1][j].GB+=1 ;

    else if (MATRICE_CODICI[i][j].TIPO==2) TRASMISSIONE_DL[(MATRICE_CODICI[i][j].RT)-1][j].BE+=1 ; 
    //TIPO  uguale a 2:TRAFFICO BE
   } 
 }

//printf("\nTrasmissione DL costruita\n");
return;
}







int ASSEGNA_RISORSE_DL(FILE* MAT_CODICI)
{
int TUTTI_CONTENTI=0,PDU_ANCORA_ASSEGNABILI=NTS_DL*K-SEGNALAZIONE_DL;
int i,j;

//PRIMO STEP DELLO SCHEDULING: ASSEGNA IL DOVUTO ALLE CONNESSIONI DIRETTE AI DIVERSI RT
for(i=0;i<NRT;i++)
{
  ASSEGNAZIONE_DL[i].GB=minimo(BANDE_TOTALI_MAC_DL[i],(int)STATO_CODE_AL_RN[i].LUNG1);

fprintf(MAT_CODICI,"\n\nRT %d : Bande totali MAC GB DL e' %d e stato code GB al RN e' %d\n",i+1,BANDE_TOTALI_MAC_DL[i],(int)STATO_CODE_AL_RN[i].LUNG1);

fprintf(MAT_CODICI,"\n\nRT %d : Stato code BE al RN e' %d\n",i+1,(int)STATO_CODE_AL_RN[i].LUNG2);
//printf("\nL'assegnazione GB DL al RT %d e' %d\n",i+1,ASSEGNAZIONE_DL[i].GB);
STATO_CODE_AL_RN[i].LUNG1-=ASSEGNAZIONE_DL[i].GB;
PDU_ANCORA_ASSEGNABILI-=ASSEGNAZIONE_DL[i].GB;
}



//SECONDO (FU TERZO) STEP DELLO SCHEDULING: ASSEGNA UNA MAC PDU AD OGNI RT FINCHE' NON CI SONO
// PIU' MAC PDU DA POTER ASSEGNARE OPPURE NON CI SONO PIU' RICHIESTE BE IN ATTESA
i=INIZIO_ROUND_ROBIN_BE_DL;
while((PDU_ANCORA_ASSEGNABILI!=0)&&(TUTTI_CONTENTI<NRT))
{
//printf("\nTERZO STEP dello SCHEDULING\n");
//printf("\nPDU ancora assegnabili= %d,i RT felici x ora sono %d su %d\n",PDU_ANCORA_ASSEGNABILI,TUTTI_CONTENTI,NRT);
 if (STATO_CODE_AL_RN[i].LUNG2!=0)
   {
     ASSEGNAZIONE_DL[i].BE+=1;
     STATO_CODE_AL_RN[i].LUNG2-=1;
     PDU_ANCORA_ASSEGNABILI-=1;
   }
 else
    {
        if (STATO_CODE_AL_RN[i].BUFFER_VUOTI!=1)
        // IL RR ASSEGNA UNA MAC PDU A OGNI RT IN ORDINE A PARTIRE DA INIZIO_ROUND_ROBIN.
        // QUINDI RIPASSERO' PIU' VOLTE PER LO STESSO RT E SERVE SAPERE SE QUESTO RT
        // HA ANCORA QUALCHE PDU NEI BUFFER
          {
           TUTTI_CONTENTI+=1;
           STATO_CODE_AL_RN[i].BUFFER_VUOTI=1;
           }
     }

 i=(i+1)%(NRT); //PER CONTINUARE IL ROUND ROBIN CICLANDO DALL'INIZIO
}

//LA PROSSIMA TRAMA REINIZIERO' IL ROUND ROBIN DAL RT SUCCESSIVO A QUELLO DOVE
//MI SONO FERMATO NELLA TRAMA CORRENTE
INIZIO_ROUND_ROBIN_BE_DL=i;

for(j=0;j<NRT;j++)
{
 STATO_CODE_AL_RN[j].BUFFER_VUOTI=0;
}

TUTTI_CONTENTI=0;

//TERZO (FU SECONDO) STEP DELLO SCHEDULING: ASSEGNA UNA MAC PDU AD OGNI RT FINCHE' NON CI SONO
// PIU' MAC PDU DA POTER ASSEGNARE OPPURE NON CI SONO PIU' RICHIESTE GB IN ATTESA
i=INIZIO_ROUND_ROBIN_GB_DL;

while((PDU_ANCORA_ASSEGNABILI!=0) && (TUTTI_CONTENTI<NRT))
{
//printf("\nSECONDO STEP dello SCHEDULING\n");
//printf("\nPDU ancora assegnabili= %d,i RT felici x  ora sono %d su %d\n", PDU_ANCORA_ASSEGNABILI,TUTTI_CONTENTI,NRT);
 if (STATO_CODE_AL_RN[i].LUNG1!=0)
   {
     ASSEGNAZIONE_DL[i].GB+=1;
     STATO_CODE_AL_RN[i].LUNG1-=1;
     PDU_ANCORA_ASSEGNABILI-=1;
   }
 else
    {
        if (STATO_CODE_AL_RN[i].BUFFER_VUOTI!=1)
        // IL RR ASSEGNA UNA MAC PDU A OGNI RT IN ORDINE A PARTIRE DA INIZIO_ROUND_ROBIN.
        // QUINDI RIPASSERO' PIU' VOLTE PER LO STESSO RT E SERVE SAPERE SE QUESTO RT
        // HA ANCORA QUALCHE PDU NEI BUFFER
          {
           TUTTI_CONTENTI+=1;
           STATO_CODE_AL_RN[i].BUFFER_VUOTI=1;
           }
     }

 i=(i+1)%(NRT); //PER CONTINUARE IL ROUND ROBIN CICLANDO DALL'INIZIO
}
 
INIZIO_ROUND_ROBIN_GB_DL=i;
//LA PROSSIMA TRAMA REINIZIERO' IL ROUND ROBIN DAL RT SUCCESSIVO A QUELLO DOVE
//MI SONO FERMATO NELLA TRAMA CORRENTE

for(j=0;j<NRT;j++)
{
 STATO_CODE_AL_RN[j].BUFFER_VUOTI=0;
}


return(0);
}



// PROCEDURA PER LA COSTRUZIONE DEL VETTORE DI TRASMISSIONE CHE SERVE PER LA 
// MEMORIZZAZIONE DELLE PDU DI CLASSE GB E BE CHE DEVONO ESSERE TRASMESSE
// NELL'UPLINK.LE MAC-PDU DI CLASSE GB E DI CLASSE BE CHE DEVONO ESSERE
// TRASMESSE SARANNO INVIDUABILI UNIVOCAMENTE ALL'INTERNO DEL VETTORE TRAMITE
// L'IDENTIFICATIVO DEL TIPO(GB O BE) E DEL RT A CUI APPARTENGONO.


void costruisci_TRASMISSIONE_UL()
{
 int i;
 for (i=0;i<NTS_UL;i++)
 {
  if (VETTORE_TS[i].TIPO=='G') TRASMISSIONE_UL[(VETTORE_TS[i].RT)-1][i].GB+=1;        
  else  
      if (VETTORE_TS[i].TIPO=='E') TRASMISSIONE_UL[(VETTORE_TS[i].RT)-1][i].BE+=1;                               
 }
//printf("\nTrasmissione UL costruita\n");
return;
}









int ASSEGNA_RISORSE_UL()
{
int TUTTI_CONTENTI=0,PDU_ANCORA_ASSEGNABILI=NTS_UL-SEGNALAZIONE_UL;
int i,j;

//PRIMO STEP DELLO SCHEDULING: ASSEGNA IL DOVUTO ALLE CONNESSIONI DIRETTE AI DIVERSI RT
for(i=0;i<NRT;i++)
{
  ASSEGNAZIONE_UL[i].GB=minimo(BANDE_TOTALI_MAC_UL[i],(int)REQUEST_CHANNEL[i].LUNG1);
  //printf("l'assegnazione UL al RT %d  %d\n",i+1,ASSEGNAZIONE_UL[i].GB);
  REQUEST_CHANNEL[i].LUNG1-=ASSEGNAZIONE_UL[i].GB;
  PDU_ANCORA_ASSEGNABILI-=ASSEGNAZIONE_UL[i].GB;
}


//SECONDO (FU TERZO) STEP DELLO SCHEDULING: ASSEGNA UNA MAC PDU AD OGNI RT FINCHE' NON CI SONO
// PIU' MAC PDU DA POTER ASSEGNARE OPPURE NON CI SONO PIU' RICHIESTE BE IN ATTESA
i=INIZIO_ROUND_ROBIN_BE_UL;
while((PDU_ANCORA_ASSEGNABILI!=0)&&(TUTTI_CONTENTI<NRT))
{//conta le trame simulate
 

 if (REQUEST_CHANNEL[i].LUNG2!=0)
   {
     ASSEGNAZIONE_UL[i].BE+=1;
     REQUEST_CHANNEL[i].LUNG2-=1;
     PDU_ANCORA_ASSEGNABILI-=1;
   }
 else
    {
        if (REQUEST_CHANNEL[i].BUFFER_VUOTI!=1)
        // IL RROBIN ASSEGNA UNA MAC PDU A OGNI RT IN ORDINE A PARTIRE DA INIZIO_ROUND_ROBIN.
        // QUINDI RIPASSERA' PIU' VOLTE PER LO STESSO RT E SERVE SAPERE SE QUESTO RT
        // HA ANCORA QUALCHE PDU NEI BUFFER
          {
           TUTTI_CONTENTI+=1;
           REQUEST_CHANNEL[i].BUFFER_VUOTI=1;
           
           }
     }

 i=(i+1)%(NRT); //PER CONTINUARE IL ROUND ROBIN CICLANDO DALL'INIZIO
}
//LA PROSSIMA TRAMA REINIZIERO' IL ROUND ROBIN DAL RT SUCCESSIVO A QUELLO DOVE
// MI SONO FERMATO NELLA TRAMA CORRENTE
INIZIO_ROUND_ROBIN_BE_UL=i;

for(j=0;j<NRT;j++)
 REQUEST_CHANNEL[j].BUFFER_VUOTI=0;

TUTTI_CONTENTI=0;

//TERZO (FU SECONDO) STEP DELLO SCHEDULING: ASSEGNA UNA MAC PDU AD OGNI RT FINCHE' NON CI SONO
// PIU' MAC PDU DA POTER ASSEGNARE OPPURE NON CI SONO PIU' RICHIESTE GB IN ATTESA
i=INIZIO_ROUND_ROBIN_GB_UL;

while((PDU_ANCORA_ASSEGNABILI!=0) && (TUTTI_CONTENTI<NRT))
{
 if (REQUEST_CHANNEL[i].LUNG1!=0)
   {
     ASSEGNAZIONE_UL[i].GB+=1;
     REQUEST_CHANNEL[i].LUNG1-=1;
     PDU_ANCORA_ASSEGNABILI-=1;
   }
 else
    {
        if (REQUEST_CHANNEL[i].BUFFER_VUOTI!=1)
        // IL ROUND ROBIN ASSEGNA UNA MAC PDU A OGNI RT IN ORDINE A PARTIRE DA
        // INIZIO_ROUND_ROBIN. QUINDI RIPASSERA' PIU' VOLTE PER LO STESSO RT E 
        //SERVE SAPERE SE QUESTO RT HA ANCORA QUALCHE PDU NEI BUFFER
          {
           TUTTI_CONTENTI+=1;
           REQUEST_CHANNEL[i].BUFFER_VUOTI=1;
           }
     }

 i=(i+1)%(NRT); //PER CONTINUARE IL ROUND ROBIN CICLANDO DALL'INIZIO
}

INIZIO_ROUND_ROBIN_GB_UL=i;
//LA PROSSIMA TRAMA REINIZIERO' IL ROUND ROBIN DAL RT SUCCESSIVO A QUELLO DOVE
// MI SONO FERMATO NELLA TRAMA CORRENTE

for(j=0;j<NRT;j++)
//{
 REQUEST_CHANNEL[j].BUFFER_VUOTI=0;
//}


return(0);
}





void ELABORA_STATO_CODE_DL(int RT,BUFFER p_GB,BUFFER q_BE ,int cont)
{
   	int temp1=0;
	int temp2=0;
	int appoggio;

    temp1=NUMERO_ELEMENTI_CODA(p_GB);
    appoggio=TRASMISSIONE_DL[RT][cont].GB+TRASMISSIONE_DL[RT][cont+1].GB;
    STATO_CODE_AL_RN[RT].LUNG1=(double)massimo(0,temp1-appoggio);
	if ((temp1!=0) || (appoggio!=0))
    	{	
	//printf("\n\nPer il RT %d\n\n",RT+1);
        //printf("\nNUMERO ELEMENTI IN CODA GB e' %d\n",temp1);
        //printf("\nNumero MAC PDU non trasmesse ma gia' organizzate per la trasmissione e' %d\n",appoggio);
	//printf("\nNUMERO ELEMENTI IN CODA - RESIDUI DA TX e' %d\n",temp1-appoggio);
        //printf("\nSTATO CODE GB e' %d\n",(int)STATO_CODE_AL_RN[RT].LUNG1);
	}


    temp2=NUMERO_ELEMENTI_CODA(q_BE);
    appoggio=TRASMISSIONE_DL[RT][cont].BE+TRASMISSIONE_DL[RT][cont+1].BE;
    STATO_CODE_AL_RN[RT].LUNG2=(double)massimo(0,temp2-appoggio);
    if ((temp2!=0) || (appoggio!=0))
    {
    //printf("\n\nPer il RT %d\n\n",RT+1);
    //printf("\nNUMERO ELEMENTI IN CODA BE e' %d\n",temp2);
    //printf("\nNumero MAC PDU non trasmesse ma gia' organizzate per la trasmissione e' %d\n",appoggio);
    //printf("\nNUMERO ELEMENTI IN CODA - RESIDUI DA TX e' %d\n",temp2-appoggio);
    //printf("\nSTATO CODE BE e' %d\n",(int)STATO_CODE_AL_RN[RT].LUNG2);
    }

return;
}



//LE SEGUENTI PRECEDURE ELABORANO LO STATO DELLE CODE E GESTISCONO LA
// TRASMISSIONE DELLE MACPDU "GB" E "BE"

void ELABORA_STATO_CODE_UL (int RT,BUFFER p_GB,BUFFER p_BE)
{
 int temp1=0,temp2=0,temp3=0,somma=0;
 temp1=NUMERO_ELEMENTI_CODA(p_GB);
 temp2=NUMERO_ELEMENTI_CODA(p_BE);
 //printf("IL NUMERO DEGLI ELEMENTI GB IN CODA PER IL RT %d E' :%d\n",RT+1,temp1);
 //printf("IL NUMERO DEGLI ELEMENTI BE IN CODA PER IL RT %d E' :%d\n",RT+1,temp2);
 somma=temp1+temp2;
 //printf("TOTALMENTE SI HANNO %d MACPDU GIA'ORGANIZZATE E DA TRASMETTERE PER IL RT %d\n",temp3,RT+1);
 REQUEST_CHANNEL[RT].LUNG1=(double)massimo(0,temp1);
 REQUEST_CHANNEL[RT].LUNG2=(double)massimo(0,temp2);
return;
}




//PROCEDURA CHE ASSEGNA IN MODO RANDOM LE MAC PDU AI VARI RT.
//IL NUMERO DI MAC PDU ASSEGNATE AI VARI RT E' INVECE DECISO
//DALLA PROCEDURA "ASSEGNA_RISORSE_DL".
//AD OGNI FINE TRAMA LA "MATRICE_CODICI" VA REINIZIALIZZATA.



void riempi_MATRICE_CODICI()
{
int RT,i,TS_ASSEGNATO,CODICE_ASSEGNATO;

inizializza_SITUAZIONE_TS_DL();


//INIZIO L'ASSEGNAZIONE RANDOM DELLE MAC PDU DA "RT" SCELTO IN MODO CASUALE
RT=random_int(NRT); // 0<=RT<=NRT-1   
//printf("\nil valore di RT scelto e' %d\n",RT+1);
for (i=0;i<NRT;i++)
{	
	//printf("\nASSEGNAZIONE DL GB PER IL RT %d VALE %d\n",RT+1,ASSEGNAZIONE_DL[RT].GB);
	while (ASSEGNAZIONE_DL[RT].GB!=0)
        {   

        TS_ASSEGNATO=random_int(NTS_DL);
 	while (TS_PIENO(TS_ASSEGNATO)==1)
         //TS_ASSEGNATO RESTITUISCE "1"  SE IL TS HA TUTTI I CODICI ASSEGNATI
     	{
      	TS_ASSEGNATO=(TS_ASSEGNATO+1)%(NTS_DL);
     	}
	
        CODICE_ASSEGNATO=random_int(K);

        while (CODICE_PIENO(TS_ASSEGNATO,CODICE_ASSEGNATO)==1)
        //CODICE_PIENO RESTITUISCE "1" SE QUELLA COPPIA <TS,CODICE> E' STATA ASSEGNATA
        {
        CODICE_ASSEGNATO=(CODICE_ASSEGNATO+1)%(K);
        }
        //printf("\n IL CODICE ASSEGNATO IS THE NUMBER %d \n",CODICE_ASSEGNATO);
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].RT=RT+1;
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO=1;
        //CLASSE puo' essere utile
        //CLASSE=MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO;
        if (((cont_trame+1)>=INIZIO_ANALISI_DL)&&((cont_trame+1)<=FINE_ANALISI_DL))
        {
		 //Numero di volte che un certo codice e' assegnato al particolare RT
		 hyst_CODICE_PROBABILE_GB[RT][CODICE_ASSEGNATO]+=1;
                 normalizza_COD_PROBABILE_GB[RT]+=1;
        }

        //AGGIUNGO IL CODICE ASSEGNATO A QUEL RT IN QUEL TS
          AGGIUNGI_RISORSA_DL(PAGING_CHANNEL,CODICE_ASSEGNATO,RT,TS_ASSEGNATO);

        ASSEGNAZIONE_DL[RT].GB-=1;
		SITUAZIONE_TS_DL[TS_ASSEGNATO]+=1;

	}
      while (ASSEGNAZIONE_DL[RT].BE!=0)
    {   
  
        TS_ASSEGNATO=random_int(NTS_DL);
    	while (TS_PIENO(TS_ASSEGNATO)==1)
     	{
      	TS_ASSEGNATO=(TS_ASSEGNATO+1)%(NTS_DL);
     	}
        //printf("\n IL TS ASSEGNATO IS THE NUMBER %d \n",TS_ASSEGNATO);
        CODICE_ASSEGNATO=random_int(K);

        while (CODICE_PIENO(TS_ASSEGNATO,CODICE_ASSEGNATO)==1)
        {
        CODICE_ASSEGNATO=(CODICE_ASSEGNATO+1)%(K);
		//printf("\nTRAMA %d\n",cont_trame+1);
		//printf("\nTS assegnato %d ha situazione %d\n",TS_ASSEGNATO,(SITUAZIONE_TS_DL[TS_ASSEGNATO]));
		//printf("\nIl codice %d appartiene al RT %d\n",CODICE_ASSEGNATO,MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].RT);
		
        }
		//printf("\n IL CODICE ASSEGNATO IS THE NUMBER %d \n",CODICE_ASSEGNATO);
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].RT=RT+1;
        MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO=2;
        //CLASSE puo' essere utile
        //CLASSE=MATRICE_CODICI[CODICE_ASSEGNATO][TS_ASSEGNATO].TIPO;
		
        if (((cont_trame+1)>=INIZIO_ANALISI_DL)&&((cont_trame+1)<=FINE_ANALISI_DL))
        {
        //Numero di volte che un certo codice e' assegnato al particolare RT
        hyst_CODICE_PROBABILE_BE[RT][CODICE_ASSEGNATO]+=1;
        normalizza_COD_PROBABILE_BE[RT]+=1;
        }


       //AGGIUNGO IL CODICE ASSEGNATO A QUEL RT IN QUEL TS
       AGGIUNGI_RISORSA_DL(PAGING_CHANNEL,CODICE_ASSEGNATO,RT,TS_ASSEGNATO);
		ASSEGNAZIONE_DL[RT].BE-=1;
		SITUAZIONE_TS_DL[TS_ASSEGNATO]+=1;
    }
    RT=(RT+1)%(NRT);

}

//printf("\nRIEMPI MATRICE DEI CODICI ESEGUITA\n");
return;
}


//PROCEDURA DUALE DELLA PRECEDENTE,VALIDA PER L'UPLINK
void riempi_VETTORE_TS()
{
 int i,RT,TS,j;
 
 inizializza_VETTORE_TS();
 RT=random_int(NRT);
 for (i=0;i<NRT;i++)
  {	
    while (ASSEGNAZIONE_UL[RT].GB!=0)
    {   
        TS=random_int(NTS_UL);
	
        while (TS_OCCUPATO(TS)==1)
        {   
         // for(j=0;j<NTS_UL;j++)         printf("%d ",VETTORE_TS[j].RT);
          
           //printf("\n\n");
             
              TS=(TS+1)%(NTS_UL);
           
        }
                
        VETTORE_TS[TS].RT=RT+1;
        VETTORE_TS[TS].TIPO='G';
        AGGIUNGI_TS(LISTA_ALL_CH_UL,RT+1,TS+1);
        	
        if (((cont_trame+1)>=INIZIO_ANALISI_UL)&&((cont_trame+1)<=FINE_ANALISI_UL))    
            hyst_RT_TS[RT][TS]+=1;
         
        ASSEGNAZIONE_UL[RT].GB-=1;
       

     }
     
    while (ASSEGNAZIONE_UL[RT].BE!=0)
    {      
        TS=random_int(NTS_UL);
	
        while (TS_OCCUPATO(TS)==1)   
      	    TS=(TS+1)%(NTS_UL);
                 
        VETTORE_TS[TS].RT=RT+1;
        VETTORE_TS[TS].TIPO='E';
        AGGIUNGI_TS(LISTA_ALL_CH_UL,RT+1,TS+1); 

        if (((cont_trame+1)>=INIZIO_ANALISI_UL)&&((cont_trame+1)<=FINE_ANALISI_UL))       hyst_RT_TS[RT][TS]+=1;
         
        ASSEGNAZIONE_UL[RT].BE-=1;
       

     }
   
    RT=(RT+1)%(NRT);
   }

// printf("VETTORE DEI TIME SLOT RIEMPITO");
 
}  



//CALCOLA STIME DEI RITARDI MEDI E DELLE VARIANZE IN BASE AL TEMPO ASSOLUTO E
//AL CAMPO "T_GEN" DELLE MAC PDU.
//QUESTA PROCEDURA VIENE CHIAMATA AD OGNI TS E AGGIORNA LE STATISTICHE.
 void CALCOLA_STATISTICHE_BASE_TS_DL(double t,int RT,BUFFER p_GB,BUFFER q_BE,int numero_GB,int numero_BE)
{
 double ritardo=0;
 int ritardo_in_TS=0;

 // CALCOLO LE STATISTICHE PER LA CLASSE GB

BUFFER p=p_GB;
BUFFER q=q_BE;
pTIPO_1 p1;
pTIPO_2 p2;
pTIPO_3 p3;


if (numero_GB>CAPIENZA_BUFFER) hyst_riempimento_GB_DL[RT][CAPIENZA_BUFFER+1]+=1;
else hyst_riempimento_GB_DL[RT][numero_GB]+=1;


while (p!=NULL)
{
 ritardo=t-(p->T_GEN);
 
  if (p->TIPO_TRAFFICO==1)
   {
   p1=VETTORE_SORGENTI_RT_DL[RT].T1;
   while ((p1->IDENTIFICATIVO)!=(p->SORGENTE)) p1=p1->NEXT_SORG;
   p1->PRIMO_MOMENTO+=ritardo;
   p1->SECONDO_MOMENTO+=pow(ritardo,2);
   normalizza_delay_ON_OFF_DL[RT]+=1;

   if (ritardo>=DELAY_ON_OFF_DL[RT].MAX) DELAY_ON_OFF_DL[RT].MAX=ritardo;
   if (ritardo<= DELAY_ON_OFF_DL[RT].MIN) DELAY_ON_OFF_DL[RT].MIN=ritardo;

   APPOGGIO_PORTATA_DL[RT].ON_OFF+=1;
   }
  else 
    {
     if (p->TIPO_TRAFFICO==2)
     {
      p2=VETTORE_SORGENTI_RT_DL[RT].T2;
      while ((p2->IDENTIFICATIVO)!=(p->SORGENTE)) p2=p2->NEXT_SORG;
      p2->PRIMO_MOMENTO+=ritardo;
      p2->SECONDO_MOMENTO+=pow(ritardo,2);
      normalizza_delay_CBR_DL[RT]+=1;
      
      if (ritardo>=DELAY_CBR_DL[RT].MAX) DELAY_CBR_DL[RT].MAX=ritardo;
      if (ritardo<= DELAY_CBR_DL[RT].MIN) DELAY_CBR_DL[RT].MIN=ritardo;

      APPOGGIO_PORTATA_DL[RT].CBR+=1;
      
     }
    }
  p=p->NEXT_MACPDU;
  APPOGGIO_PORTATA_DL[RT].GB+=1;
}

 // CALCOLO LE STATISTICHE RILEVANTI PER LA CLASSE BE

 if (OVERFLOW_BE_HAPPENED_DL[RT]==1) hyst_riempimento_BE_DL[RT][CAPIENZA_BUFFER+1]+=1;
 else 
	 if (OVERFLOW_BE_HAPPENED_DL[RT]==0) hyst_riempimento_BE_DL[RT][numero_BE]+=1;

 // ISTOGRAMMA DEI RITARDI DELLE MAC PDU PER TUTTO IL TRAFFICO IP* AL RT
 // DIFFERENZA NS TRAFFICO BE RISPETTO A DELLUOMO

 while (q!=NULL)
   {
    ritardo=t-q->T_GEN;
    
    ritardo_in_TS=(int)floor(ritardo/DURATA_TS_DL);
    if (ritardo_in_TS >=MAX_RITARDO_TS_DL) hyst_delay_BE_DL[RT][MAX_RITARDO_TS_DL]+=1;
    else hyst_delay_BE_DL[RT][ritardo_in_TS]+=1;
    normalizza_delay_BE_DL[RT]+=1;

   p3=VETTORE_SORGENTI_RT_DL[RT].T3;
   while ((p3->IDENTIFICATIVO)!=(q->SORGENTE)) p3=p3->NEXT_SORG;
   p3->PRIMO_MOMENTO+=ritardo;
   p3->SECONDO_MOMENTO+=pow(ritardo,2);

   if (ritardo>=DELAY_BE_DL[RT].MAX) DELAY_BE_DL[RT].MAX=ritardo;
   if (ritardo<= DELAY_BE_DL[RT].MIN) DELAY_BE_DL[RT].MIN=ritardo;
   
   APPOGGIO_PORTATA_DL[RT].BE+=1;
   q=q->NEXT_MACPDU;
 
   }

 return;
}


void CALCOLA_STATISTICHE_BASE_TRAMA_DL()
{
int i;

for (i=0;i<NRT;i++) 
{
    hyst_portata_ON_OFF_DL[i][APPOGGIO_PORTATA_DL[i].ON_OFF]+=1; 
    hyst_portata_CBR_DL[i][APPOGGIO_PORTATA_DL[i].CBR]+=1; //Dovrebbe venire un DIRAC
    hyst_portata_GB_DL[i][APPOGGIO_PORTATA_DL[i].GB]+=1;
    hyst_portata_BE_DL[i][APPOGGIO_PORTATA_DL[i].BE]+=1;
        
}
return;
}


// CALCOLA STIME DEI RITARDI MEDI E DELLE VARIANZE IN BASE AL TEMPO ASSOLUTO E
// AL CAMPO "T_GEN" DELLE MAC PDU.
// QUESTA PROCEDURA VIENE CHIAMATA AD OGNI TS E AGGIORNA LE STATISTICHE.

 void CALCOLA_STATISTICHE_BASE_TS_UL(double t,int RT,BUFFER p_GB,BUFFER q_BE,int numero_GB,int numero_BE)
{
 double ritardo=0;
 int ritardo_in_TS=0;

 // CALCOLO LE STATISTICHE PER LA CLASSE GB

BUFFER p=p_GB;
BUFFER q=q_BE;

pTIPO_1 p1;
pTIPO_2 p2;
pTIPO_3 p3;

if (numero_GB>CAPIENZA_BUFFER)
 hyst_riempimento_GB_UL[RT][CAPIENZA_BUFFER+1]+=1;

else
 hyst_riempimento_GB_UL[RT][numero_GB]+=1;


while (p!=NULL)
{
 ritardo=t-(p->T_GEN);
 
  if (p->TIPO_TRAFFICO==1)
   {
   p1=VETTORE_SORGENTI_RT_UL[RT].T1;

   while ((p1->IDENTIFICATIVO)!=(p->SORGENTE))
   
    p1=p1->NEXT_SORG;
   
   p1->PRIMO_MOMENTO+=ritardo;
   
   p1->SECONDO_MOMENTO+=pow(ritardo,2);
   
   normalizza_delay_ON_OFF_UL[RT]+=1;
      
   if (ritardo>=DELAY_ON_OFF_UL[RT].MAX) DELAY_ON_OFF_UL[RT].MAX=ritardo;
   
      if (ritardo<= DELAY_ON_OFF_UL[RT].MIN) DELAY_ON_OFF_UL[RT].MIN=ritardo;
   

   APPOGGIO_PORTATA_UL[RT].ON_OFF+=1;
   }
  else 
    {
     if (p->TIPO_TRAFFICO==2)
     {
      p2=VETTORE_SORGENTI_RT_UL[RT].T2;
   
      while ((p2->IDENTIFICATIVO)!=(p->SORGENTE))
      
       p2=p2->NEXT_SORG;
      
      p2->PRIMO_MOMENTO+=ritardo;
      p2->SECONDO_MOMENTO+=pow(ritardo,2);
      normalizza_delay_CBR_UL[RT]+=1;
            
      if (ritardo>=DELAY_CBR_UL[RT].MAX) DELAY_CBR_UL[RT].MAX=ritardo;
      if (ritardo<= DELAY_CBR_UL[RT].MIN) DELAY_CBR_UL[RT].MIN=ritardo;

      APPOGGIO_PORTATA_UL[RT].CBR+=1;
    
     }
    }
  p=p->NEXT_MACPDU;
  APPOGGIO_PORTATA_UL[RT].GB+=1;

}

 // CALCOLO LE STATISTICHE RILEVANTI PER LA CLASSE BE

 if (OVERFLOW_BE_HAPPENED_UL[RT]==1)
   hyst_riempimento_BE_UL[RT][CAPIENZA_BUFFER+1]+=1;
   
 else 
	 if (OVERFLOW_BE_HAPPENED_UL[RT]==0)
           hyst_riempimento_BE_UL[RT][numero_BE]+=1;
             
         

 // ISTOGRAMMA DEI RITARDI DELLE MAC PDU PER TUTTO IL TRAFFICO IP AL RT
 // DIFFERENZA NS TRAFFICO BE RISPETTO A DELLUOMO

 while (q!=NULL)
   {
    ritardo=t-q->T_GEN;
    
    ritardo_in_TS=(int)floor(ritardo/DURATA_TS_UL);
   
    if (ritardo_in_TS >=MAX_RITARDO_TS_UL) hyst_delay_BE_UL[RT][MAX_RITARDO_TS_UL]+=1;
    else hyst_delay_BE_UL[RT][ritardo_in_TS]+=1;
    normalizza_delay_BE_UL[RT]+=1;
   

   p3=VETTORE_SORGENTI_RT_UL[RT].T3;
 
   while ((p3->IDENTIFICATIVO)!=(q->SORGENTE))
   
    p3=p3->NEXT_SORG;
   
   p3->PRIMO_MOMENTO+=ritardo;
   
   p3->SECONDO_MOMENTO+=pow(ritardo,2);

   if (ritardo>=DELAY_BE_UL[RT].MAX) DELAY_BE_UL[RT].MAX=ritardo;
   if (ritardo<= DELAY_BE_UL[RT].MIN) DELAY_BE_UL[RT].MIN=ritardo;

   APPOGGIO_PORTATA_UL[RT].BE+=1;
   q=q->NEXT_MACPDU;
   
 }
 return;
}




void CALCOLA_STATISTICHE_BASE_TRAMA_UL()
{
  int i;
 
   for (i=0;i<NRT;i++) 
     {
	hyst_portata_ON_OFF_UL[i][APPOGGIO_PORTATA_UL[i].ON_OFF]+=1; 
	hyst_portata_CBR_UL[i][APPOGGIO_PORTATA_UL[i].CBR]+=1; 
        hyst_portata_GB_UL[i][APPOGGIO_PORTATA_UL[i].GB]+=1;
        hyst_portata_BE_UL[i][APPOGGIO_PORTATA_UL[i].BE]+=1;
        
     }
 return;
}





//SVUOTA I BUFFER UNA VOLTA CHE LE MAC_PDU SONO STATE TRASMESSE
int TRASMISSIONE_IN_DL(double tempo,int time_slot,FILE *risultati)
{
 int RT;
 int trasmessi_GB;
 int trasmessi_BE;
 int numero_GB=0;
 int numero_BE=0;
 

 int numero_elementi_coda_GB,numero_elementi_coda_BE;

BUFFER p_GB=NULL,q_BE=NULL;

 for (RT=0;RT<NRT;RT++)
 {
  trasmessi_GB=TRASMISSIONE_DL[RT][time_slot].GB;
  numero_elementi_coda_GB=NUMERO_ELEMENTI_CODA(CODE_GB_RN[RT]);
  macpdu_trasm_GB_DL+=trasmessi_GB;
 
    //C' uno sfasamento tra la trama e la matrice dei codici
    //printf("\nNumero elementi presenti in coda GB  al RT %d sono %d \n",RT+1,numero_elementi_coda_GB);
    
  //Numero GB  il numero di elementi presenti in coda,trasmessi GB  il numero di elementi da togliere dalla coda
   p_GB=ACCORCIA_LISTA(&CODE_GB_RN[RT],trasmessi_GB,&numero_GB);
    
  trasmessi_BE=TRASMISSIONE_DL[RT][time_slot].BE;
  numero_elementi_coda_BE=NUMERO_ELEMENTI_CODA(CODE_BE_RN[RT]);
  macpdu_trasm_BE_DL+=trasmessi_BE;
  
  
 //Numero BE  il numero di elementi presenti in coda,trasmessi Be  il numero di elementi da togliere dalla coda
  q_BE=ACCORCIA_LISTA(&CODE_BE_RN[RT],trasmessi_BE,&numero_BE);
  LUNGHEZZA_CODE_BE_DL[RT]=numero_BE;
  
 //ENTRAMBE LE CHIAMATE AD ACCORCIA_LISTA RESTITUISCONO LA PARTE DI BUFFER CHE VIENE TRASMESSA NEL TS CORRENTE
 
 if (((cont_trame+1)>=INIZIO_ANALISI_DL)&&((cont_trame+1)<=FINE_ANALISI_DL))
  CALCOLA_STATISTICHE_BASE_TS_DL(tempo,RT,p_GB,q_BE,numero_GB,numero_BE);
  
  LIBERA_LISTA(p_GB);
  LIBERA_LISTA(q_BE);

 }

return (0);
}



//SVUOTA I BUFFER UNA VOLTA CHE LE MAC_PDU SONO STATE TRASMESSE
int TRASMISSIONE_IN_UL(double tempo,int time_slot)
{
 int RT;
 int trasmessi_GB;
 int trasmessi_BE;
 int numero_GB=0;
 int numero_BE=0;

BUFFER p_GB=NULL, q_BE=NULL;

 for (RT=0;RT<NRT;RT++)
 {
  trasmessi_GB=TRASMISSIONE_UL[RT][time_slot].GB;
  trasmessi_BE=TRASMISSIONE_UL[RT][time_slot].BE;
  macpdu_trasm_GB_UL+=trasmessi_GB;
  macpdu_trasm_BE_UL+=trasmessi_BE;
 
  p_GB=ACCORCIA_LISTA(&CODE_GB_RT[RT],trasmessi_GB,&numero_GB);
  q_BE=ACCORCIA_LISTA(&CODE_BE_RT[RT],trasmessi_BE,&numero_BE);
 
   LUNGHEZZA_CODE_BE_UL[RT]=numero_BE;
  //ENTRAMBE LE CHIAMATE RESTITUISCONO LA PARTE DI BUFFER CHE VIENE TRASMESSA
  // NEL TS CORRENTE
    
 if (((cont_trame+1)>=INIZIO_ANALISI_UL)&&((cont_trame+1)<=FINE_ANALISI_UL))
  {
  CALCOLA_STATISTICHE_BASE_TS_UL(tempo,RT,p_GB,q_BE,numero_GB,numero_BE);
  } 
  LIBERA_LISTA(p_GB);
  LIBERA_LISTA(q_BE);
  
 }

return (0);
}



// DEALLOCAZIONE DELLA MEMORIA OCCUPATA DAL VETTORE DELLE SORGENTI DELL'UPLINK
void dealloca_sorgenti_RT_UL()
{
pTIPO_1 pt1_A,pt1_B;
pTIPO_2 pt2_A,pt2_B;
pTIPO_3 pt3_A,pt3_B;
int j;
for (j=0;j<NRT;j++)
    {
    pt1_A=VETTORE_SORGENTI_RT_UL[j].T1;
    pt1_B=pt1_A;
    pt2_A=VETTORE_SORGENTI_RT_UL[j].T2;
    pt2_B=pt2_A;
    pt3_A=VETTORE_SORGENTI_RT_UL[j].T3;
    pt3_B=pt3_A;
    while (pt1_A!=NULL)
          {
          pt1_B=pt1_A->NEXT_SORG;
          free(pt1_A);
          pt1_A=pt1_B;
          }
    VETTORE_SORGENTI_RT_UL[j].T1=NULL;
    while (pt2_A!=NULL)
          {
          pt2_B=pt2_A->NEXT_SORG;
          free(pt2_A);
          pt2_A=pt2_B;
          }
    VETTORE_SORGENTI_RT_UL[j].T2=NULL;
    while (pt3_A!=NULL)
          {
          pt3_B=pt3_A->NEXT_SORG;
          free(pt3_A);
          pt3_A=pt3_B;
          }
    VETTORE_SORGENTI_RT_UL[j].T3=NULL;
    }
return;
}



// DEALLOCAZIONE DELLA MEMORIA OCCUPATA DAL VETTORE DELLE SORGENTI DEL DOWNLINK
void dealloca_sorgenti_RT_DL()
{
pTIPO_1 pt1_A,pt1_B;
pTIPO_2 pt2_A,pt2_B;
pTIPO_3 pt3_A,pt3_B;
int j;
for (j=0;j<NRT;j++)
    {
    pt1_A=VETTORE_SORGENTI_RT_DL[j].T1;
    pt1_B=pt1_A;
    pt2_A=VETTORE_SORGENTI_RT_DL[j].T2;
    pt2_B=pt2_A;
    pt3_A=VETTORE_SORGENTI_RT_DL[j].T3;
    pt3_B=pt3_A;
    while (pt1_A!=NULL)
          {
          pt1_B=pt1_A->NEXT_SORG;
          free(pt1_A);
          pt1_A=pt1_B;
          }
    VETTORE_SORGENTI_RT_DL[j].T1=NULL;
    while (pt2_A!=NULL)
          {
          pt2_B=pt2_A->NEXT_SORG;
          free(pt2_A);
          pt2_A=pt2_B;
          }
    VETTORE_SORGENTI_RT_DL[j].T2=NULL;
    while (pt3_A!=NULL)
          {
          pt3_B=pt3_A->NEXT_SORG;
          free(pt3_A);
          pt3_A=pt3_B;
          }
    VETTORE_SORGENTI_RT_DL[j].T3=NULL;
    }
return;
}

void PRESENTAZIONE()
{
char car;
printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
printf("****************************************************************\n\n\n");
printf("        S I M U L A T O R E   M A C  v1.0 DOWNLINK-UPLINK\n\n");
printf("     PRIN 2000: SISTEMI OFDM CON APPLICAZIONI ALLE RETI WLAN\n\n");
printf(" UNITA' DI ROMA 1 - UNIVERSITA' DEGLI STUDI DI ROMA \"LA SAPIENZA\"\n\n");
printf("                          Programmatori\n");
printf("               ING.GUERINO GIANCOLA - kubika@libero.it\n");
printf("             ANTONELLA DE LUCA - antonellad@infinito.it\n");
printf("                 FRANCESCO PASSI - f.passi@libero.it\n");
printf("                   ANDREA VITALI - anvit@libero.it\n\n\n");
printf("****************************************************************\n\n\n");
printf("\n                    premi INVIO per cominciare\n\n\n");
//PER USARE TELNET e SSH NON CI DEVONO ESSERE INTERAZIONI UTENTE-MACCHINA.
car=getchar();


return;
}



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// INIZIO DEL MAIN
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
   
int main()
{
  FILE  *risultati_UL;
      if ((risultati_UL=fopen("risultati_UL.dat","w"))==NULL)
      {
      puts("\nImpossibile aprire il FILE risultati_UL\n");
      exit(1);
      }
    
  FILE  *risultati_DL;
      if ((risultati_DL=fopen("risultati_DL.dat","w"))==NULL)
      {
      puts("\nImpossibile aprire il FILE risultati_DL\n");
      exit(1);
      }
    
  FILE *MAT_CODICI;
      
      if ((MAT_CODICI=fopen("matricecodici.dat","w"))==NULL)
      {
      puts("\nImpossibile aprire il FILE MAT_CODICI\n");
      exit(1);
      } 


    //VARIABILI VARIE
   
    int ausil_1=0,ausil_2=0;
    int i=0,j=0,OFF=0,NexT=0;   
    int continua_ul,control_ul,continua_dl,control_dl;
    int inutile_ul,inutile_dl;                        // variabili per i cicli
    int temp_ul,temp1_ul,temp2_ul; 
    int temp_dl,temp1_dl,temp2_dl;           // variabili di appoggio intere
    char ctemp_ul,ctemp_dl;
    double MIN=1000000,MAX=0;
	//VARIABILI PER CALCOLARE I RITARDI E VARIABILI AUSILIARIE
    double t=0,t_UL=(4*DURATA_TS_DL),t_DL=0;
	//CONTATORI DEI TEMPI - DANNO IL VALORE IN SECONDI
    int k=0;
	//contatore per la stampa finale
 
    int m,n;
    int	contatore_TS_in_UL=0;
    int	contatore_TS_in_DL=NTS_DL-2;
    int aus_dl=0; //CONTA I TS IN DL PARTENDO DA ZERO
    pTIPO_1 p1;
    pTIPO_2 p2;
    pTIPO_3 p3;
    
    double varianza_ul,varianza_DL;
    int pincopallo_ul=0,pincopallo_dl=0;
    
    INIZIO_ROUND_ROBIN_GB_UL=1;
    INIZIO_ROUND_ROBIN_BE_UL=1;
    INIZIO_ROUND_ROBIN_GB_DL=1;
    INIZIO_ROUND_ROBIN_BE_DL=1;
        
        
    //SERVE PER INIZIALIZZARE LA FUNZIONE RANDOM
   srand((unsigned int)time(NULL));
   
   
   PRESENTAZIONE();
   
    // INIZIALIZZIAMO I VETTORI CHE RACCOLGONO LE SORGENTI
    printf("************ INIZIALIZZAZIONI***********\n");
    

    // INIZIALIZZIAMO I VETTORI CHE RACCOLGONO LE SORGENTI
    inizializza_SORGENTI_DL();
    inizializza_SORGENTI_UL();
    
    inizializza_CONTATORI();
    // PRESUPPONE CHE I FILE GIA' ESISTANO
    CREA_MATRICI_SORGENTI_DL();
    CREA_MATRICI_SORGENTI_UL();
    
    inizializza_percentuali();
    inizializza_VETTORI_BANDE();


    /////////////////////////////
    // INSERIMENTO DELLE SORGENTI AL RADIO NODE
    //
    // Procedura analoga alla precedente, se non che in questo caso l'indicatore
    // del radio terminal va inteso come IL RADIO TERMINAL CHE QUELLA SORGENTE
    // VUOLE RAGGIUNGERE
    //
 

    /////////////////////////////////////////////////////////////////////////////////////
    //	CODICE DA USARE SE VUOI INTRODURRE I RT E LE SOTTOCLASSI DA TASTIERA
    
    continua_dl=1;
    printf("\a\n**************INSERIMENTO DELLE SORGENTI AL RADIO NODE*************\n");    
while (continua_dl>0)
{
        printf("\nVUOI INSERIRE UNA SORGENTE AL RADIO NODE? [S/N]");
        ctemp_dl=getchar();
        getchar();
  if ((ctemp_dl=='S')||(ctemp_dl=='s'))
    {
        printf("\nVerso quale radio terminal la sorgente deve inviare i dati? [ 1 - %d ]\n",NRT);
        scanf("%d",&temp_dl);               // temp_dl memorizza IL TERMINALE
        if (temp_dl<=NRT)
        {
           control_dl=0;
           printf("\nDefinizione del tipo di sorgente\n1 - GB ON-OFF\n2 - GB CBR\n3 - BE");
           while (control_dl==0)
           {
           printf("\nDi che tipo e' questa sorgente? [1-2-3]\n");
           scanf("%d",&temp1_dl);           //temp1_dl memorizza il tipo di sorgente
           if ((temp1_dl!=1)&&(temp1_dl!=2)&&(temp1_dl!=3))
              {
              printf("*** ERRORE *** E' stata indicata una sorgente non valida");
              }
           else control_dl=1;
           }
           
           // Arrivati a questo punto sono stati indicati correttamente il terminale
           // e il tipo di sorgente
           
if (temp1_dl==1)           // sorgente di TIPO 1
{

    printf("\nScegli il tipo di sorgente ON-OFF:");
    printf("\n1 - DATI AD ALTA VELOCITA'");
    printf("\n2 - DATI A MEDIA VELOCITA'");
    printf("\n3 - DATI A BASSA VELOCITA'");
    printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
    scanf("%d",&temp2_dl);
    getchar();
    
   pincopallo_dl=inserisci_sorgente_TIPO1_RN(temp_dl,temp2_dl);         //SICURAMENTE LA % SIMMETRICA ALLOCATA AL RT E' 
   if (pincopallo_dl!=0)                                                //MINORE O UGUALE DI QUELLA ALLOCATA AL RN.
      	{
         pincopallo_ul=inserisci_simmetrica_TIPO1_DL(temp_dl,temp2_dl);
         	
         BANDA_TOTALE_DL+=pincopallo_dl;
         BANDA_TOTALE_UL+=pincopallo_ul;
         
         BANDA_RT_DL[temp_dl-1]+=pincopallo_dl;      
         BANDA_RT_UL[temp_dl-1]+=pincopallo_ul;      
        
printf("\nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100); 
 printf("\nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100);
         
        }
   else  
   {
   printf("\nsorry,non e' stata allocata la sorgente GB indicata per insufficienza di risorse disponibili");      
printf("\nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100);
printf("\nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100);

   }
}

else
{
   if(temp1_dl==2)     // sorgente di TIPO 2
   {
     printf("\nScegli il tipo di sorgente CBR:");
             printf("\n1 - VOCE");
             printf("\n2 - VIDEO ALTA VELOCITA'");
             printf("\n3 - VIDEO BASSA VELOCITA'");
             printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
             scanf("%d",&temp2_dl);
             getchar();
             
    pincopallo_dl=inserisci_sorgente_TIPO2_RN(temp_dl,temp2_dl);
    if (pincopallo_dl!=0)
       {	
         pincopallo_ul=inserisci_simmetrica_TIPO2_DL(temp_dl,temp2_dl);
         	
         BANDA_TOTALE_DL+=pincopallo_dl;
         BANDA_TOTALE_UL+=pincopallo_ul;
         
         BANDA_RT_DL[temp_dl-1]+=pincopallo_dl;
         BANDA_RT_UL[temp_dl-1]+=pincopallo_ul;
        
         
             
printf("\nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100);
 printf("\nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100);
 

        }
   else
      {
 printf("\nsorry,non e' stata allocata la sorgente GB indicata per insufficienza di risorse disponibili\n");
 printf("nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100);
 printf("\nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100);
      }

   }
   else             // sorgente di TIPO 3
   {
     printf("\nScegli il tipo di sorgente BE:");
             printf("\n1 - HTTP");
             printf("\n2 - FTP");
             printf("\n3 - SMTP");
             printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
             scanf("%d",&temp2_dl);
             getchar();
    inserisci_sorgente_TIPO3_RN(temp_dl,temp2_dl);
    inserisci_simmetrica_TIPO3_DL(temp_dl,temp2_dl);
   }
 }

           // verifica esistenza nuova sorgente
           printf("\nALTRA SORGENTE? [S/N]");
           ctemp_dl=getchar();
           getchar();
           if ((ctemp_dl!='S')&&(ctemp_dl!='s')) continua_dl = 0;
           else printf("\n\n\nNUOVA SORGENTE\n--------------");
 }
        else printf("*** ERRORE *** Ci sono al massimo %d terminali!! ",NRT);
}

 else 
 {
  continua_dl=0;
  ausil_1=1;
 } 
} 

    //////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////
    




    ///////////////////////////////
    // INSERIMENTO DELLE SORGENTI AI RADIO TERMINALS
    //
    // Attenzione!! Per il momento le sorgenti sono tutte presenti
    // sin dall'inizio della simulazione e non terminano di generare
    // il traffico per tutta la durata della simulazione stessa.
    //
    // Attenzione!! Per il momento introduciamo un set di sorgenti dello stesso
    // tipo. In particolare, in questa versione, introduciamo 'NCLASSI' categorie di
    // sorgenti ogni TIPO
    //
    // Attenzione!! Per il momento il numero e le tipologie delle sorgenti
    // presenti ai radio terminals e al radio node sono completamente scorrelat
    
       
    continua_ul=1;
    printf("\a\n************INSERIMENTO DELLE SORGENTI AL RADIO TERMINAL***********\n");
    
while (continua_ul>0)
 {
        printf("\nVUOI INSERIRE UNA SORGENTE AI RADIO TERMINAL? [S/N]");
        ctemp_ul=getchar();
        getchar();
        
 if ((ctemp_ul=='S')||(ctemp_ul=='s'))
  {
           
        printf("\nQuale radio terminal deve inviare i dati? [ 1 - %d ]\n",NRT);
        scanf("%d",&temp_ul);               // temp_ul memorizza IL TERMINALE
        if (temp_ul<=NRT)
        {
           control_ul=0;
           printf("\nDefinizione del tipo di sorgente\n1 - GB ON-OFF\n2 - GB CBR\n3 - BE");
           while (control_ul==0)
           {
           printf("\nDi che tipo e' questa sorgente? [1-2-3]\n");
           scanf("%d",&temp1_ul);           //temp1_ul memorizza il tipo di sorgente
           if ((temp1_ul!=1)&&(temp1_ul!=2)&&(temp1_ul!=3))
              {
              printf("*** ERRORE *** E' stata indicata una sorgente non valida");
              }
           else control_ul=1;
           }
           
           // Arrivati a questo punto sono stati indicati correttamente il terminale
           // e il tipo di sorgente
           
if (temp1_ul==1)           // sorgente di TIPO 1
{

    printf("\nScegli il tipo di sorgente ON-OFF:");
    printf("\n1 - DATI AD ALTA VELOCITA'");
    printf("\n2 - DATI A MEDIA VELOCITA'");
    printf("\n3 - DATI A BASSA VELOCITA'");
    printf("\nsottoclasse della  sorgente? [ 1 - %d ]   ",NCLASSI);
    scanf("%d",&temp2_ul);
    getchar();
                                                                //AVENDO ALLOCATO GIA' LE SORGENTI AL RN,PRIMA DI
    pincopallo_ul=calcola_banda_TIPO1_RT(temp_ul,temp2_ul);     //POTERNE ALLOCARE UNA IN UL,DEVO VERIFICARE CHE 
    pincopallo_dl=calcola_banda_simm_TIPO1_RT(temp_ul,temp2_ul);//LA SIMMETRICA NON CREI INCOMPATIBILITA',QUINDI  
                                                                //CALCOLO LE BANDE SENZA ALLOCARE LE SORGENTI.
          
   if (((BANDA_TOTALE_UL+pincopallo_ul)<CAPACITA_ALLOCABILE_GB_UL)&&((BANDA_TOTALE_DL+pincopallo_dl)<CAPACITA_ALLOCABILE_GB_DL))
      	{	
        pincopallo_ul=inserisci_sorgente_TIPO1_RT(temp_ul,temp2_ul);  //SE POSSO,ALLOCO LE SORGENTI.
        pincopallo_dl=inserisci_simmetrica_TIPO1_UL(temp_ul,temp2_ul);
        
        BANDA_TOTALE_UL+=pincopallo_ul;
        BANDA_TOTALE_DL+=pincopallo_dl;
        
        BANDA_RT_DL[temp_ul-1]+=pincopallo_dl;
        BANDA_RT_UL[temp_ul-1]+=pincopallo_ul;
        
        
printf("\nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100);
printf("\nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100);
 
        }
   else 
   {
   printf("\nsorry,non e' stata allocata la sorgente GB indicata per insufficienza di risorse disponibili");      
 printf("\nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100); 
printf("\nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100);
 
   }
}

else
{
   if(temp1_ul==2)     // sorgente di TIPO 2
   {
     printf("\nScegli il tipo di sorgente CBR:");
             printf("\n1 - VOCE");
             printf("\n2 - VIDEO ALTA VELOCITA'");
             printf("\n3 - VIDEO BASSA VELOCITA'");
             printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
             scanf("%d",&temp2_ul);
             getchar();
             
    pincopallo_ul=calcola_banda_TIPO2_RT(temp_ul,temp2_ul);         
    pincopallo_dl=calcola_banda_simm_TIPO2_RT(temp_ul,temp2_ul);           
   
   if (((BANDA_TOTALE_UL+pincopallo_ul)<CAPACITA_ALLOCABILE_GB_UL)&&((BANDA_TOTALE_DL+pincopallo_dl)<CAPACITA_ALLOCABILE_GB_DL))      
    
      	{
        pincopallo_ul=inserisci_sorgente_TIPO2_RT(temp_ul,temp2_ul);
        pincopallo_dl=inserisci_simmetrica_TIPO2_UL(temp_ul,temp2_ul);	
        
        BANDA_TOTALE_UL+=pincopallo_ul;
        BANDA_TOTALE_DL+=pincopallo_dl;
        
        BANDA_RT_DL[temp_ul-1]+=pincopallo_dl;
        BANDA_RT_UL[temp_ul-1]+=pincopallo_ul;
        
        
        
        
printf("\nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100);
printf("\nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100);

        }
   else
      {
printf("\nsorry,non e' stata allocata la sorgente GB indicata per insufficienza di risorse disponibili\n");
printf("nRISORSE OCCUPATE CLASSE GB IN UPLINK: %2.2lf%\n",(BANDA_TOTALE_UL/(double)CAPACITA_ALLOCABILE_GB_UL)*100);
printf("\nRISORSE OCCUPATE CLASSE GB IN DOWNLINK: %2.2lf%\n",(BANDA_TOTALE_DL/(double)CAPACITA_ALLOCABILE_GB_DL)*100);
      }

   }
   else             // sorgente di TIPO 3
   {
     printf("\nScegli il tipo di sorgente BE:");
             printf("\n1 - HTTP");
             printf("\n2 - FTP");
             printf("\n3 - SMTP");
             printf("\nsottoclasse della sorgente? [ 1 - %d ]   ",NCLASSI);
             scanf("%d",&temp2_ul);
             getchar();
    inserisci_sorgente_TIPO3_RT(temp_ul,temp2_ul);
    inserisci_simmetrica_TIPO3_UL(temp_ul,temp2_ul);
    
   }
 }

           // verifica esistenza nuova sorgente
           printf("\nALTRA SORGENTE? [S/N]");
           ctemp_ul=getchar();
           getchar();
           if ((ctemp_ul!='S')&&(ctemp_ul!='s')) continua_ul = 0;
           else printf("\n\n\nNUOVA SORGENTE\n--------------");
 }
        else printf("*** ERRORE *** Ci sono al massimo %d terminali!! ",NRT);
        
}
else
 {
 ausil_2=1;
  continua_ul=0;
 } 
}

if ((ausil_1==1)&&(ausil_2==1))
{
 printf("\n*****NON ESISTONO SORGENTI,NESSUNA TRASMISSIONE VERRA' INIZIATA!!!******\n");
 exit(1);

}

    //////////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////////



/*
//**************************************************************************************************************
//**************************************************************************************************************
//**************************************************************************************************************
    
    //////////////////////////////////////////////////////////////////////////////////////////////////   
    ///       CODICE DA USARE SE VUOI INSERIRE I RT E LE SOTTOCLASSI DA FILE (TELNET E SSH)        ///    ////////////////////////////////////////////////////////////////////////////////////////////////// 
     FILE  *terminali_DL;
      if ((terminali_DL=fopen("terminali_DL.txt","r"))==NULL)
      {
      puts("\nImpossibile aprire il FILE terminali_DL\n");
      exit(1);
      }
    //da questo file vengono letti i RT, il tipo di sorgente e la sottoclasse scelti

    char fine_dl='0';	
    

    printf("\a\nINSERIMENTO DELLE SORGENTI AL RADIO NODE\n");

    while (fine_dl!=EOF)
    {
        fscanf(terminali_DL,"%d",&temp_dl);               // temp_dl ora memorizza IL TERMINALE
        
        fscanf(terminali_DL,"%d",&temp1_dl);           //temp1_dl ora memorizza il tipo di sorgente

        fscanf(terminali_DL,"%d",&temp2_dl);  
           // Arrivati a questo punto sono stati indicati correttamente il terminale
           // e il tipo di sorgente

           if (temp1_dl==1)           // sorgente di TIPO 1
           {
           inserisci_sorgente_TIPO1_RN(temp_dl,temp2_dl);
           inserisci_simmetrica_TIPO1_DL(temp_dl,temp2_dl);
           
		   printf("\nRT= %d, Sottoclasse= %d\n",temp_dl,temp2_dl);
		   scanf("%d",&inutile_dl);
           }
           else
           {
                  if(temp1_dl==2)         // sorgente di TIPO 2
                  {
                  inserisci_sorgente_TIPO2_RN(temp_dl,temp2_dl);
                  inserisci_simmetrica_TIPO2_DL(temp_dl,temp2_dl);
                  printf("\nRT= %d, Sottoclasse= %d\n",temp_dl,temp2_dl);
		          scanf("%d",&inutile_dl);

                  }
                  else                 // sorgente di TIPO 3
                  {
                  inserisci_sorgente_TIPO3_RN(temp_dl,temp2_dl);
                  inserisci_simmetrica_TIPO3_DL(temp_dl,temp2_dl);
                  printf("\nRT= %d, Sottoclasse= %d\n",temp_dl,temp2_dl);
		          scanf("%d",&inutile_dl);
                  }
           }

           // verifica esistenza nuova sorgente
            fine_dl=fgetc(terminali_DL);

    }
   
   
   
   
    
     FILE  *terminali_UL;
      if ((terminali_UL=fopen("terminali_UL.txt","r"))==NULL)
      {
      puts("\nImpossibile aprire il FILE terminali_UL\n");
      exit(1);
      }
    //da questo file vengono letti i RT, il tipo di sorgente e la sottoclasse scelti

    char fine_ul='0';	

    printf("\a\nINSERIMENTO DELLE SORGENTI AL RADIO NODE\n");

    while (fine_ul!=EOF)
    {
        fscanf(terminali_UL,"%d",&temp_ul);               // temp_ul ora memorizza IL TERMINALE
        
        fscanf(terminali_UL,"%d",&temp1_ul);           //temp1_ul ora memorizza il tipo di sorgente

        fscanf(terminali_UL,"%d",&temp2_ul);  
           // Arrivati a questo punto sono stati indicati correttamente il terminale
           // e il tipo di sorgente

           if (temp1_ul==1)           // sorgente di TIPO 1
           {
           inserisci_sorgente_TIPO1_RT(temp_ul,temp2_ul);
           inserisci_simmetrica_TIPO1_UL(temp_dl,temp2_dl);
		   printf("\nRT= %d, Sottoclasse= %d\n",temp_ul,temp2_ul);
		  // scanf("%d",&inutile_ul);
           }
           else
           {
                  if(temp1_ul==2)         // sorgente di TIPO 2
                  {
                  inserisci_sorgente_TIPO2_RT(temp_ul,temp2_ul);
                  inserisci_simmetrica_TIPO2_UL(temp_dl,temp2_dl);
                  printf("\nRT= %d, Sottoclasse= %d\n",temp_ul,temp2_ul);
		          //scanf("%d",&inutile_ul);

                  }
                  else                 // sorgente di TIPO 3
                  {
                  inserisci_sorgente_TIPO3_RT(temp_ul,temp2_ul);
                  inserisci_simmetrica_TIPO3_UL(temp_dl,temp2_dl);
                  printf("\nRT= %d, Sottoclasse= %d\n",temp_ul,temp2_ul);
		          //scanf("%d",&inutile_ul);
                  }
           }

           // verifica esistenza nuova sorgente
            fine_ul=fgetc(terminali_UL);

    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////

*/
//**************************************************************************************************************
//**************************************************************************************************************
//**************************************************************************************************************
  
  
   
    CONTA_SORGENTI_RN();
    CONTA_SORGENTI_RT();

    inizializzazione_MATRICE_CODICI();
    inizializzazione_PAGING_CHANNEL();
    inizializzazione_STATO_CODE_AL_RN();
    
    inizializza_VETTORE_TS();
    inizializza_REQUEST_CHANNEL_UL();
    inizializza_ALLOCATIONAL_CHANNEL();
    

    //INIZIALIZZIAMO LE CODE AI BUFFER
    inizializza_BUFFER();
    	
    //INIZIALIZZO LE STATISTICHE
    inizializza_STATISTICHE_DL();
    inizializza_STATISTICHE_UL();

    
    inizializza_ASSEGNAZIONE_DL();
    inizializza_ASSEGNAZIONE_UL();
     
    inizializza_TRASMISSIONE_DL();
    inizializza_TRASMISSIONE_UL();
    
    inizializza_BANDE_TOTALI_MAC();




    //INIZIALIZZAZIONE DEL TRAFFICO
    
    for (i=0;i<NRT;i++)
    {
    // SORGENTI ON-OFF        
        inizializza_sorgenti_TIPO1_DL(i);
        inizializza_sorgenti_TIPO1_UL(i);
        
    // SORGENTI CBR   
        inizializza_sorgenti_TIPO2_DL(i);
        inizializza_sorgenti_TIPO2_UL(i);
    // SORGENTI BE    
        inizializza_sorgenti_TIPO3_DL(i);
        inizializza_sorgenti_TIPO3_UL(i);
	}


    printf("\n*** FINE INIZIALIZZAZIONI *** \n");




	// GESTISCO IL DOWNLINK 

	while (cont_trame<MAX_NUM_TRAME)
	{
      printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
      printf("\n\n    LA TRAMA IN DOWNLINK E' LA NUMERO %d\n\n",cont_trame+1);
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	
  	
      while (aus_dl<NTS_DL)
        {
          if (aus_dl==0) 
      //ORA GESTISCO IL PRIMO TS IN DOWNLINK
           {              
	         for (i=0;i<NRT;i++) 
			 {
           // La generazione del traffico va avanti finche' non finisce il TS corrente:
           // tempo al momento indica l'inizio del TS corrente
              GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
              GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
              GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);      
			 }
		
	 fprintf(MAT_CODICI,"\nTRAMA %d\n\n",cont_trame+1);

	 for (i=0;i<NRT;i++) ELABORA_STATO_CODE_DL(i,CODE_GB_RN[i],CODE_BE_RN[i],contatore_TS_in_DL);
    
	 ASSEGNA_RISORSE_DL(MAT_CODICI);   
               
         riempi_MATRICE_CODICI();
	

         //Calcolo dei ritardi con annessi e connessi
         TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);
    
	 t_DL+=DURATA_TS_DL;
 
	 contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
      
      
        }
                 
  //GESTISCO IL TS DELLA RIALLOCAZIONE IN DL
       else
        {
         if(aus_dl==RIALLOCAZIONE_DL-1)

          {
           inizializza_TRASMISSIONE_DL();
	       costruisci_TRASMISSIONE_DL();
	       //printf("\nHo costruito la trasmissione DL\n");

             // stampo la trasmissione_DL
	      fprintf(MAT_CODICI,"\n\n\n");	
	      for (m=0;m<NRT;m++)
	       {
		fprintf(MAT_CODICI,"\n");
		for (n=0;n<NTS_DL;n++)
                fprintf(MAT_CODICI," %d & %d   ",TRASMISSIONE_DL[m][n].GB,TRASMISSIONE_DL[m][n].BE);
                fprintf(MAT_CODICI,"\n");
	       }
	       fprintf(MAT_CODICI,"******************************************************************");
  
 
 
               for (i=0;i<NRT;i++) 
                {
                 // La generazione del traffico va avanti finche' non finisce il TS corrente:
                 // tempo al momento indica l'inizio del TS corrente
                 GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);  
                }

               // Calcolo dei ritardi con annessi e connessi
               TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

               t_DL+=DURATA_TS_DL;
               
               contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
               
            }
               
          else
 //ORA GESTISCO IL GENERICO TS IN DL
           {
            for (i=0;i<NRT;i++) 
            {     
             GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);
    
            }
           // Calcolo dei ritardi con annessi e connessi
           TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

           t_DL+=DURATA_TS_DL; 
            
           contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
           
          }
          
        }
        
      aus_dl+=1;
      
    }
 
	  
// ORA GESTIAMO L'UPLINK 

      printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
      printf("\n\n    LA TRAMA IN UPLINK E' LA NUMERO %d\n\n",cont_trame+1);
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	
      while(contatore_TS_in_UL<NTS_UL)
      {
        if(contatore_TS_in_UL==0)
             
          {
          //GESTISCO IL REQUEST
                   
            for (i=0;i<NRT;i++) 
	         {
        
               GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);
               
              }
               
            for (i=0;i<NRT;i++)            ELABORA_STATO_CODE_UL(i,CODE_GB_RT[i],CODE_BE_RT[i]);
              
            ASSEGNA_RISORSE_UL();
                                          
            riempi_VETTORE_TS();
                 
         
            TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
     
            t_UL+=DURATA_TS_UL;
                      
            contatore_TS_in_UL+=1;
			
           }
                 
         else
           {
             if((contatore_TS_in_UL==(2*RIALLOCAZIONE_UL))&&(cont_trame>0))
              {
               //GESTISCO IL TS DELLA RIALLOCAZIONE PER L'UPLINK
                     
               inizializza_TRASMISSIONE_UL();
	           costruisci_TRASMISSIONE_UL();
                    
               for (i=0;i<NRT;i++) 
			   {      	   
  
               // La generazione del traffico va avanti finche' non finisce il TS corrente:
               //tempo al  momento indica l'inizio del TS corrente
               
                   GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                   GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                   GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                }
               
               TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
               t_UL+=DURATA_TS_UL;
               contatore_TS_in_UL+=1;
               
              }
                  
             else
               {
                //GESTISCO IL GENERICO TS IN UPLINK
                    
                for (i=0;i<NRT;i++) 
				 {      
               
                   GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                   GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                   GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                  }
               
                TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
				t_UL+=DURATA_TS_UL;
                     
                contatore_TS_in_UL+=1;
			
                }
              }
                
                
             }
           







/*
//////////////////////////////////////////////////////////////////////////////////////////
////////// /SECONDO MAIN (BISOGNA PORRE IL CONTATORE DEI TS IN UL PARI A 0) //////////////
//////////////////////////////////////////////////////////////////////////////////////////

	while (cont_trame<MAX_NUM_TRAME)
	{
          printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
          printf("\n\n    LA TRAMA E' LA NUMERO %d\n\n",cont_trame+1);
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	
  	
          while (aus_dl<NTS_DL)
            {
             if (aus_dl==0)
              {
               //GESTISCO I PRIMI "RAPP" TS IN UL E IL PRIMO TS IN DL
               
               while(contatore_TS_in_UL<RAPP)
                {
                 if(contatore_TS_in_UL==0)
                 
                  {
                     //GESTISCO IL PRIMO TS IN UPLINK
                   
                     for (i=0;i<NRT;i++) 
	             {
        
                       GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);
               
                      }
               
                      for (i=0;i<NRT;i++)            ELABORA_STATO_CODE_UL(i,CODE_GB_RT[i],CODE_BE_RT[i]);
              
                      ASSEGNA_RISORSE_UL();
                                          
                      riempi_VETTORE_TS();
                 
         
                      TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
     
                      t_UL+=DURATA_TS_UL;
                      
                      contatore_TS_in_UL+=1;
                  }
                 
                else
                 {
                   if(contatore_TS_in_UL==RIALLOCAZIONE_UL-1)
                    {
                     //GESTISCO IL TS DELLA RIALLOCAZIONE PER L'UPLINK
                     
                      inizializza_TRASMISSIONE_UL();
	              costruisci_TRASMISSIONE_UL();
                    
                      for (i=0;i<NRT;i++) 
		      {      	   
  
               // La generazione del traffico va avanti finche' non finisce il TS corrente:
               //t_UL al  momento indica l'inizio del TS corrente
               
                       GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                      }
               
                      TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
                      t_UL+=DURATA_TS_UL;
                      contatore_TS_in_UL+=1;
                  
                    }
                  
                  else
                   {
                    //GESTISCO IL GENERICO TS IN UPLINK
                    
                    for (i=0;i<NRT;i++) 
		     {      
               
                      GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                      GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                      GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                      }
               
                     TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
                     t_UL+=DURATA_TS_UL;
                     
                     contatore_TS_in_UL+=1;
                   }
                 }
                
                
             }
           
           //ORA GESTISCO IL PRIMO TS IN DOWNLINK
           
	for (i=0;i<NRT;i++) 
	 {
           // La generazione del traffico va avanti finche' non finisce il TS corrente:
           // t_DL al momento indica l'inizio del TS corrente
          GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
          GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
          GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);      
         }
		
	 fprintf(MAT_CODICI,"\nTRAMA %d\n\n",cont_trame+1);

	 for (i=0;i<NRT;i++) ELABORA_STATO_CODE_DL(i,CODE_GB_RN[i],CODE_BE_RN[i],contatore_TS_in_DL);
    
	 ASSEGNA_RISORSE_DL(MAT_CODICI);   
               
         riempi_MATRICE_CODICI();
	

         //Calcolo dei ritardi con annessi e connessi
         TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);
    
	 t_DL+=DURATA_TS_DL;
 
	 contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
      
      
        }
                 
 
       else
        {
         if(aus_dl==RIALLOCAZIONE_DL-1)
          {
           //GESTISCO I GENERICI "RAPP" TS IN UL E IL TS DELLA RIALLOCAZIONE IN DL
           
           while(contatore_TS_in_UL<(RIALLOCAZIONE_DL*RAPP))
            {
             //GESTISCO IL GENERICO TS IN UL
                            
             for (i=0;i<NRT;i++) 
              {    
              
               GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

               }
               
               TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
               t_UL+=DURATA_TS_UL;
               
               contatore_TS_in_UL+=1;
           
             }
            
             //GESTISCO IL TS DELLA RIALLOCAZIONE IN DL
          
               inizializza_TRASMISSIONE_DL();
	       costruisci_TRASMISSIONE_DL();
	       //printf("\nHo costruito la trasmissione DL\n");

             // stampo la trasmissione_DL
	      fprintf(MAT_CODICI,"\n\n\n");	
	      for (m=0;m<NRT;m++)
	       {
		fprintf(MAT_CODICI,"\n");
		for (n=0;n<NTS_DL;n++)
                fprintf(MAT_CODICI," %d & %d   ",TRASMISSIONE_DL[m][n].GB,TRASMISSIONE_DL[m][n].BE);
                fprintf(MAT_CODICI,"\n");
	       }
	       fprintf(MAT_CODICI,"******************************************************************");
  
 
 
               for (i=0;i<NRT;i++) 
                {
                 // La generazione del traffico va avanti finche' non finisce il TS corrente:
                 // t_DL al momento indica l'inizio del TS corrente
                 GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);  
                }

               // Calcolo dei ritardi con annessi e connessi
               TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

               t_DL+=DURATA_TS_DL;
               
               contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
               
            }
               
          else
           {
            //GESTISCO I GENERICI "RAPP" TS IN UL ED IL GENERICO TS IN DL
            
            while(contatore_TS_in_UL<((aus_dl+1)*RAPP))
             {
              //GESTISCO IL GENERICO TS IN UL   
            
              for (i=0;i<NRT;i++) 
               {    
              
                GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                }
               
               TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
               t_UL+=DURATA_TS_UL; 
                             
               contatore_TS_in_UL+=1;
               
             }
           
           //ORA GESTISCO IL GENERICO TS IN DL
           
            for (i=0;i<NRT;i++) 
            {     
             GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);
    
            }
           // Calcolo dei ritardi con annessi e connessi
           TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

           t_DL+=DURATA_TS_DL; 
            
           contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
           
          }
          
        }
        
      aus_dl+=1;
      
    }
    
*/    
/*    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////// MAIN CHIARO DAL PUNTO DI VISTA LOGICO ///////////////////////////
//////////////////////////////// SEGUE LA FIGURA 6.8 DELLA TESI //////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

	while (cont_trame<MAX_NUM_TRAME)
	{
          printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
          printf("\n\n    LA TRAMA E' LA NUMERO %d\n\n",cont_trame+1);
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	  printf("\n*****************************************\n\n");
	


  	
          while (aus_dl<NTS_DL)
            {
             controllo=0;
             
             if (aus_dl==0)
              {
               controllo=1;
               //GESTISCO I PRIMI "RAPP" TS IN UL E IL PRIMO TS IN DL
               
               while(contatore_TS_in_UL<RAPP)
                {
                    //GESTISCO IL GENERICO TS IN UPLINK
                    
                    for (i=0;i<NRT;i++) 
		     {      
               
                      GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                      GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                      GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                      }
               
                     TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
                     t_UL+=DURATA_TS_UL;
                     
                     contatore_TS_in_UL+=1;
                 
                 }
                
                
             
           
           //ORA GESTISCO IL PRIMO TS IN DOWNLINK
           
	for (i=0;i<NRT;i++) 
	 {
           // La generazione del traffico va avanti finche' non finisce il TS corrente:
           // t_DL al momento indica l'inizio del TS corrente
          GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
          GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
          GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);      
         }
		
	 fprintf(MAT_CODICI,"\nTRAMA %d\n\n",cont_trame+1);

	 for (i=0;i<NRT;i++) ELABORA_STATO_CODE_DL(i,CODE_GB_RN[i],CODE_BE_RN[i],contatore_TS_in_DL);
    
	 ASSEGNA_RISORSE_DL(MAT_CODICI);   
               
         riempi_MATRICE_CODICI();
	

         //Calcolo dei ritardi con annessi e connessi
         TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);
    
	 t_DL+=DURATA_TS_DL;
 
	 contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
      
      
        }
                 
 
              
         if((aus_dl==RIALLOCAZIONE_DL-1)&&(cont_trame==0))
          {
           controllo=1;
           //GESTISCO I GENERICI "RAPP" TS IN UL E IL TS DELLA RIALLOCAZIONE IN DL
           
           while(contatore_TS_in_UL<(RIALLOCAZIONE_DL*RAPP))
            {
             //GESTISCO IL GENERICO TS IN UL
                            
             for (i=0;i<NRT;i++) 
              {    
              
               GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

               }
               
               TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
               t_UL+=DURATA_TS_UL;
               
               contatore_TS_in_UL+=1;
           
             }
            
             //GESTISCO IL TS DELLA RIALLOCAZIONE IN DL
          
               inizializza_TRASMISSIONE_DL();
	       costruisci_TRASMISSIONE_DL();
	       //printf("\nHo costruito la trasmissione DL\n");

             // stampo la trasmissione_DL
	      fprintf(MAT_CODICI,"\n\n\n");	
	      for (m=0;m<NRT;m++)
	       {
		fprintf(MAT_CODICI,"\n");
		for (n=0;n<NTS_DL;n++)
                fprintf(MAT_CODICI," %d & %d   ",TRASMISSIONE_DL[m][n].GB,TRASMISSIONE_DL[m][n].BE);
                fprintf(MAT_CODICI,"\n");
	       }
	       fprintf(MAT_CODICI,"******************************************************************");
  
 
 
               for (i=0;i<NRT;i++) 
                {
                 // La generazione del traffico va avanti finche' non finisce il TS corrente:
                 // t_DL al momento indica l'inizio del TS corrente
                 GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);  
                }

               // Calcolo dei ritardi con annessi e connessi
               TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

               t_DL+=DURATA_TS_DL;
               
               contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
               
           } 
            
            
              
         if((aus_dl==RIALLOCAZIONE_DL-1)&&(cont_trame!=0))
          { 
            controllo=1;
            
           //GESTISCO I GENERICI "RAPP-1" TS IN UL, IL TS DELLA RIALLOCAZIONE IN UL E QUELLO IN DL
           
           while(contatore_TS_in_UL<(RIALLOCAZIONE_DL*RAPP))
            {
            
            if(contatore_TS_in_UL==RIALLOCAZIONE_UL)
                    {
                     //GESTISCO IL TS DELLA RIALLOCAZIONE PER L'UPLINK
                     
                      inizializza_TRASMISSIONE_UL();
	              costruisci_TRASMISSIONE_UL();
                    
                      for (i=0;i<NRT;i++) 
		      {      	   
  
               // La generazione del traffico va avanti finche' non finisce il TS corrente:
               //t_UL al  momento indica l'inizio del TS corrente
               
                       GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                      }
               
                      TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
                      t_UL+=DURATA_TS_UL;
                      contatore_TS_in_UL+=1;
                  
                    }
                  
                    
             //GESTISCO IL GENERICO TS IN UL
                            
             for (i=0;i<NRT;i++) 
              {    
              
               GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

               GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

               }
               
               TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
               t_UL+=DURATA_TS_UL;
               
               contatore_TS_in_UL+=1;
           
             }
            
             //GESTISCO IL TS DELLA RIALLOCAZIONE IN DL
          
               inizializza_TRASMISSIONE_DL();
	       costruisci_TRASMISSIONE_DL();
	       //printf("\nHo costruito la trasmissione DL\n");

             // stampo la trasmissione_DL
	      fprintf(MAT_CODICI,"\n\n\n");	
	      for (m=0;m<NRT;m++)
	       {
		fprintf(MAT_CODICI,"\n");
		for (n=0;n<NTS_DL;n++)
                fprintf(MAT_CODICI," %d & %d   ",TRASMISSIONE_DL[m][n].GB,TRASMISSIONE_DL[m][n].BE);
                fprintf(MAT_CODICI,"\n");
	       }
	       fprintf(MAT_CODICI,"******************************************************************");
  
 
 
               for (i=0;i<NRT;i++) 
                {
                 // La generazione del traffico va avanti finche' non finisce il TS corrente:
                 // t_DL al momento indica l'inizio del TS corrente
                 GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
                 GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);  
                }

               // Calcolo dei ritardi con annessi e connessi
               TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

               t_DL+=DURATA_TS_DL;
               
               contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
               
           }  


                     
            
      if(aus_dl==(2*RIALLOCAZIONE_DL)-2)
      
          {
            controllo=1;

           while(contatore_TS_in_UL<((2*RIALLOCAZIONE_DL-1)*RAPP))
           
            {
                if(contatore_TS_in_UL==(2*RIALLOCAZIONE_UL)) //GESTISCO IL REQUEST
                 
                  {
                   
                     for (i=0;i<NRT;i++) 
	             {
        
                       GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                       GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);
               
                      }
               
                      for (i=0;i<NRT;i++)            ELABORA_STATO_CODE_UL(i,CODE_GB_RT[i],CODE_BE_RT[i]);
              
                      ASSEGNA_RISORSE_UL();
                                          
                      riempi_VETTORE_TS();
                 
         
                      TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
     
                      t_UL+=DURATA_TS_UL;
                      
                      contatore_TS_in_UL+=1;
                  }
                 
                //GESTISCO IL GENERICO TS IN UPLINK
               
              
                    for (i=0;i<NRT;i++) 
		     {      
               
                      GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                      GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                      GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                      }
               
                     TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
                     t_UL+=DURATA_TS_UL;
                     
                     contatore_TS_in_UL+=1;
       
               
             }// FINE WHILE
             
             //ORA GESTISCO IL GENERICO TS IN DOWNLINK
             
                
            for (i=0;i<NRT;i++) 
            {     
             GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);
    
            }
           // Calcolo dei ritardi con annessi e connessi
           TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

           t_DL+=DURATA_TS_DL; 
            
           contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
 
        } //FINE IF
         
            
               
          if(controllo==0)
           {
            //GESTISCO I GENERICI "RAPP" TS IN UL ED IL GENERICO TS IN DL
            
            while(contatore_TS_in_UL<((aus_dl+1)*RAPP))
             {
              //GESTISCO IL GENERICO TS IN UL   
            
              for (i=0;i<NRT;i++) 
               {    
              
                GENERA_TRAFFICO_TIPO1_UL(i,t_UL+DURATA_TS_UL);

                GENERA_TRAFFICO_TIPO2_UL(i,t_UL+DURATA_TS_UL);

                GENERA_TRAFFICO_TIPO3_UL(i,t_UL+DURATA_TS_UL);

                }
               
               TRASMISSIONE_IN_UL(t_UL,contatore_TS_in_UL);
              
               t_UL+=DURATA_TS_UL; 
                             
               contatore_TS_in_UL+=1;
               
             }
           
           //ORA GESTISCO IL GENERICO TS IN DL
           
            for (i=0;i<NRT;i++) 
            {     
             GENERA_TRAFFICO_TIPO1_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO2_DL(i,t_DL+DURATA_TS_DL);
             GENERA_TRAFFICO_TIPO3_DL(i,t_DL+DURATA_TS_DL);
    
            }
           // Calcolo dei ritardi con annessi e connessi
           TRASMISSIONE_IN_DL(t_DL,contatore_TS_in_DL,risultati_DL);

           t_DL+=DURATA_TS_DL; 
            
           contatore_TS_in_DL=(contatore_TS_in_DL+1)%NTS_DL;
           
          }
          
        
        
      aus_dl+=1;
      
    }
    
*/






    

//CALCOLIAMO LE STATISTICHE BASE TRAMA PER L'UPLINK
          
  if (((cont_trame+1)>=INIZIO_ANALISI_UL)&&((cont_trame+1)<=FINE_ANALISI_UL)) 
  
                  CALCOLA_STATISTICHE_BASE_TRAMA_UL();

          
   //RIINIZIALIZZO IL TUTTO PER LA NUOVA TRAMA
       inizializza_VETTORE_TS();
       inizializza_REQUEST_CHANNEL_UL();
       inizializza_ALLOCATIONAL_CHANNEL();
       inizializza_ASSEGNAZIONE_UL();
   
       for (i=0;i<NRT;i++) 
		
	{
		APPOGGIO_PORTATA_UL[i].ON_OFF=0; 
		APPOGGIO_PORTATA_UL[i].CBR=0; 	
                APPOGGIO_PORTATA_UL[i].GB=0;
                APPOGGIO_PORTATA_UL[i].BE=0;
	}
          


//CALCOLIAMO LE STATISTICHE BASE TRAMA PER IL DOWNLINK 
    if (((cont_trame+1)>=INIZIO_ANALISI_DL)&&((cont_trame+1)<=FINE_ANALISI_DL)) 
        
                CALCOLA_STATISTICHE_BASE_TRAMA_DL();
    
 
    //RIINIZIALIZZO IL TUTTO PER LA NUOVA TRAMA
    inizializza_ASSEGNAZIONE_DL();
    inizializzazione_MATRICE_CODICI();
    inizializzazione_STATO_CODE_AL_RN();

    for (i=0;i<NRT;i++) 
		
	{
        APPOGGIO_PORTATA_DL[i].ON_OFF=0; 
        APPOGGIO_PORTATA_DL[i].CBR=0; 	
        APPOGGIO_PORTATA_DL[i].GB=0;
        APPOGGIO_PORTATA_DL[i].BE=0;
	}
         
 
    
  cont_trame+=1;
  
  aus_dl=0;
  
  contatore_TS_in_UL=0;
 }          
    
fclose(MAT_CODICI);

  

//*******************************************************************************
//***********************              UPLINK           *************************
//*******************************************************************************

fprintf(risultati_UL,"\n\n*****TRASMESSE GB IN UPLINK*****\n\n");

fprintf(risultati_UL,"%d ",macpdu_trasm_GB_UL);
fprintf(risultati_UL,"\n\n");

fprintf(risultati_UL,"\n\n*****TRASMESSE BE IN UPLINK*****\n\n");

fprintf(risultati_UL,"%d ",macpdu_trasm_BE_UL);
fprintf(risultati_UL,"\n\n");




fprintf(risultati_UL,"\n\n*****HYST RT-TS IN UPLINK*****\n\n");
for(i=0;i<NRT;i++)
 {
  for(j=0;j<NTS_UL;j++) 
  fprintf(risultati_UL,"%d ",hyst_RT_TS[i][j]);        
  fprintf(risultati_UL,"\n\n");
 }    

fprintf(risultati_UL,"\nTRAME CONSIDERATE NELLE STATISTICHE:  # %d -  # %d\n\n",(int)INIZIO_ANALISI_UL,(int)FINE_ANALISI_UL);

fprintf(risultati_UL,"\n****DELAY ON-OFF MAX IN UPLINK****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_UL[i].T1)!=NULL)
  {
  if  (DELAY_ON_OFF_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_UL,"%lf  ",DELAY_ON_OFF_UL[i].MAX);
  }
else fprintf(risultati_UL," ---- "); 
}
fprintf(risultati_UL,"\n\n");

fprintf(risultati_UL,"\n****DELAY ON-OFF MIN IN UPLINK****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_UL[i].T1)!=NULL) 
{
  if  (DELAY_ON_OFF_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_UL,"%lf  ",DELAY_ON_OFF_UL[i].MIN);
  }
else fprintf(risultati_UL," ---- "); 
}
fprintf(risultati_UL,"\n\n");

fprintf(risultati_UL,"\n****DELAY CBR MAX IN UPLINK****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_UL[i].T2)!=NULL) 

  {
  if  (DELAY_CBR_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_UL,"%lf  ",DELAY_CBR_UL[i].MAX);
  }

else fprintf(risultati_UL," ---- "); 
}
fprintf(risultati_UL,"\n\n");

fprintf(risultati_UL,"\n****DELAY CBR MIN IN UPLINK****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_UL[i].T2)!=NULL) 
{
  if  (DELAY_CBR_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_UL,"%lf  ",DELAY_CBR_UL[i].MIN);
  }
else fprintf(risultati_UL," ---- "); 
}

fprintf(risultati_UL,"\n\n");

fprintf(risultati_UL,"\n****DELAY BE MAX IN UPLINK****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_UL[i].T3)!=NULL)  
{
  if  (DELAY_BE_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_UL,"%lf  ",DELAY_BE_UL[i].MAX);
  }
else fprintf(risultati_UL," ---- "); 
}
fprintf(risultati_UL,"\n\n");

fprintf(risultati_UL,"\n****DELAY BE MIN IN UPLINK****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_UL[i].T3)!=NULL)
{
  if  (DELAY_BE_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_UL,"%lf  ",DELAY_BE_UL[i].MIN);
  }
else fprintf(risultati_UL," ---- "); 
} 
fprintf(risultati_UL,"\n\n");


for (i=0;i<NRT;i++)
{
 p1=VETTORE_SORGENTI_RT_UL[i].T1;
 if (p1!=NULL)
 {
 fprintf(risultati_UL,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO ON-OFF IN UPLINK AL RT %d \n",i+1);
 } 
 if (normalizza_delay_ON_OFF_UL[i]==0) normalizza_delay_ON_OFF_UL[i]=1;
 while (p1!=NULL)
 {
  p1->PRIMO_MOMENTO=(p1->PRIMO_MOMENTO)/(normalizza_delay_ON_OFF_UL[i]);
  p1->SECONDO_MOMENTO=(p1->SECONDO_MOMENTO)/(normalizza_delay_ON_OFF_UL[i]);
  varianza_ul=(p1->SECONDO_MOMENTO)-(pow(p1->PRIMO_MOMENTO,2));
   if  (DELAY_ON_OFF_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_UL,"( %12.11lf , %12.11lf  )",p1->PRIMO_MOMENTO,varianza_ul);
    
  p1=p1->NEXT_SORG;
 }
 fprintf(risultati_UL,"\n\n");
 
p2=VETTORE_SORGENTI_RT_UL[i].T2;
if (p2!=NULL)
{
fprintf(risultati_UL,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO CBR IN UPLINK AL RT %d \n",i+1); 
}
if (normalizza_delay_CBR_UL[i]==0) normalizza_delay_CBR_UL[i]=1;

 while (p2!=NULL)
 {
  p2->PRIMO_MOMENTO=(p2->PRIMO_MOMENTO)/(normalizza_delay_CBR_UL[i]);
  p2->SECONDO_MOMENTO=(p2->SECONDO_MOMENTO)/(normalizza_delay_CBR_UL[i]);
  varianza_ul=(p2->SECONDO_MOMENTO)-(pow(p2->PRIMO_MOMENTO,2));
 
   if  (DELAY_CBR_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
  else fprintf(risultati_UL,"( %12.11lf , %12.11lf )  ",p2->PRIMO_MOMENTO,varianza_ul);
  
  p2=p2->NEXT_SORG;
 }
 fprintf(risultati_UL,"\n\n");


p3=VETTORE_SORGENTI_RT_UL[i].T3;
if (p3!=NULL)
{
fprintf(risultati_UL,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO BE IN UPLINK AL RT %d \n",i+1);
}
if (normalizza_delay_BE_UL[i]==0) normalizza_delay_BE_UL[i]=1;

 while (p3!=NULL)
 {
  p3->PRIMO_MOMENTO=(p3->PRIMO_MOMENTO)/(normalizza_delay_BE_UL[i]);
  p3->SECONDO_MOMENTO=(p3->SECONDO_MOMENTO)/(normalizza_delay_BE_UL[i]);
  varianza_ul=(p3->SECONDO_MOMENTO)-(pow(p3->PRIMO_MOMENTO,2));
  
  
  if  (DELAY_BE_UL[i].MAX==0) fprintf(risultati_UL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else fprintf(risultati_UL,"( %12.11lf , %12.11lf )  ",p3->PRIMO_MOMENTO,varianza_ul);
  
  
  p3=p3->NEXT_SORG;
 }
 fprintf(risultati_UL,"\n\n");
 fprintf(risultati_UL,"\n\n");

}

fprintf(risultati_UL,"\n\n****HYST DELAY BE IN UPLINK(la scala dei valori e' 10E-3)****\n");
for (i=0;i<MAX_RITARDO_TS_UL+1;i++)
{
	for (j=0;j<NRT;j++) 
        {
        if (normalizza_delay_BE_UL[j]==0) normalizza_delay_BE_UL[j]=1;
        fprintf(risultati_UL,"%lf  ",(hyst_delay_BE_UL[j][i]/(double)(normalizza_delay_BE_UL[j]))*1000);
        }
	fprintf(risultati_UL,"\n");
        
}
fprintf(risultati_UL,"\n\n");


//NEGLI ISTOGRAMMI VA CONSIDERATO CHE ORA LE STATISTICHE SONO RELATIVE SOLO A UNA FINESTRA
fprintf(risultati_UL,"\nPREPARATORIO A HYST PORTATA ON OFF BASE TRAMA IN UPLINK\n");
fprintf(risultati_UL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1));
for (i=0;i<NRT;i++)
{
	inutile_ul=0;
	for (j=0;j<NTS_UL-SEGNALAZIONE_UL+1;j++) inutile_ul+=hyst_portata_ON_OFF_UL[i][j];
	fprintf(risultati_UL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_ul);
}

fprintf(risultati_UL,"\n****HYST PORTATA ON OFF SU BASE TRAMA IN UPLINK(la scala dei valori e' 10E-3)****\n");
for (i=0;i<NTS_UL-SEGNALAZIONE_UL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_UL,"%lf  ",(hyst_portata_ON_OFF_UL[j][i]/(double)(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1))*1000);
  fprintf(risultati_UL,"\n");
}


fprintf(risultati_UL,"\nPREPARATORIO A HYST PORTATA CBR BASE TRAMA IN UPLINK\n");
fprintf(risultati_UL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1));
for (i=0;i<NRT;i++)
{
	inutile_ul=0;
	for (j=0;j<NTS_UL-SEGNALAZIONE_UL+1;j++) inutile_ul+=hyst_portata_CBR_UL[i][j];
	fprintf(risultati_UL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_ul);
}
fprintf(risultati_UL,"\n\n****HYST PORTATA CBR SU BASE TRAMA IN UPLINK(la scala dei valori e' 10E-3)****\n");
for (i=0;i<NTS_UL-SEGNALAZIONE_UL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_UL,"%lf  ",(hyst_portata_CBR_UL[j][i]/(double)(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1))*1000);
  fprintf(risultati_UL,"\n");
}


fprintf(risultati_UL,"\nPREPARATORIO A HYST PORTATA GB BASE TRAMA IN UPLINK\n");
fprintf(risultati_UL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1));
for (i=0;i<NRT;i++)
{
	inutile_ul=0;
	for (j=0;j<NTS_UL-SEGNALAZIONE_UL+1;j++) inutile_ul+=hyst_portata_GB_UL[i][j];
	fprintf(risultati_UL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_ul);
}
fprintf(risultati_UL,"\n\n****HYST PORTATA GB SU BASE TRAMA (la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<NTS_UL-SEGNALAZIONE_UL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_UL,"%lf  ",(hyst_portata_GB_UL[j][i]/(double)(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1))*1000);
  fprintf(risultati_UL,"\n");
}

fprintf(risultati_UL,"\nPREPARATORIO A HYST PORTATA BE BASE TRAMA IN UPLINK\n");
fprintf(risultati_UL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1));
for (i=0;i<NRT;i++)
{
	inutile_ul=0;
	for (j=0;j<NTS_UL-SEGNALAZIONE_UL+1;j++) inutile_ul+=hyst_portata_BE_UL[i][j];
	fprintf(risultati_UL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_ul);
}
fprintf(risultati_UL,"\n\n****HYST PORTATA BE SU BASE TRAMA IN UPLINK(la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<NTS_UL-SEGNALAZIONE_UL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_UL,"%lf  ",(hyst_portata_BE_UL[j][i]/(double)(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1))*1000);
  fprintf(risultati_UL,"\n");
}



//NEGLI ISTOGRAMMI VA CONSIDERATO CHE ORA LE STATISTICHE SONO RELATIVE SOLO A UNA FINESTRA

fprintf(risultati_UL,"\nPREPARATORIO A HYST RIEMPIMENTO BUFFER GB BASE TS IN UPLINK\n");
fprintf(risultati_UL,"\nLa somma dovrebbe essere pari al numero di TS presenti nelle trame analizzate= %d\n",int(NTS_UL*(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1)));
for (i=0;i<NRT;i++)
{
	inutile_ul=0;
	for (j=0;j<CAPIENZA_BUFFER+2;j++) inutile_ul+=hyst_riempimento_GB_UL[i][j];
	fprintf(risultati_UL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_ul);
}

fprintf(risultati_UL,"\n****HYST RIEMPIMENTO BUFFER GB SU BASE TS IN UPLINK(la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<CAPIENZA_BUFFER+2;i++)
{
for (j=0;j<NRT;j++)
 fprintf(risultati_UL,"%lf  ",(hyst_riempimento_GB_UL[j][i]/(double)(NTS_UL*(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1)))*1000);
 
 fprintf(risultati_UL,"\n");
}


fprintf(risultati_UL,"\nPREPARATORIO A HYST RIEMPIMENTO BUFFER BE BASE TS IN UPLINK\n");
fprintf(risultati_UL,"\nLa somma dovrebbe essere pari al numero di TS presenti nelle trame analizzate= %d\n",int(NTS_UL*(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1)));
for (i=0;i<NRT;i++)
{
	inutile_ul=0;
	for (j=0;j<CAPIENZA_BUFFER+2;j++) inutile_ul+=hyst_riempimento_BE_UL[i][j];
	fprintf(risultati_UL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_ul);
}
fprintf(risultati_UL,"\n\n****HYST RIEMPIMENTO BUFFER BE SU BASE TS IN UPLINK(la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<CAPIENZA_BUFFER+2;i++)
{
for (j=0;j<NRT;j++) 
   
 fprintf(risultati_UL,"%lf ",(hyst_riempimento_BE_UL[j][i]/(double)(NTS_UL*(FINE_ANALISI_UL-INIZIO_ANALISI_UL+1)))*1000);
 
fprintf(risultati_UL,"\n");
}

fprintf(risultati_UL,"\n\n");

fclose(risultati_UL);
  




//*******************************************************************************
//***********************           DOWNLINK            *************************
//*******************************************************************************

fprintf(risultati_DL,"\n\n*****TRASMESSE GB*****\n\n");

fprintf(risultati_DL,"%d ",macpdu_trasm_GB_DL);
fprintf(risultati_DL,"\n\n");

fprintf(risultati_DL,"\n\n*****TRASMESSE BE*****\n\n");

fprintf(risultati_DL,"%d ",macpdu_trasm_BE_DL);
fprintf(risultati_DL,"\n\n");








fprintf(risultati_DL,"\nTRAME CONSIDERATE NELLE STATISTICHE:  # %d -  # %d\n\n",(int)INIZIO_ANALISI_DL,(int)FINE_ANALISI_DL);

fprintf(risultati_DL,"\n****DELAY ON-OFF MAX IN DOWNLINK****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_DL[i].T1)!=NULL)
  {
  if  (DELAY_ON_OFF_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_DL,"%lf  ",DELAY_ON_OFF_DL[i].MAX);
  }
else fprintf(risultati_DL," ---- "); 
}
fprintf(risultati_DL,"\n\n");

fprintf(risultati_DL,"\n****DELAY ON-OFF MIN IN DOWNLINK****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_DL[i].T1)!=NULL) 
{
  if  (DELAY_ON_OFF_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_DL,"%lf  ",DELAY_ON_OFF_DL[i].MIN);
  }
else fprintf(risultati_DL," ---- "); 
}
fprintf(risultati_DL,"\n\n");

fprintf(risultati_DL,"\n****DELAY CBR MAX IN DOWNLINK****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_DL[i].T2)!=NULL) 

  {
  if  (DELAY_CBR_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_DL,"%lf  ",DELAY_CBR_DL[i].MAX);
  }

else fprintf(risultati_DL," ---- "); 
}
fprintf(risultati_DL,"\n\n");

fprintf(risultati_DL,"\n****DELAY CBR MIN IN DOWNLINK****\n");
for (i=0;i<NRT;i++)
{
if ((VETTORE_SORGENTI_RT_DL[i].T2)!=NULL) 
{
  if  (DELAY_CBR_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_DL,"%lf  ",DELAY_CBR_DL[i].MIN);
  }
else fprintf(risultati_DL," ---- "); 
}

fprintf(risultati_DL,"\n\n");

fprintf(risultati_DL,"\n****DELAY BE MAX IN DOWNLINK****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_DL[i].T3)!=NULL)  
{
  if  (DELAY_BE_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_DL,"%lf  ",DELAY_BE_DL[i].MAX);
  }
else fprintf(risultati_DL," ---- "); 
}
fprintf(risultati_DL,"\n\n");

fprintf(risultati_DL,"\n****DELAY BE MIN IN DOWNLINK****\n");
for (i=0;i<NRT;i++) 
{
if ((VETTORE_SORGENTI_RT_DL[i].T3)!=NULL)
{
  if  (DELAY_BE_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_DL,"%lf  ",DELAY_BE_DL[i].MIN);
  }
else fprintf(risultati_DL," ---- "); 
} 
fprintf(risultati_DL,"\n\n");


for (i=0;i<NRT;i++)
{
 p1=VETTORE_SORGENTI_RT_DL[i].T1;
 if (p1!=NULL)
 {
 fprintf(risultati_DL,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO ON-OFF IN DOWNLINK AL RT %d \n",i+1);
 } 
 if (normalizza_delay_ON_OFF_DL[i]==0) normalizza_delay_ON_OFF_DL[i]=1;
 while (p1!=NULL)
 {
  p1->PRIMO_MOMENTO=(p1->PRIMO_MOMENTO)/(normalizza_delay_ON_OFF_DL[i]);
  p1->SECONDO_MOMENTO=(p1->SECONDO_MOMENTO)/(normalizza_delay_ON_OFF_DL[i]);
  varianza_DL=(p1->SECONDO_MOMENTO)-(pow(p1->PRIMO_MOMENTO,2));
 
   if  (DELAY_ON_OFF_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else  fprintf(risultati_DL,"( %12.11lf , %12.11lf  )",p1->PRIMO_MOMENTO,varianza_DL);
    
  p1=p1->NEXT_SORG;
 }
 fprintf(risultati_DL,"\n\n");
 
p2=VETTORE_SORGENTI_RT_DL[i].T2;
if (p2!=NULL)
{
fprintf(risultati_DL,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO CBR IN DOWNLINK AL RT %d \n",i+1); 
}
if (normalizza_delay_CBR_DL[i]==0) normalizza_delay_CBR_DL[i]=1;

 while (p2!=NULL)
 {
  p2->PRIMO_MOMENTO=(p2->PRIMO_MOMENTO)/(normalizza_delay_CBR_DL[i]);
  p2->SECONDO_MOMENTO=(p2->SECONDO_MOMENTO)/(normalizza_delay_CBR_DL[i]);
  varianza_DL=(p2->SECONDO_MOMENTO)-(pow(p2->PRIMO_MOMENTO,2));
  
  
  
  
  if  (DELAY_CBR_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
  else fprintf(risultati_DL,"( %12.11lf , %12.11lf )  ",p2->PRIMO_MOMENTO,varianza_DL);
  
  p2=p2->NEXT_SORG;
 }
 fprintf(risultati_DL,"\n\n");


p3=VETTORE_SORGENTI_RT_DL[i].T3;
if (p3!=NULL)
{
fprintf(risultati_DL,"\nRITARDO MEDIO E VARIANZA PER IL TRAFFICO BE IN DOWNLINK AL RT %d \n",i+1);
}
if (normalizza_delay_BE_DL[i]==0) normalizza_delay_BE_DL[i]=1;

 while (p3!=NULL)
 {
  p3->PRIMO_MOMENTO=(p3->PRIMO_MOMENTO)/(normalizza_delay_BE_DL[i]);
  p3->SECONDO_MOMENTO=(p3->SECONDO_MOMENTO)/(normalizza_delay_BE_DL[i]);
  varianza_DL=(p3->SECONDO_MOMENTO)-(pow(p3->PRIMO_MOMENTO,2));
  
  
  if  (DELAY_BE_DL[i].MAX==0) fprintf(risultati_DL," MAI GENERATO/TRASMESSO TRAFFICO "); 
    else fprintf(risultati_DL,"( %12.11lf , %12.11lf )  ",p3->PRIMO_MOMENTO,varianza_DL);
  
  
  p3=p3->NEXT_SORG;
 }
 fprintf(risultati_DL,"\n\n");
 fprintf(risultati_DL,"\n\n");

}

fprintf(risultati_DL,"\n\n****HYST DELAY BE IN DOWNLINK(la scala dei valori e' 10E-3)****\n");
for (i=0;i<MAX_RITARDO_TS_DL+1;i++)
{
	for (j=0;j<NRT;j++) 
        {
        if (normalizza_delay_BE_DL[j]==0) normalizza_delay_BE_DL[j]=1;
        fprintf(risultati_DL,"%lf  ",(hyst_delay_BE_DL[j][i]/(double)(normalizza_delay_BE_DL[j]))*1000);
        }
	fprintf(risultati_DL,"\n");
        
}
fprintf(risultati_DL,"\n\n");


//NEGLI ISTOGRAMMI VA CONSIDERATO CHE ORA LE STATISTICHE SONO RELATIVE SOLO A UNA FINESTRA
fprintf(risultati_DL,"\nPREPARATORIO A HYST PORTATA ON OFF BASE TRAMA IN DOWNLINK\n");
fprintf(risultati_DL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1));
for (i=0;i<NRT;i++)
{
	inutile_dl=0;
	for (j=0;j<NTS_DL*K-SEGNALAZIONE_DL+1;j++) inutile_dl+=hyst_portata_ON_OFF_DL[i][j];
	fprintf(risultati_DL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_dl);
}

fprintf(risultati_DL,"\n****HYST PORTATA ON OFF SU BASE TRAMA IN DOWNLINK(la scala dei valori e' 10E-3)****\n");
for (i=0;i<NTS_DL*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_DL,"%lf  ",(hyst_portata_ON_OFF_DL[j][i]/(double)(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1))*1000);
  fprintf(risultati_DL,"\n");
}


fprintf(risultati_DL,"\nPREPARATORIO A HYST PORTATA CBR BASE TRAMA IN DOWNLINK\n");
fprintf(risultati_DL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1));
for (i=0;i<NRT;i++)
{
	inutile_dl=0;
	for (j=0;j<NTS_DL*K-SEGNALAZIONE_DL+1;j++) inutile_dl+=hyst_portata_CBR_DL[i][j];
	fprintf(risultati_DL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_dl);
}
fprintf(risultati_DL,"\n\n****HYST PORTATA CBR SU BASE TRAMA IN DOWNLINK(la scala dei valori e' 10E-3)****\n");
for (i=0;i<NTS_DL*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_DL,"%lf  ",(hyst_portata_CBR_DL[j][i]/(double)(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1))*1000);
  fprintf(risultati_DL,"\n");
}


fprintf(risultati_DL,"\nPREPARATORIO A HYST PORTATA GB BASE TRAMA IN DOWNLINK\n");
fprintf(risultati_DL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1));
for (i=0;i<NRT;i++)
{
	inutile_dl=0;
	for (j=0;j<NTS_DL*K-SEGNALAZIONE_DL+1;j++) inutile_dl+=hyst_portata_GB_DL[i][j];
	fprintf(risultati_DL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_dl);
}
fprintf(risultati_DL,"\n\n****HYST PORTATA GB SU BASE TRAMA IN DOWNLINK(la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<NTS_DL*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_DL,"%lf  ",(hyst_portata_GB_DL[j][i]/(double)(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1))*1000);
  fprintf(risultati_DL,"\n");
}

fprintf(risultati_DL,"\nPREPARATORIO A HYST PORTATA BE BASE TRAMA IN DOWNLINK\n");
fprintf(risultati_DL,"\nLa somma dovrebbe essere pari al numero di trame analizzate %d\n",int(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1));
for (i=0;i<NRT;i++)
{
	inutile_dl=0;
	for (j=0;j<NTS_DL*K-SEGNALAZIONE_DL+1;j++) inutile_dl+=hyst_portata_BE_DL[i][j];
	fprintf(risultati_DL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_dl);
}
fprintf(risultati_DL,"\n\n****HYST PORTATA BE SU BASE TRAMA IN DOWNLINK(la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<NTS_DL*K-SEGNALAZIONE_DL+1;i++)
{
  for (j=0;j<NRT;j++) fprintf(risultati_DL,"%lf  ",(hyst_portata_BE_DL[j][i]/(double)(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1))*1000);
  fprintf(risultati_DL,"\n");
}


//CALCOLATI ALL'INTERNO DELLA riempi_MATRICE_CODICI
fprintf(risultati_DL,"\n\n****HYST CODICI PIU' PROBABILMENTE ASSEGNATI PER Tx GB AL DETERMINATO RT****\n");
for (i=0;i<K;i++)
{	
 for (j=0;j<NRT;j++)	
 {
 if (normalizza_COD_PROBABILE_GB[j]==0) normalizza_COD_PROBABILE_GB[j]=1;
 fprintf(risultati_DL,"%lf  ",hyst_CODICE_PROBABILE_GB[j][i]/(double)(normalizza_COD_PROBABILE_GB[j]));
 }
 fprintf(risultati_DL,"\n");
}
fprintf(risultati_DL,"\n");

fprintf(risultati_DL,"\n\n****HYST CODICI PIU' PROBABILMENTE ASSEGNATI PER Tx BE AL DETERMINATO RT****\n");
for (i=0;i<K;i++)
{ 	
 for (j=0;j<NRT;j++)
 {
 if (normalizza_COD_PROBABILE_BE[j]==0) normalizza_COD_PROBABILE_BE[j]=1;
 fprintf(risultati_DL,"%lf  ",hyst_CODICE_PROBABILE_BE[j][i]/(double)(normalizza_COD_PROBABILE_BE[j]));
 }
 fprintf(risultati_DL,"\n");
 
}
fprintf(risultati_DL,"\n\n");


//NEGLI ISTOGRAMMI VA CONSIDERATO CHE ORA LE STATISTICHE SONO RELATIVE SOLO A UNA FINESTRA

fprintf(risultati_DL,"\nPREPARATORIO A HYST RIEMPIMENTO BUFFER GB BASE TS IN DOWNLINK\n");
fprintf(risultati_DL,"\nLa somma dovrebbe essere pari al numero di TS presenti nelle trame analizzate= %d\n",int(NTS_DL*(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1)));
for (i=0;i<NRT;i++)
{
	inutile_dl=0;
	for (j=0;j<CAPIENZA_BUFFER+2;j++) inutile_dl+=hyst_riempimento_GB_DL[i][j];
	fprintf(risultati_DL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_dl);
}

fprintf(risultati_DL,"\n****HYST RIEMPIMENTO BUFFER GB SU BASE TS IN DOWNLINK(la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<CAPIENZA_BUFFER+2;i++)
{
for (j=0;j<NRT;j++)
 fprintf(risultati_DL,"%lf  ",(hyst_riempimento_GB_DL[j][i]/(double)(NTS_DL*(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1)))*1000);
 
 fprintf(risultati_DL,"\n");
}


fprintf(risultati_DL,"\nPREPARATORIO A HYST RIEMPIMENTO BUFFER BE BASE TS IN DOWNLINK\n");
fprintf(risultati_DL,"\nLa somma dovrebbe essere pari al numero di TS presenti nelle trame analizzate= %d\n",int(NTS_DL*(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1)));
for (i=0;i<NRT;i++)
{
	inutile_dl=0;
	for (j=0;j<CAPIENZA_BUFFER+2;j++) inutile_dl+=hyst_riempimento_BE_DL[i][j];
	fprintf(risultati_DL,"\nPer l'RT %d la somma e' %d\n",i+1,inutile_dl);
}
fprintf(risultati_DL,"\n\n****HYST RIEMPIMENTO BUFFER BE SU BASE TS IN DOWNLINK(la scala dei valori e' 10E-3)****\n\n");
for (i=0;i<CAPIENZA_BUFFER+2;i++)
{
for (j=0;j<NRT;j++)
 fprintf(risultati_DL,"%lf  ",(hyst_riempimento_BE_DL[j][i]/(double)(NTS_DL*(FINE_ANALISI_DL-INIZIO_ANALISI_DL+1)))*1000);
 
fprintf(risultati_DL,"\n");
}

fprintf(risultati_DL,"\n\n");

fclose(risultati_DL);





// DEALLOCAZIONE DELLE STRUTTURE CHE RACCOLGONO LE SORGENTI
    dealloca_sorgenti_RT_UL();
    dealloca_sorgenti_RT_DL();
    
	
        
        
	printf("\n\n********************* FINE SIMULAZIONE ***********************\n");

    return 0;
}

 

 
 
 
 
 
 
 
 
 
 
               
        
        
        
        
        
        
        
        
     

